package com.dlsm.controller;

import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.ExcelWriter;
import com.alibaba.excel.write.metadata.WriteSheet;
import com.alibaba.fastjson.JSONException;
import com.alibaba.fastjson.JSONObject;
import com.dlsm.model.Person;
import com.dlsm.model.vo.ActivityVO4;
import com.dlsm.model.vo.ActivityVO6;
import com.dlsm.model.vo.ActivityVO9;
import com.dlsm.utils.*;
import net.sf.json.JSONArray;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.ClassPathResource;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import org.xm.similarity.text.CosineSimilarity;
import org.xm.similarity.text.TextSimilarity;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.*;


@CrossOrigin(origins = "*", maxAge = 3600)
@Controller
@RequestMapping("/similarity")
public class SimilarityController {

    @Autowired
    private JdbcTemplate jdbcTemplate;

    @PostMapping({"/list"})//浏览器访问页面 list 文本相似度计算
    @ResponseBody
    public com.alibaba.fastjson.JSONArray list(HttpServletRequest req) throws IOException {

        net.sf.json.JSONObject dataOfJson = net.sf.json.JSONObject.fromObject(getRequestJsonObject(req).toString());
        String id = dataOfJson.getString("id");
        String content = dataOfJson.getString("keyword");

        JSONObject jsonObject = new JSONObject();
        jsonObject.put("id", id);
        jsonObject.put("keyword", content);


        JSONObject json2 = new JSONObject();
        com.alibaba.fastjson.JSONArray json3 = new com.alibaba.fastjson.JSONArray();

        JSONArray forecast0 = dataOfJson.getJSONArray("list");

        if(forecast0.size()>0)
        {


            for(int c=0;c<forecast0.size();c++)
            {
                net.sf.json.JSONObject result0=forecast0.getJSONObject(c);
                String lid = result0.getString("id");
                String compare = result0.getString("keyword");
                JSONObject json1 = new JSONObject();
                TextSimilarity cosSimilarity = new CosineSimilarity();
                double score1 = cosSimilarity.getSimilarity(content, compare);
                json1.put("id", lid);
                json1.put("score", score1);
                //json1.put("keyword", compare);
                json3.add(json1);
            }
        }

        json2.put("list",jsonArraySort(json3.toString()));

        com.alibaba.fastjson.JSONArray jsonArray = new com.alibaba.fastjson.JSONArray();
        jsonArray.add(jsonObject);
        jsonArray.add(json2);


        return jsonArray;//访问
    }


    /**
     * 6.信访事项反映内容分类统计表（三级通用）
     */
    @PostMapping("/classify")
    @ResponseBody
    public void classify(HttpServletResponse response, HttpServletRequest request, String startTime,String endTime,String compareBegTime,String compareEndTime,String createOrgID,String ccmID,String registerTypeID,String orgName,String contentClassifyID)  {

        SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");

        String dytime = formatter.format(new Date());

        if(StringUtils.isBlank(startTime))
        {
            startTime = "2022-01-01";
        }
        if(StringUtils.isBlank(endTime))
        {
            endTime = "2022-12-31";
        }
        if(StringUtils.isBlank(compareBegTime))
        {
            compareBegTime = "2021-01-01";
        }
        if(StringUtils.isBlank(compareEndTime))
        {
            compareEndTime = "2021-12-31";
        }
        if(StringUtils.isBlank(createOrgID))
        {
            createOrgID = "40";
        }
        if(StringUtils.isBlank(registerTypeID))
        {
            registerTypeID = "001,002,003,004";
        }
        if(StringUtils.isBlank(ccmID))
        {
            ccmID = "001|002|003|004|005";
        }
        else {
            ccmID = ccmID.replace(",","|");
        }

        String sql = "";

        sql+= "SELECT \n" ;
        sql+="(SELECT count(m.ccmID) FROM matter m where FIND_IN_SET(m.createOrgID,'"+createOrgID+"') and m.ccmID REGEXP '"+ccmID+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') <= '"+endTime+"' and m.ccmID = mat.ccmID) as xfsxsl,\n";
                sql+="\n";
                sql+="mat.ccmID,\n";
                sql+="\n";

                if(StringUtils.isBlank(contentClassifyID))
                {
                        sql+="(case when CHAR_LENGTH(mat.ccmID)>=3 then (SELECT dict.description FROM dictionary dict where dict.dictID='FYN' and dict.flag=1 and dict.dictValue = left(mat.ccmID,3) LIMIT 1) else '' end) as flz1,\n";
                }
                else {
                    if(contentClassifyID.length()==3)
                    {
                        sql+="(case when CHAR_LENGTH(mat.ccmID)>=3 then (SELECT dict.description FROM dictionary dict where dict.dictID='FYN' and dict.flag=1 and dict.dictValue = left(mat.ccmID,3) LIMIT 1) else '' end) as flz1,\n";
                        sql+="\n";
                        sql+="(case when CHAR_LENGTH(mat.ccmID)>=6 then CONCAT('->', (SELECT dict.description FROM dictionary dict where dict.dictID='FYN' and dict.flag=1 and dict.dictValue = left(mat.ccmID,6) LIMIT 1)) else '' end) as flz2,\n";
                        sql+="\n";
                    }
                    else if(contentClassifyID.length()==6)
                    {
                        sql+="(case when CHAR_LENGTH(mat.ccmID)>=3 then (SELECT dict.description FROM dictionary dict where dict.dictID='FYN' and dict.flag=1 and dict.dictValue = left(mat.ccmID,3) LIMIT 1) else '' end) as flz1,\n";
                        sql+="\n";
                        sql+="(case when CHAR_LENGTH(mat.ccmID)>=6 then CONCAT('->', (SELECT dict.description FROM dictionary dict where dict.dictID='FYN' and dict.flag=1 and dict.dictValue = left(mat.ccmID,6) LIMIT 1)) else '' end) as flz2,\n";
                        sql+="\n";
                        sql+="(case when CHAR_LENGTH(mat.ccmID)>=9 then CONCAT('->',(SELECT dict.description FROM dictionary dict where dict.dictID='FYN' and dict.flag=1 and dict.dictValue = left(mat.ccmID,9) LIMIT 1)) else '' end) as flz3,\n";
                        sql+="\n";
                    }
                    else if(contentClassifyID.length()==9)
                    {
                        sql+="(case when CHAR_LENGTH(mat.ccmID)>=3 then (SELECT dict.description FROM dictionary dict where dict.dictID='FYN' and dict.flag=1 and dict.dictValue = left(mat.ccmID,3) LIMIT 1) else '' end) as flz1,\n";
                        sql+="\n";
                        sql+="(case when CHAR_LENGTH(mat.ccmID)>=6 then CONCAT('->', (SELECT dict.description FROM dictionary dict where dict.dictID='FYN' and dict.flag=1 and dict.dictValue = left(mat.ccmID,6) LIMIT 1)) else '' end) as flz2,\n";
                        sql+="\n";
                        sql+="(case when CHAR_LENGTH(mat.ccmID)>=9 then CONCAT('->',(SELECT dict.description FROM dictionary dict where dict.dictID='FYN' and dict.flag=1 and dict.dictValue = left(mat.ccmID,9) LIMIT 1)) else '' end) as flz3,\n";
                        sql+="\n";
                        sql+="(case when CHAR_LENGTH(mat.ccmID)>=12 then CONCAT('->',(SELECT dict.description FROM dictionary dict where dict.dictID='FYN' and dict.flag=1 and dict.dictValue = left(mat.ccmID,12) LIMIT 1)) else '' end) as flz4,\n";
                        sql+="\n";
                    }
                    else
                    {
                        sql+="(case when CHAR_LENGTH(mat.ccmID)>=3 then (SELECT dict.description FROM dictionary dict where dict.dictID='FYN' and dict.flag=1 and dict.dictValue = left(mat.ccmID,3) LIMIT 1) else '' end) as flz1,\n";
                        sql+="\n";
                        sql+="(case when CHAR_LENGTH(mat.ccmID)>=6 then CONCAT('->', (SELECT dict.description FROM dictionary dict where dict.dictID='FYN' and dict.flag=1 and dict.dictValue = left(mat.ccmID,6) LIMIT 1)) else '' end) as flz2,\n";
                        sql+="\n";
                        sql+="(case when CHAR_LENGTH(mat.ccmID)>=9 then CONCAT('->',(SELECT dict.description FROM dictionary dict where dict.dictID='FYN' and dict.flag=1 and dict.dictValue = left(mat.ccmID,9) LIMIT 1)) else '' end) as flz3,\n";
                        sql+="\n";
                        sql+="(case when CHAR_LENGTH(mat.ccmID)>=12 then CONCAT('->',(SELECT dict.description FROM dictionary dict where dict.dictID='FYN' and dict.flag=1 and dict.dictValue = left(mat.ccmID,12) LIMIT 1)) else '' end) as flz4,\n";
                        sql+="\n";
                        sql+="(case when CHAR_LENGTH(mat.ccmID)>=15 then CONCAT('->',(SELECT dict.description FROM dictionary dict where dict.dictID='FYN' and dict.flag=1 and dict.dictValue = left(mat.ccmID,15) LIMIT 1)) else '' end) as flz5,\n";
                    }
                }

                sql+="\n";
                sql+="\n";
                sql+="(CASE WHEN IFNULL(\n";
                sql+="(SELECT count(m.ccmID) FROM matter m where FIND_IN_SET(m.createOrgID,'"+createOrgID+"') and m.ccmID REGEXP '"+ccmID+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') <= '"+endTime+"' and m.ccmID = mat.ccmID)\n";
                sql+=",0) = 0 THEN '0.00%'  WHEN IFNULL(\n";
                sql+="(SELECT count(m.ccmID) FROM matter m where FIND_IN_SET(m.createOrgID,'"+createOrgID+"') and m.ccmID REGEXP '"+ccmID+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and m.ccmID = mat.ccmID)\n";
                sql+=",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n";
                sql+="(SELECT count(m.ccmID) FROM matter m where FIND_IN_SET(m.createOrgID,'"+createOrgID+"') and m.ccmID REGEXP '"+ccmID+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') <= '"+endTime+"' and m.ccmID = mat.ccmID)\n";
                sql+=",0)-IFNULL(\n";
                sql+="(SELECT count(m.ccmID) FROM matter m where FIND_IN_SET(m.createOrgID,'"+createOrgID+"') and m.ccmID REGEXP '"+ccmID+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and m.ccmID = mat.ccmID)\n";
                sql+=",0))/IFNULL(\n";
                sql+="(SELECT count(m.ccmID) FROM matter m where FIND_IN_SET(m.createOrgID,'"+createOrgID+"') and m.ccmID REGEXP '"+ccmID+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and m.ccmID = mat.ccmID)\n";
                sql+=",0)*100 ,2)  ,'%') END ) as xfsxsl_tb,\n";
                sql+="\n";
                sql+="(CASE WHEN IFNULL(\n";
                sql+="(SELECT count(m.ccmID) FROM matter m where FIND_IN_SET(m.createOrgID,'"+createOrgID+"') and m.ccmID REGEXP '"+ccmID+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') <= '"+endTime+"' and m.ccmID = mat.ccmID)\n";
                sql+=",0) = 0 THEN '0.00%'  WHEN IFNULL(\n";
                sql+="(SELECT count(m.ccmID) FROM matter m where FIND_IN_SET(m.createOrgID,'"+createOrgID+"') and m.ccmID like concat('',left(mat.ccmID, CHAR_LENGTH(mat.ccmID)-1),'%') and DATE_FORMAT(m.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') <= '"+endTime+"')\n";
                sql+=",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n";
                sql+="(SELECT count(m.ccmID) FROM matter m where FIND_IN_SET(m.createOrgID,'"+createOrgID+"') and m.ccmID REGEXP '"+ccmID+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') <= '"+endTime+"' and m.ccmID = mat.ccmID)\n";
                sql+=",0))/IFNULL(\n";
                sql+="(SELECT count(m.ccmID) FROM matter m where FIND_IN_SET(m.createOrgID,'"+createOrgID+"') and m.ccmID like concat('',left(mat.ccmID, CHAR_LENGTH(mat.ccmID)-1),'%') and DATE_FORMAT(m.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') <= '"+endTime+"')\n";
                sql+=",0)*100 ,2)  ,'%') END ) as zsyjzb,\n";
                sql+="(SELECT count(m.ccmID) FROM matter m where FIND_IN_SET(m.createOrgID,'"+createOrgID+"') and m.ccmID like concat('',left(mat.ccmID, CHAR_LENGTH(mat.ccmID)-1),'%') and DATE_FORMAT(m.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') <= '"+endTime+"') as zsyjsl,\n";
                sql+="\n";
                sql+="count(1) as dnljjc2,\n";
                sql+="\n";
                sql+="(CASE WHEN IFNULL(\n";
                sql+="count(1)\n";
                sql+=",0) = 0 THEN '0.00%'  WHEN IFNULL(\n";
                sql+="(SELECT count(m.ccmID) FROM matter m where FIND_IN_SET(m.createOrgID,'"+createOrgID+"') and m.ccmID REGEXP '"+ccmID+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') >= CONCAT(year(now())-1,'-01') and DATE_FORMAT(m.createTime,'%Y-%m-%d') <= CONCAT(year(now())-1,'-12') and m.ccmID = mat.ccmID)\n";
                sql+=",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n";
                sql+="count(1)\n";
                sql+=",0)-IFNULL(\n";
                sql+="(SELECT count(m.ccmID) FROM matter m where FIND_IN_SET(m.createOrgID,'"+createOrgID+"') and m.ccmID REGEXP '"+ccmID+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') >= CONCAT(year(now())-1,'-01') and DATE_FORMAT(m.createTime,'%Y-%m-%d') <= CONCAT(year(now())-1,'-12') and m.ccmID = mat.ccmID)\n";
                sql+=",0))/IFNULL(\n";
                sql+="(SELECT count(m.ccmID) FROM matter m where FIND_IN_SET(m.createOrgID,'"+createOrgID+"') and m.ccmID REGEXP '"+ccmID+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') >= CONCAT(year(now())-1,'-01') and DATE_FORMAT(m.createTime,'%Y-%m-%d') <= CONCAT(year(now())-1,'-12') and m.ccmID = mat.ccmID)\n";
                sql+=",0)*100 ,2)  ,'%') END ) as xfsxsl_tb2,\n";
                sql+="\n";
                sql+="\n";
                sql+="(CASE WHEN IFNULL(\n";
                sql+="count(1)\n";
                sql+=",0) = 0 THEN '0.00%'  WHEN IFNULL(\n";
                sql+="(SELECT count(m.ccmID) FROM matter m where FIND_IN_SET(m.createOrgID,'"+createOrgID+"') and m.ccmID REGEXP '"+ccmID+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') >= CONCAT(DATE_FORMAT(NOW(), '%Y'),'-01') and DATE_FORMAT(m.createTime,'%Y-%m-%d') <= CONCAT(DATE_FORMAT(NOW(), '%Y'),'-12'))\n";
                sql+=",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n";
                sql+="count(1)\n";
                sql+=",0))/IFNULL(\n";
                sql+="(SELECT count(m.ccmID) FROM matter m where FIND_IN_SET(m.createOrgID,'"+createOrgID+"') and m.ccmID REGEXP '"+ccmID+"' and DATE_FORMAT(m.createTime,'%Y-%m-%d') >= CONCAT(DATE_FORMAT(NOW(), '%Y'),'-01') and DATE_FORMAT(m.createTime,'%Y-%m-%d') <= CONCAT(DATE_FORMAT(NOW(), '%Y'),'-12'))\n";
                sql+=",0)*100 ,2)  ,'%') END ) as zlzb2,\n";
                sql+="\n";
                sql+="(CASE WHEN IFNULL(\n";
                sql+="count(1)\n";
                sql+=",0) = 0 THEN '0.00%'  WHEN IFNULL(\n";
                sql+="(SELECT count(m.ccmID) FROM matter m where FIND_IN_SET(m.createOrgID,'"+createOrgID+"') and m.ccmID like concat('',left(mat.ccmID, CHAR_LENGTH(mat.ccmID)-1),'%') and DATE_FORMAT(m.createTime,'%Y-%m-%d') >= CONCAT(DATE_FORMAT(NOW(), '%Y'),'-01') and DATE_FORMAT(m.createTime,'%Y-%m-%d') <= CONCAT(DATE_FORMAT(NOW(), '%Y'),'-12'))\n";
                sql+=",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n";
                sql+="count(1)\n";
                sql+=",0))/IFNULL(\n";
                sql+="(SELECT count(m.ccmID) FROM matter m where FIND_IN_SET(m.createOrgID,'"+createOrgID+"') and m.ccmID like concat('',left(mat.ccmID, CHAR_LENGTH(mat.ccmID)-1),'%') and DATE_FORMAT(m.createTime,'%Y-%m-%d') >= CONCAT(DATE_FORMAT(NOW(), '%Y'),'-01') and DATE_FORMAT(m.createTime,'%Y-%m-%d') <= CONCAT(DATE_FORMAT(NOW(), '%Y'),'-12'))\n";
                sql+=",0)*100 ,2)  ,'%') END ) as zsyjzb2\n";
                sql+="\n";
                sql+="\n";
                sql+="FROM matter mat INNER JOIN activity act on mat.activityID = act.id and FIND_IN_SET(act.registerTypeID,'"+registerTypeID+"') where FIND_IN_SET(mat.createOrgID,'"+createOrgID+"') and mat.ccmID REGEXP '"+ccmID+"' and DATE_FORMAT(mat.createTime,'%Y-%m-%d') >= CONCAT(DATE_FORMAT(NOW(), '%Y'),'-01') and DATE_FORMAT(mat.createTime,'%Y-%m-%d') <= CONCAT(DATE_FORMAT(NOW(), '%Y'),'-12') ";

                if(StringUtils.isBlank(contentClassifyID))
                {
                    sql+=" GROUP BY flz1 ORDER BY flz1 desc";
                }
                else {
                    if(contentClassifyID.length()==3)
                    {
                        sql+=" and mat.ccmID like '"+contentClassifyID+"%' GROUP BY flz1,flz2 ORDER BY flz1 desc";
                    }
                    else if(contentClassifyID.length()==6)
                    {
                        sql+=" and mat.ccmID like '"+contentClassifyID+"%' GROUP BY flz1,flz2,flz3 ORDER BY flz1 desc";
                    }
                    else if(contentClassifyID.length()==9)
                    {
                        sql+=" and mat.ccmID like '"+contentClassifyID+"%' GROUP BY flz1,flz2,flz3,flz4 ORDER BY flz1 desc";
                    }
                    else
                    {
                        sql+=" and mat.ccmID like '"+contentClassifyID+"%' GROUP BY flz1,flz2,flz3,flz4,flz5 ORDER BY flz1 desc";
                    }
                }



        RowMapper<ActivityVO6> beanlist = new BeanPropertyRowMapper<ActivityVO6>(ActivityVO6.class);
        List<ActivityVO6> list = new ArrayList<ActivityVO6>();
        list = jdbcTemplate.query(sql.toString(), beanlist);

        //总计
        BigDecimal total = new BigDecimal(list.stream().mapToInt(ActivityVO6::getXfsxsl).sum());

        List<ActivityVO6> list1 = new ArrayList<ActivityVO6>();

        for(int i=0;i<list.size();i++)
        {
            ActivityVO6 a6 = list.get(i);
            a6.setZlzb(CalculateUtil(new BigDecimal(a6.getXfsxsl()),total));
            list1.add(a6);
        }

        ExcelWriter excelWriter = null;
        try {
            String templateName = "信访事项反映内容分类统计表";
            String suffix = ".xlsx";
            InputStream inputStream = new ClassPathResource("/static/temp/excel/" + templateName + suffix).getInputStream();
            String name = "信访事项反映内容分类统计表";
            String file_name = new String(name.getBytes(), "ISO-8859-1");
            response.addHeader("Content-Disposition", "attachment;filename=" +file_name + System.currentTimeMillis() + ".xlsx");
            response.setContentType("multipart/form-data");
            excelWriter = EasyExcel.write(response.getOutputStream()).withTemplate(inputStream).build();
            WriteSheet writeSheet = EasyExcel.writerSheet().build();
            excelWriter.fill(list1, writeSheet);
            Map<String,String> map =new HashMap<>();
            map.put("dytime",dytime);
            map.put("orgName",orgName);
            excelWriter.fill(map, writeSheet);
        } catch (IOException e) {
            e.printStackTrace();
        }finally {
            // 关闭流
            excelWriter.finish();
        }

//        String templateName = "信访事项反映内容分类统计表";
//        String suffix = ".xlsx";
//        String templateFileName =
//                TestFileUtil.class.getResource("/static/temp/excel/").getPath() + templateName + suffix;
//
//        String fileName = "信访事项反映内容分类统计表" + System.currentTimeMillis() + ".xlsx";
//        String filePath = TestFileUtil.getPath() ;
//        ExcelWriter excelWriter = EasyExcel.write(filePath+fileName).withTemplate(templateFileName).build();
//        WriteSheet writeSheet = EasyExcel.writerSheet().build();
//        excelWriter.fill(list, writeSheet);
//        excelWriter.finish();
//        export(filePath,fileName,response,request);
    }


    /**
     * 9.集体访情况统计表（三级通用）以及11.联名信登记情况统计表
     */
    @PostMapping("/jitifang")
    @ResponseBody
    public void jitifang(HttpServletResponse response, HttpServletRequest request,String createOrgID,String startTime,String endTime,String orgName) throws IOException {
        String sql = "select a.activityNum as activity,h.d_count,h.a_count - h.d_count as e_count, a.xfNumber - h.a_count - h.b_count as c_count,h.b_count,b.`name`,a.xfNumber as xfNumber1,d.nationalityID,g.ancestors,e.xfName,e.abstract abstract1,e.happenRegion,e.belongs,e.visit,e.createTime as createTime1,i.ancestors as ancestors1\n" +
                "from activity a\n" +
                "                LEFT JOIN person b on a.mainPerson=b.id\n" +
                "                LEFT JOIN person_activity c on a.id=c.activityID\n" +
                "                LEFT JOIN person d on c.personID = d.id\n" +
                "                LEFT JOIN matter e on e.activityID = a.id\n" +
                "                LEFT JOIN sys_organization f on a.createOrgID = f.id\n" +
                "                LEFT JOIN sys_dept g on f.deptID = g.id\n" +
                "\t\t\t\t\t\t\t\tLEFT JOIN sys_dept i on d.domicile = i.deptName\n" +
                "\t\t\t\t\t\t\t\tLEFT JOIN (\n" +
                "\t\t\t\t\t\t\t\t\tselect a1.activityNum,COUNT(CASE WHEN d1.nationalityID = '134044' or d1.nationalityID = \t\t\t\t\t\t\t\t\t'134045' or d1.nationalityID = '134046' THEN 1 END) AS a_count,\n" +
                "\t\t\t\t\t\t\t\t\tCOUNT(CASE WHEN d1.nationalityID != '134044' and d1.nationalityID != '134045' \n" +
                "\t\t\t\t\t\t\t\tand d1.nationalityID != '134046' and d1.nationalityID != '' THEN 1 END) AS b_count,\n" +
                "\t\t\t\t\t\t\t\t\tCOUNT(CASE WHEN POSITION(g1.ancestors in i1.ancestors) = 1 THEN 1 END) AS d_count\n" +
                "\t\t\t\t\t\t\t\t\tfrom activity a1\n" +
                "\t\t\t\t\t\t\t\t\tLEFT JOIN person b1 on a1.mainPerson=b1.id\n" +
                "\t\t\t\t\t\t\t\t\tLEFT JOIN person_activity c1 on a1.id=c1.activityID\n" +
                "\t\t\t\t\t\t\t\t\tLEFT JOIN person d1 on c1.personID = d1.id\n" +
                "\t\t\t\t\t\t\t\t\tLEFT JOIN matter e1 on e1.activityID = a1.id\n" +
                "\t\t\t\t\t\t\t\t\tLEFT JOIN sys_organization f1 on a1.createOrgID = f1.id\n" +
                "\t\t\t\t\t\t\t\t\tLEFT JOIN sys_dept g1 on f1.deptID = g1.id\n" +
                "\t\t\t\t\t\t\t\t\tLEFT JOIN sys_dept i1 on d1.domicile = i1.deptName\n" +
                "\t\t\t\t\t\t\t\t\twhere a1.xfTypeID = '001002' and a1.xfNumber >= 5\n" +
                "\t\t\t\t\t\t\t\t\tGROUP BY a1.activityNum\n" +
                "\t\t\t\t\t\t\t\t\t)h on h.activityNum = a.activityNum\n" +
                "                where a.xfTypeID = '001002' and a.xfNumber >= 5\n";
        if(createOrgID != null && createOrgID.length() > 0){
            sql += "and a.createOrgID = '" + createOrgID + "'\n";
        }
        if(startTime != null && startTime.length() > 0 && endTime != null && endTime.length() > 0){
            sql += " and DATE_FORMAT(e.createTime,'%Y-%m-%d') >= '" + startTime + "'  and DATE_FORMAT(e.createTime,'%Y-%m-%d') <= '" + endTime + "'\n";
        }
        sql += "\t\t\t\t\t\t\t\tGROUP BY activity";
        RowMapper<ActivityVO9> beanlist = new BeanPropertyRowMapper<ActivityVO9>(ActivityVO9.class);
        List<ActivityVO9> list = new ArrayList<ActivityVO9>();
        list = jdbcTemplate.query(sql.toString(), beanlist);
        int i = 0;
        for (ActivityVO9 activityVO9:list) {
            i++;
            activityVO9.setIndex(i);
            activityVO9.setCreateTime2(DateTimeUtils.getDayMonthYear(activityVO9.getCreateTime1()));
            activityVO9.setXfNumber2(activityVO9.getXfNumber1());
        }
        List<String> arrs = new ArrayList<>();
        arrs.add("index");
        arrs.add("activity");
        arrs.add("name");
        arrs.add("xfNumber2");
        arrs.add("d_count");
        arrs.add("e_count");
        arrs.add("c_count");
        arrs.add("b_count");
        List<String> arrs1 = new ArrayList<>();
        arrs1.add("xfName");
        arrs1.add("abstract1");
        arrs1.add("happenRegion");
        arrs1.add("belongs");
        arrs1.add("visit");
        arrs1.add("createTime2");

        String templateName = "集体访登记情况统计表（三级通用）";
        ExcelUtil.excludeOrIncludeWrite1(response,list,ActivityVO9.class,arrs,arrs1,templateName,orgName);
//        String templateName = "集体访登记情况统计表（三级通用）";
//        String suffix = ".xlsx";
//        String templateFileName = TestFileUtil.class.getResource("/static/temp/excel/").getPath() + templateName + suffix;
//
//        String fileName = "集体访登记情况统计表（三级通用）" + System.currentTimeMillis() + ".xlsx";
//        String filePath = TestFileUtil.getPath() ;
//        ExcelWriter excelWriter = EasyExcel.write(filePath+fileName).withTemplate(templateFileName).build();
//        WriteSheet writeSheet = EasyExcel.writerSheet().build();
//        excelWriter.fill(list, writeSheet);
//        excelWriter.finish();
//        export(filePath,fileName,response,request);
    }


    /**
     * 9.集体访情况统计表（三级通用）以及11.联名信登记情况统计表
     */
    @PostMapping("/jitifang1")
    @ResponseBody
    public void jitifang1(HttpServletResponse response, HttpServletRequest request,String createOrgID,String startTime,String endTime,String orgName) throws IOException {
        String sql = "select a.activityNum as activity,h.d_count,h.a_count - h.d_count as e_count, a.xfNumber - h.a_count - h.b_count as c_count,h.b_count,b.`name`,a.xfNumber as xfNumber1,d.nationalityID,g.ancestors,e.xfName,e.abstract abstract1,e.happenRegion,e.belongs,e.visit,e.createTime as createTime1,i.ancestors as ancestors1\n" +
                "from activity a\n" +
                "                LEFT JOIN person b on a.mainPerson=b.id\n" +
                "                LEFT JOIN person_activity c on a.id=c.activityID\n" +
                "                LEFT JOIN person d on c.personID = d.id\n" +
                "                LEFT JOIN matter e on e.activityID = a.id\n" +
                "                LEFT JOIN sys_organization f on a.createOrgID = f.id\n" +
                "                LEFT JOIN sys_dept g on f.deptID = g.id\n" +
                "\t\t\t\t\t\t\t\tLEFT JOIN sys_dept i on d.domicile = i.deptName\n" +
                "\t\t\t\t\t\t\t\tLEFT JOIN (\n" +
                "\t\t\t\t\t\t\t\t\tselect a1.activityNum,COUNT(CASE WHEN d1.nationalityID = '134044' or d1.nationalityID = \t\t\t\t\t\t\t\t\t'134045' or d1.nationalityID = '134046' THEN 1 END) AS a_count,\n" +
                "\t\t\t\t\t\t\t\t\tCOUNT(CASE WHEN d1.nationalityID != '134044' and d1.nationalityID != '134045' \n" +
                "\t\t\t\t\t\t\t\tand d1.nationalityID != '134046' and d1.nationalityID != '' THEN 1 END) AS b_count,\n" +
                "\t\t\t\t\t\t\t\t\tCOUNT(CASE WHEN POSITION(g1.ancestors in i1.ancestors) = 1 THEN 1 END) AS d_count\n" +
                "\t\t\t\t\t\t\t\t\tfrom activity a1\n" +
                "\t\t\t\t\t\t\t\t\tLEFT JOIN person b1 on a1.mainPerson=b1.id\n" +
                "\t\t\t\t\t\t\t\t\tLEFT JOIN person_activity c1 on a1.id=c1.activityID\n" +
                "\t\t\t\t\t\t\t\t\tLEFT JOIN person d1 on c1.personID = d1.id\n" +
                "\t\t\t\t\t\t\t\t\tLEFT JOIN matter e1 on e1.activityID = a1.id\n" +
                "\t\t\t\t\t\t\t\t\tLEFT JOIN sys_organization f1 on a1.createOrgID = f1.id\n" +
                "\t\t\t\t\t\t\t\t\tLEFT JOIN sys_dept g1 on f1.deptID = g1.id\n" +
                "\t\t\t\t\t\t\t\t\tLEFT JOIN sys_dept i1 on d1.domicile = i1.deptName\n" +
                "\t\t\t\t\t\t\t\t\twhere a1.xfTypeID = '002002' and a1.xfNumber >= 5\n" +
                "\t\t\t\t\t\t\t\t\tGROUP BY a1.activityNum\n" +
                "\t\t\t\t\t\t\t\t\t)h on h.activityNum = a.activityNum\n" +
                "                where a.xfTypeID = '002002' and a.xfNumber >= 5\n";
        if(createOrgID != null && createOrgID.length() > 0){
            sql += "and a.createOrgID = '" + createOrgID + "'\n";
        }
        if(startTime != null && startTime.length() > 0 && endTime != null && endTime.length() > 0){
            sql += " and DATE_FORMAT(e.createTime,'%Y-%m-%d') >= '" + startTime + "'  and DATE_FORMAT(e.createTime,'%Y-%m-%d') <= '" + endTime + "'\n";
        }
        sql += "\t\t\t\t\t\t\t\tGROUP BY activity";
        RowMapper<ActivityVO9> beanlist = new BeanPropertyRowMapper<ActivityVO9>(ActivityVO9.class);
        List<ActivityVO9> list = new ArrayList<ActivityVO9>();
        list = jdbcTemplate.query(sql.toString(), beanlist);
        int i = 0;
        for (ActivityVO9 activityVO9:list) {
            i++;
            activityVO9.setIndex(i);
            activityVO9.setCreateTime2(DateTimeUtils.getDayMonthYear(activityVO9.getCreateTime1()));
        }
        List<String> arrs = new ArrayList<>();
        arrs.add("index");
        arrs.add("activity");
        arrs.add("name");
        arrs.add("xfNumber1");
        arrs.add("d_count");
        arrs.add("e_count");
        arrs.add("c_count");
        arrs.add("b_count");
        List<String> arrs1 = new ArrayList<>();
        arrs1.add("xfName");
        arrs1.add("abstract1");
        arrs1.add("happenRegion");
        arrs1.add("belongs");
        arrs1.add("visit");
        arrs1.add("createTime2");

        String templateName = "联名信登记情况统计表（三级通用）";
        ExcelUtil.excludeOrIncludeWrite1(response,list,ActivityVO9.class,arrs,arrs1,templateName,orgName);

//        String suffix = ".xlsx";
//        String templateFileName = TestFileUtil.class.getResource("/static/temp/excel/").getPath() + templateName + suffix;
//
//        String fileName = "集体访登记情况统计表（三级通用）" + System.currentTimeMillis() + ".xlsx";
//        String filePath = TestFileUtil.getPath() ;
//        ExcelWriter excelWriter = EasyExcel.write(filePath+fileName).withTemplate(templateFileName).build();
//        WriteSheet writeSheet = EasyExcel.writerSheet().build();
//        excelWriter.fill(list, writeSheet);
//        excelWriter.finish();
//        export(filePath,fileName,response,request);
    }


    /**
     * 4.信访人户籍地统计表（三级通用）
     */
    @PostMapping("/domicile")
    @ResponseBody
    public void domicile(HttpServletResponse response, HttpServletRequest request, String startTime,String endTime,String compareBegTime,String compareEndTime,String deptId,String orgName)  {

        SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");

        String dytime = formatter.format(new Date());

        if(StringUtils.isBlank(startTime))
        {
            startTime = "2022-01-01";
        }
        if(StringUtils.isBlank(endTime))
        {
            endTime = "2022-12-31";
        }
        if(StringUtils.isBlank(compareBegTime))
        {
            compareBegTime = "2021-01-01";
        }
        if(StringUtils.isBlank(compareEndTime))
        {
            compareEndTime = "2021-12-31";
        }
        if(StringUtils.isBlank(deptId))
        {
            deptId = "2";
        }

        String a = "本行政区划外";
        String b = "境外";
        String c = "未标明户籍地";
//        try {
//            a = new String(a.getBytes(), "UTF-8");
//            b = new String(b.getBytes(), "UTF-8");
//            c = new String(c.getBytes(), "UTF-8");
//        } catch (UnsupportedEncodingException e) {
//            e.printStackTrace();
//        }

        String sql = "SELECT * FROM (SELECT \n" +
                "dept.deptName as bm,\n" +
                "(SELECT COUNT(act1.id) FROM activity act1 where act1.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) AND DATE_FORMAT(act1.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act1.createTime,'%Y-%m-%d') <= '"+endTime+"') as xfhdjpc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "(SELECT COUNT(act1.id) FROM activity act1 where act1.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act1.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act1.createTime,'%Y-%m-%d') <= '"+endTime+"')\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT COUNT(act1.id) FROM activity act1 where act1.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act1.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act1.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "(SELECT COUNT(act1.id) FROM activity act1 where act1.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act1.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act1.createTime,'%Y-%m-%d') <= '"+endTime+"')\n" +
                ",0)-IFNULL(\n" +
                "(SELECT COUNT(act1.id) FROM activity act1 where act1.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act1.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act1.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT COUNT(act1.id) FROM activity act1 where act1.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act1.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act1.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0)*100 ,2)  ,'%') END ) as xfhdjpctb,\n" +
                "IFNULL(\n" +
                "(SELECT sum(act1.xfNumber) FROM activity act1 where act1.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act1.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act1.createTime,'%Y-%m-%d') <= '"+endTime+"')\n" +
                ",0) as sjrc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "(SELECT sum(act1.xfNumber) FROM activity act1 where act1.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act1.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act1.createTime,'%Y-%m-%d') <= '"+endTime+"')\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT sum(act1.xfNumber) FROM activity act1 where act1.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act1.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act1.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "(SELECT sum(act2.xfNumber) as sjrc1 FROM activity act2 where act2.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue))  and DATE_FORMAT(act2.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act2.createTime,'%Y-%m-%d') <= '"+endTime+"')\n" +
                ",0)-IFNULL(\n" +
                "(SELECT sum(act2.xfNumber) as sjrc1 FROM activity act2 where act2.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act2.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act2.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT sum(act2.xfNumber) as sjrc1 FROM activity act2 where act2.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act2.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act2.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0)*100 ,2)  ,'%') END ) as sjrctb,\n" +
                "IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc10 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='002')\n" +
                ",0) lxrc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc11 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='002')\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc12 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='002')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc13 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='002')\n" +
                ",0)-IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc14 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='002')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc15 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='002')\n" +
                ",0)*100 ,2)  ,'%') END ) as lxjctb,\n" +
                "IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='001')\n" +
                ",0) as lfrc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='001')\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='001')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='001')\n" +
                ",0)-IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='001')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='001')\n" +
                ",0)*100 ,2)  ,'%') END ) as lfrctb,\n" +
                "IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='004')\n" +
                ",0) as wsfyrc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='004')\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='004')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='004')\n" +
                ",0)-IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='004')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='004')\n" +
                ",0)*100 ,2)  ,'%') END ) as wsfytb,\n" +
                "IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='003')\n" +
                ",0) as ldrc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='003')\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='003')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='003')\n" +
                ",0)-IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='003')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and left(ry.domicileID,CHAR_LENGTH(d.dictValue))=d.dictValue)) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='003')\n" +
                ",0)*100 ,2)  ,'%') END ) as ldtb \n" +
                "\n" +
                " FROM sys_dept dept inner join dictionary d on dept.deptName = d.description and d.dictID ='DQ' where FIND_IN_SET(dept.id,'"+deptId+"') or FIND_IN_SET(dept.parentID,'"+deptId+"') order by dept.orderNum) a1 \n" +
                " \n" +
                "UNION\n" +
                "\n" +
                "SELECT * FROM (SELECT \n" +
                "convert('"+a+"' using gb2312) as bm,\n" +
                "COUNT(act.id) as xfhdjpc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "COUNT(act.id)\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT COUNT(act1.id) as xfhdjpc1 FROM activity act1 where act1.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act1.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act1.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "COUNT(act.id)\n" +
                ",0)-IFNULL(\n" +
                "(SELECT COUNT(act1.id) as xfhdjpc1 FROM activity act1 where act1.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act1.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act1.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT COUNT(act1.id) as xfhdjpc1 FROM activity act1 where act1.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act1.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act1.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0)*100 ,2)  ,'%') END ) as xfhdjpctb,\n" +
                "IFNULL(sum(act.xfNumber),0) as sjrc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "sum(act.xfNumber)\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT sum(act2.xfNumber) as sjrc1 FROM activity act2 where act2.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act2.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act2.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "sum(act.xfNumber)\n" +
                ",0)-IFNULL(\n" +
                "(SELECT sum(act2.xfNumber) as sjrc1 FROM activity act2 where act2.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act2.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act2.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT sum(act2.xfNumber) as sjrc1 FROM activity act2 where act2.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act2.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act2.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0)*100 ,2)  ,'%') END ) as sjrctb,\n" +
                "IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc10 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='002')\n" +
                ",0) lxrc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc11 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='002')\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc12 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='002')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc13 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='002')\n" +
                ",0)-IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc14 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='002')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc15 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='002')\n" +
                ",0)*100 ,2)  ,'%') END ) as lxjctb,\n" +
                "IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='001')\n" +
                ",0) as lfrc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='001')\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='001')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='001')\n" +
                ",0)-IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='001')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='001')\n" +
                ",0)*100 ,2)  ,'%') END ) as lfrctb,\n" +
                "IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='004')\n" +
                ",0) as wsfyrc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='004')\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='004')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='004')\n" +
                ",0)-IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='004')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='004')\n" +
                ",0)*100 ,2)  ,'%') END ) as wsfytb,\n" +
                "IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='003')\n" +
                ",0) as ldrc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='003')\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='003')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='003')\n" +
                ",0)-IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='003')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='003')\n" +
                ",0)*100 ,2)  ,'%') END ) as ldtb \n" +
                " FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID in('134044','134045','134046') and ry.domicileID not in(SELECT d.dictValue FROM dictionary d where d.dictID ='DQ' and d.description in (SELECT dept.deptName FROM sys_dept dept where FIND_IN_SET('"+deptId+"',ancestors))))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"') a2\n" +
                " \n" +
                " UNION\n" +
                " \n" +
                "SELECT * FROM  (SELECT \n" +
                "convert('"+b+"' using gb2312) as bm,\n" +
                "COUNT(act.id) as xfhdjpc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "COUNT(act.id)\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT COUNT(act1.id) as xfhdjpc1 FROM activity act1 where act1.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act1.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act1.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "COUNT(act.id)\n" +
                ",0)-IFNULL(\n" +
                "(SELECT COUNT(act1.id) as xfhdjpc1 FROM activity act1 where act1.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act1.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act1.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT COUNT(act1.id) as xfhdjpc1 FROM activity act1 where act1.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act1.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act1.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0)*100 ,2)  ,'%') END ) as xfhdjpctb,\n" +
                "IFNULL(sum(act.xfNumber),0) as sjrc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "sum(act.xfNumber)\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT sum(act2.xfNumber) as sjrc1 FROM activity act2 where act2.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act2.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act2.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "sum(act.xfNumber)\n" +
                ",0)-IFNULL(\n" +
                "(SELECT sum(act2.xfNumber) as sjrc1 FROM activity act2 where act2.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act2.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act2.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT sum(act2.xfNumber) as sjrc1 FROM activity act2 where act2.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act2.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act2.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0)*100 ,2)  ,'%') END ) as sjrctb,\n" +
                "IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc10 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='002')\n" +
                ",0) lxrc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc11 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='002')\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc12 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='002')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc13 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='002')\n" +
                ",0)-IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc14 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='002')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc15 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='002')\n" +
                ",0)*100 ,2)  ,'%') END ) as lxjctb,\n" +
                "IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='001')\n" +
                ",0) as lfrc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='001')\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='001')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='001')\n" +
                ",0)-IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='001')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='001')\n" +
                ",0)*100 ,2)  ,'%') END ) as lfrctb,\n" +
                "IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='004')\n" +
                ",0) as wsfyrc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='004')\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='004')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='004')\n" +
                ",0)-IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='004')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='004')\n" +
                ",0)*100 ,2)  ,'%') END ) as wsfytb,\n" +
                "IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='003')\n" +
                ",0) as ldrc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='003')\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='003')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='003')\n" +
                ",0)-IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='003')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='003')\n" +
                ",0)*100 ,2)  ,'%') END ) as ldtb \n" +
                " FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where ry.nationalityID is not null and ry.nationalityID!='' and ry.nationalityID not in('134044','134045','134046'))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"') a3\n" +
                " \n" +
                "  UNION\n" +
                " \n" +
                "SELECT * FROM ( SELECT \n" +
                "convert('"+c+"' using gb2312) as bm,\n" +
                "COUNT(act.id) as xfhdjpc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "COUNT(act.id)\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT COUNT(act1.id) as xfhdjpc1 FROM activity act1 where act1.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID='') )) and DATE_FORMAT(act1.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act1.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "COUNT(act.id)\n" +
                ",0)-IFNULL(\n" +
                "(SELECT COUNT(act1.id) as xfhdjpc1 FROM activity act1 where act1.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act1.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act1.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT COUNT(act1.id) as xfhdjpc1 FROM activity act1 where act1.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act1.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act1.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0)*100 ,2)  ,'%') END ) as xfhdjpctb,\n" +
                "IFNULL(sum(act.xfNumber),0) as sjrc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "sum(act.xfNumber)\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT sum(act2.xfNumber) as sjrc1 FROM activity act2 where act2.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act2.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act2.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "sum(act.xfNumber)\n" +
                ",0)-IFNULL(\n" +
                "(SELECT sum(act2.xfNumber) as sjrc1 FROM activity act2 where act2.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act2.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act2.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT sum(act2.xfNumber) as sjrc1 FROM activity act2 where act2.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act2.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act2.createTime,'%Y-%m-%d') <= '"+compareEndTime+"')\n" +
                ",0)*100 ,2)  ,'%') END ) as sjrctb,\n" +
                "IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc10 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='002')\n" +
                ",0) lxrc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc11 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='002')\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc12 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='002')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc13 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='002')\n" +
                ",0)-IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc14 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='002')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lxrc15 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='002')\n" +
                ",0)*100 ,2)  ,'%') END ) as lxjctb,\n" +
                "IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='001')\n" +
                ",0) as lfrc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='001')\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='001')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='001')\n" +
                ",0)-IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='001')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as lfrc24 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='001')\n" +
                ",0)*100 ,2)  ,'%') END ) as lfrctb,\n" +
                "IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='004')\n" +
                ",0) as wsfyrc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='004')\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='004')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='004')\n" +
                ",0)-IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='004')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as wsfy42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='004')\n" +
                ",0)*100 ,2)  ,'%') END ) as wsfytb,\n" +
                "IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='003')\n" +
                ",0) as ldrc,\n" +
                "(CASE WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='003')\n" +
                ",0) = 0 THEN '0.00%'  WHEN IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='003')\n" +
                ",0) = 0 THEN '100.00%' ELSE concat(round((IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"' and act.registerTypeID='003')\n" +
                ",0)-IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='003')\n" +
                ",0))/IFNULL(\n" +
                "(SELECT SUM(act.xfNumber) as ld42 FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+compareBegTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+compareEndTime+"' and act.registerTypeID='003')\n" +
                ",0)*100 ,2)  ,'%') END ) as ldtb \n" +
                " FROM activity act where act.id in (SELECT pa.activityID FROM person_activity pa where pa.personID in (SELECT ry.id from person ry where (ry.domicileID is null or ry.domicileID=''))) and DATE_FORMAT(act.createTime,'%Y-%m-%d') >= '"+startTime+"' and DATE_FORMAT(act.createTime,'%Y-%m-%d') <= '"+endTime+"') a4";


        RowMapper<ActivityVO4> beanlist = new BeanPropertyRowMapper<ActivityVO4>(ActivityVO4.class);
        List<ActivityVO4> list = new ArrayList<ActivityVO4>();
        list = jdbcTemplate.query(sql.toString(), beanlist);



        ExcelWriter excelWriter = null;
        try {
            String templateName = "信访人户籍地统计表";
            String suffix = ".xlsx";
            InputStream inputStream = new ClassPathResource("/static/temp/excel/" + templateName + suffix).getInputStream();

            String name = "信访人户籍地统计表";

            String file_name = new String(name.getBytes(), "ISO-8859-1");

            response.addHeader("Content-Disposition", "attachment;filename=" + file_name + System.currentTimeMillis() + ".xlsx");
            response.setContentType("multipart/form-data");
            //response.setContentType("application/vnd.ms-excel");
            response.setCharacterEncoding("UTF-8");
            excelWriter = EasyExcel.write(response.getOutputStream()).withTemplate(inputStream).build();
            WriteSheet writeSheet = EasyExcel.writerSheet().build();
            excelWriter.fill(list, writeSheet);
            Map<String,String> map =new HashMap<>();
            map.put("dytime",dytime);
            map.put("orgName",orgName);
            excelWriter.fill(map, writeSheet);
        } catch (IOException e) {
            e.printStackTrace();
        }finally {
            // 关闭流
            excelWriter.finish();
        }

//        String templateName = "信访人户籍地统计表";
//        String suffix = ".xlsx";
//        String templateFileName =
//                TestFileUtil.class.getResource("/static/temp/excel/").getPath() + templateName + suffix;
//
//        String fileName = "信访人户籍地统计表" + System.currentTimeMillis() + ".xlsx";
//        String filePath = TestFileUtil.getPath() ;
//        ExcelWriter excelWriter = EasyExcel.write(filePath+fileName).withTemplate(templateFileName).build();
//        WriteSheet writeSheet = EasyExcel.writerSheet().build();
//        excelWriter.fill(list, writeSheet);
//        excelWriter.finish();
//        export(filePath,fileName,response,request);
    }


    /**导出文件方法*/
    public void export(String filePath, String fileName,  HttpServletResponse response, HttpServletRequest request) {


        try {
            response.setCharacterEncoding("utf-8");
            response.setContentType("multipart/form-data");
            response.setHeader("Content-Disposition",
                    "attachment;fileName=" + FileUtils.setFileDownloadHeader(request,fileName));
            FileUtils.writeBytes(filePath+fileName, response.getOutputStream());
        } catch (IOException e) {
            e.printStackTrace();
        }
        FileUtils.deleteFile(filePath+fileName);
    }

    public static JSONArray jsonArraySort(String jsonArrStr) {
        com.alibaba.fastjson.JSONArray jsonArr = com.alibaba.fastjson.JSON.parseArray(jsonArrStr);
        JSONArray sortedJsonArray = new JSONArray();
        List<JSONObject> jsonValues = new ArrayList<JSONObject>();
        for (int i = 0; i < jsonArr.size(); i++) {
            jsonValues.add(jsonArr.getJSONObject(i));
        }
        Collections.sort(jsonValues, new Comparator<JSONObject>() {
            private static final String KEY_NAME = "score";

            @Override
            public int compare(JSONObject a, JSONObject b) {
                String valA = new String();
                String valB = new String();
                try {
                    String aStr = a.getString(KEY_NAME);
                    valA = aStr;
                    String bStr = b.getString(KEY_NAME);
                    valB = bStr;
                } catch (JSONException e) {
                }
                return -valA.compareTo(valB);
            }
        });
        for (int i = 0; i < jsonArr.size(); i++) {
            sortedJsonArray.add(jsonValues.get(i));
        }
        return sortedJsonArray;
    }

    public static JSONObject getRequestJsonObject(HttpServletRequest request) throws IOException {
        String json = getRequestJsonString(request);
        return JSONObject.parseObject(json);
    }

    public static String getRequestJsonString(HttpServletRequest request)
            throws IOException {
        String submitMehtod = request.getMethod();
        if (submitMehtod.equals("GET")) {
            return new String(request.getQueryString().getBytes("iso-8859-1"),"utf-8").replaceAll("%22", "\"");
        } else {
            return getRequestPostStr(request);
        }
    }

    public static byte[] getRequestPostBytes(HttpServletRequest request)
            throws IOException {
        int contentLength = request.getContentLength();
        if(contentLength<0){
            return null;
        }
        byte buffer[] = new byte[contentLength];
        for (int i = 0; i < contentLength;) {

            int readlen = request.getInputStream().read(buffer, i,
                    contentLength - i);
            if (readlen == -1) {
                break;
            }
            i += readlen;
        }
        return buffer;
    }

    public static String getRequestPostStr(HttpServletRequest request)
            throws IOException {
        byte buffer[] = getRequestPostBytes(request);
        String charEncoding = request.getCharacterEncoding();
        if (charEncoding == null) {
            charEncoding = "UTF-8";
        }
        return new String(buffer, charEncoding);
    }


    public static String CalculateUtil(BigDecimal a, BigDecimal b){
        String percent = b == null ? "-" : b.compareTo(new BigDecimal(0)) == 0 ? "-": a == null ? "0.00%" : a.multiply(new BigDecimal(100)).divide(b,2,BigDecimal.ROUND_HALF_UP) + "%";
        return percent;
    }

}
