package com.dlsm.mapper;


import com.dlsm.model.Activity;
import com.dlsm.model.AffiliationMatter;
import com.dlsm.model.LeadBehalf;
import com.dlsm.model.export.ActivityDTO;
import com.dlsm.model.export.GradeExport;
import com.dlsm.model.vo.*;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.LinkedList;
import java.util.List;

/**
 * 活动管理Mapper接口
 *
 * @author xunfeng
 * @date 2022-03-02
 */
@Mapper
public interface ActivityMapper {

    // 查询信访总量分析表
    public List<Activity> selectActivityList(@Param("deptIdList") String deptIdList,@Param("deptId")  String deptId,@Param("startTime")  Date startTime,@Param("endTime")  Date endTime);

    // 查询热点问题
    public List<Activity> selectHotSpotActivityList(@Param("deptIdList") String deptIdList,@Param("deptId")  String deptId,@Param("startTime")  Date startTime,@Param("endTime")  Date endTime,@Param("registerTypeIdList")  String registerTypeIdList);

    LinkedList<ActivityDTO> selectByActivityDtoToExport(ActivityVO activityVO);

    List<ActivityVO> selectByXFZBToExport(ActivityVO activityVO);

    List<ActivityVO1> networkList(@Param("id") String id);

    List<ActivityVO1> hierarchyList(GradeExport gradeExport);

    List<ActivityVO> selectByXfdj(ActivityVO activityVO);

    List<ActivityVO2> behalfList(AffiliationMatter affiliationMatter);

    List<ActivityDTO> selectCustom(ZdyQuery zdyQuery);

    List<ActivityDTO> selectXFRSX(MatterQuery matterQuery);

    public List<LeadBehalf> cxLD(LeadBehalf leadBehalf);
}

