package com.dlsm.mapper;



import com.dlsm.model.*;
import com.dlsm.model.dto.ActivityDto1;
import com.dlsm.model.dto.MatterDto;
import com.dlsm.model.export.MatterDTO2;
import com.dlsm.model.export.MatterExport;
import com.dlsm.model.export.PersonExport;
import com.dlsm.model.vo.*;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 固定报表接口导出
 *
 * @author xunfeng
 * @date 2022-03-02
 */
@Mapper
public interface ExportMapper {

   /**
    * 查询个人
    * @param id
    * @return
    */
   Person selectPerson(@Param("id") Long id);

   /**
    * 查询初重
    * @param id
    * @return
    */
   List<MatterDto> personInitial(@Param("id") Long id);

   /**
    * 反映次数
    * @param id
    * @return
    */
   int number1(@Param("id") String id);

   /**
    * 人民群众信访（活动）登记信息和主信访人信息
    * @param id
    * @return
    */
   ActivityVO2 peopleActivity(@Param("id") String id);


   List<MatterRelationVo> relationList(String id);

//
   MatterExport selectMatterById(String id);


   List<Activity_Person> selectActivityIDById(String id);

   List<PersonExport> selectPersons (PersonExport personExport);


   /**
    * 查询三级地址
    * @param id
    * @return
    */
   String selectDomicileById(String id);

   List<Matter> selectMatters(MatterDTO2 matterDTO2);



   /**
    * 依法分类处理情况统计表（三级通用）
    * @param affiliationMatter
    * @return
    */
   List<MatterDto> exclFLtjList(AffiliationMatter affiliationMatter);


   /**
    * 信访事项所属系统统计表（三级通用）
    * @param affiliationMatter
    * @return
    */
   List<ActivityDto1> exclXfSsxtList(AffiliationMatter affiliationMatter);

   /**
    *信访事项所属属地统计表（三级通用）
    * @param matterVO
    * @return
    */
   List<ActivityDto1> exclXfSsSdList(AffiliationMatterVO matterVO);


}
