package com.dlsm.mapper;


import com.dlsm.model.Activity;
import com.dlsm.model.Label;
import com.dlsm.model.Matter;
import com.dlsm.model.export.ActivityDTO;
import com.dlsm.model.vo.MatterQuery;
import com.dlsm.model.dto.MatterDto;
import com.dlsm.model.vo.MatterVO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 信访事项管理Mapper接口
 *
 * @author xunfeng
 * @date 2022-03-02
 */
@Mapper
public interface MatterMapper {

    // 查询信访事项
    List<Matter> selectMatterList(@Param("activityList") List<Activity> activityList);

    // 根据分类ID查询分类名称
    List<String> selectLFReasonID(String identifying);

    // 根据来访原因ID查询子id
    String selectDescriptionByDictValue(String dictValue);

    // 根据来访原因ID查询子父id
    String selectParentIdById(String identifying);

    // 查询热点问题字典表
    List<Label> selectHotSpotType();

    //人民群众信访基本信息
    MatterDto MessageAbstract(@Param("id")String id);

    //事项基本信息多次反馈
    List<MatterDto> MessageList(@Param("newRelation")  List<String> newRelation);

    //本系统办理情况
    List<MatterDto> TransactList(@Param("newRelation")  List<String> newRelation);

    //查询人 的基本信息
    List<Matter> networkMatterList(@Param("matterID")  String matterID);

    //查询 同一信访事项涉及的参与集体（群体）走访和联名信署名的人员名单
    List<MatterVO> morePersonList(@Param("id")  String id);

    //本次反映事项
    MatterDto onceMatter(@Param("id")  String id);


    //重复信访查询
    List<ActivityDTO> selectRepeatXf(MatterQuery matterQuery);

    //领导代表查询
    List<ActivityDTO> selectLeader(MatterQuery matterQuery);

    List<ActivityDTO> excludeExcelCollectiveResponse(MatterQuery matterQuery);

    List<MatterVO> selectSXZJQX(MatterQuery matterQuery);

    //15.上级交办转送件处理情况统计表
    List<MatterVO> selectSJJBZSQK(MatterQuery matterQuery);
    // 10 12 集体访（联名信）问题属地统计表
    List<MatterVO> selectWTSD(MatterQuery matterQuery);

    // 根据传入的问题分类value查询父value
    String selectParentValueByDictValue(String identifying);
}
