package com.dlsm.model;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@Data
@AllArgsConstructor
@NoArgsConstructor
@Builder
public class Lettermanage {

     /**登录的单位id*/
     private String  UserId;

    /**部门的单位id*/
    private String  DeptId;

     /**开始时间*/
     @DateTimeFormat(pattern ="yyyy-MM-dd")
     @JsonFormat(pattern="yyyy-MM-dd",timezone = "GMT+8")
     private Date  startTime;

     /**结束时间*/
     @DateTimeFormat(pattern ="yyyy-MM-dd")
     @JsonFormat(pattern="yyyy-MM-dd",timezone = "GMT+8")
     private Date  endTime;

      /**活动办理结束时间*/
     @DateTimeFormat(pattern ="yyyy-MM-dd")
     @JsonFormat(pattern="yyyy-MM-dd",timezone = "GMT+8")
     private Date createTime;

     /** 记录活动开始时间 */
     @DateTimeFormat(pattern ="yyyy-MM-dd")
     @JsonFormat(pattern="yyyy-MM-dd",timezone = "GMT+8")
     private Date time;

      /**办理方式*/
     private String handleModel;

    /**办理方式*/
    private String handleModelID;





    /** 创建单位的多个*/
    private String  createOrgIDS;

    /** 创建单位Id*/
    private Integer  createOrgID;

    /**是否受理*/
    private  Integer isAccept;

    /** 人工判断是否受理*/
    private  Integer isAcceptPerson;

    /** 组织名称 */
    private String orgName;

    /**1是人大，2审判机关，3检察机关，4纪检监察，0行政机关*/
    private Integer isRenDa;

    /**人大常委会代理机构设置为1*/
    private Integer agent;

    /**活动id*/
    private String activityID;

    /**信访来源编号*/
    private String  xfSourceID;

    /** 文字描述 */
    private String content;

    /**去向单位id*/
    private  Integer finalDisposalID;

    public String getUserId() {
        return UserId;
    }

    public void setUserId(String userId) {
        UserId = userId;
    }

    public Date getStartTime() {
        return startTime;
    }

    public void setStartTime(Date startTime) {
        this.startTime = startTime;
    }

    public Date getEndTime() {
        return endTime;
    }

    public void setEndTime(Date endTime) {
        this.endTime = endTime;
    }


    public String getHandleModel() {
        return handleModel;
    }

    public void setHandleModel(String handleModel) {
        this.handleModel = handleModel;
    }

    public String getHandleModelID() {
        return handleModelID;
    }

    public void setHandleModelID(String handleModelID) {
        this.handleModelID = handleModelID;
    }



    public String getCreateOrgIDS() {
        return createOrgIDS;
    }

    public void setCreateOrgIDS(String createOrgIDS) {
        this.createOrgIDS = createOrgIDS;
    }

    public Integer getIsAccept() {
        return isAccept;
    }

    public void setIsAccept(Integer isAccept) {
        this.isAccept = isAccept;
    }

    public Integer getIsAcceptPerson() {
        return isAcceptPerson;
    }

    public void setIsAcceptPerson(Integer isAcceptPerson) {
        this.isAcceptPerson = isAcceptPerson;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public String getDeptId() {
        return DeptId;
    }

    public void setDeptId(String deptId) {
        DeptId = deptId;
    }

    public String getOrgName() {
        return orgName;
    }

    public void setOrgName(String orgName) {
        this.orgName = orgName;
    }

    public Integer getIsRenDa() {
        return isRenDa;
    }

    public void setIsRenDa(Integer isRenDa) {
        this.isRenDa = isRenDa;
    }

    public Integer getAgent() {
        return agent;
    }

    public void setAgent(Integer agent) {
        this.agent = agent;
    }

    public String getActivityID() {
        return activityID;
    }

    public void setActivityID(String activityID) {
        this.activityID = activityID;
    }

    public String getXfSourceID() {
        return xfSourceID;
    }

    public void setXfSourceID(String xfSourceID) {
        this.xfSourceID = xfSourceID;
    }

    public Integer getCreateOrgID() {
        return createOrgID;
    }

    public void setCreateOrgID(Integer createOrgID) {
        this.createOrgID = createOrgID;
    }

    public Integer getFinalDisposalID() {
        return finalDisposalID;
    }

    public void setFinalDisposalID(Integer finalDisposalID) {
        this.finalDisposalID = finalDisposalID;
    }
}
