package com.dlsm.model;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Date;

@Data
@AllArgsConstructor
@NoArgsConstructor
@Builder
public class Matter {

    /** 事项id */
    private String id;

    /** 信访来源 */
    private Integer isAccept;

    /** 信访原因 */
    private String lfReason;

    /** 信访原因编号 */
    private String lfReasonID;

    /** 纪检监察的主要问题分类ID */
    private String contentClassifyMainID;

    /** 纪检监察的主要问题分类 */
    private String contentClassifyMain;

    /** 所属内容分类 */
    private String contentClassify;

    /** 所属内容分类编号 */
    private String contentClassifyID;

    /** 去向单位 */
    private String finalDisposal;

    /** 去向单位Id */
    private Integer finalDisposalID;

    /** 信访问题发生所属系统 */
    private String belongs;

    /** 信访问题发生所属系统id */
    private String belongsID;

    /** 问题属地 */
    private String happenRegion;

    /** 问题属地编号 */
    private String happenRegionID;

    /** 问题发生详细地址 */
    private String happenAddress;

    /** 信访内容 */
    private String content;

    /** 关键词 */
    private String keyWord;

    /** 热点问题分类 */
    private String hotspot;

    /** 是否三跨三分离 */
    private Integer isSKSFL;

    /** 信访简称 */
    private String xfjc;

    /** 活动表Id */
    private String activityID;

    /** 办理方式 */
    private String handleModel;

    /** 办理方式编号 */
    private String handleModelID;

    /** 事项编号 */
    private String matterNum;

    /** 事项名称 */
    private String xfName;

    /** 初重情况 */
    private String visit;

    /** 初重情况Id */
    private String visitID;

    /** 流程Id */
    private Integer taskid;

    /** 创建者 */
    private String createPerson;

    /** 创建人账号 */
    private String createAccount;

    /** 创建单位 */
    private String createOrg;

    /** 创建单位ID */
    private Integer createOrgID;

    /** 创建时间 */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;

    /** 问题分类id */
    private String ccmID;

    /**
     * 是否受理范围人工判断0受理
     */
    private String isAcceptPerson;

}
