package com.dlsm.model.export;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import com.alibaba.excel.annotation.write.style.HeadStyle;
import com.alibaba.excel.enums.poi.FillPatternTypeEnum;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;


/** 信访活动为主的导出对象
 * Created with IntelliJ IDEA.
 *
 * @Author: dzy
 * @Date: 2022/03/23/10:10
 * @Description:
 */
@Data
@ColumnWidth(15)
@HeadStyle(fillPatternType = FillPatternTypeEnum.SOLID_FOREGROUND, fillForegroundColor = 13)
public class ActivityDTO {

    /** 信访活动 */
    private String id;
    private String mrId;
    @ExcelProperty("序号")
    private String number;
    @ExcelProperty("重复次数")
    private String count;
    @ExcelProperty("信访来源")
    private String xfSource;
    @ExcelProperty("信访性质")
    private String xfNature;
    @ExcelProperty("信访类型")
    private String xfType;
    @ExcelProperty("信访人数")
    private String xfNumber;
    @ExcelProperty("信访登记类型")
    private String registerType;
    @ExcelProperty("是否异常")
    private String isAbnormal;
    @ExcelProperty("异常编号")
    private String abnormalID;
    @ExcelProperty("登记时间")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private String createTime;
    @ExcelProperty("登记人姓名")
    private String createPerson;
    @ExcelProperty("登记单位")
    private String createOrg;
    @ExcelProperty("事项编号")
    private String matterID;
    @ExcelProperty("人员id")
    private String personID;
    //因前端逻辑特殊处理 存放人员姓名返回 （原内容：主信访人Id）
    @ExcelProperty("主信访人")
    private String mainPerson;
    @ExcelProperty("活动编号")
    private String activityNum;
    @ExcelProperty("登记地点")
    private String registerPlace;
    @ExcelProperty("登记地点Id")
    private String meetingID;
    @ExcelProperty("是否大会版")
    private String isMeeting;
    @ExcelProperty("大会届次")
    private String meetingSession;

    /** 信访人 */
    @ExcelProperty("姓名")
    private String name;
    @ExcelProperty("性别")
    private String sex;
    @ExcelProperty("出生日期")
    private String birthday;
    @ExcelProperty("证件类型")
    private String IDType;
    @ExcelProperty("证件号码")
    private String IDNumber;
    @ExcelProperty("来访人身份")
    private String identity;
    @ExcelProperty("国家和地区")
    private String nationality;
    @ExcelProperty("民族")
    private String nation;
    @ExcelProperty("身份证所属地区")
    private String idCardRegion;
    @ExcelProperty("户口所在地")
    private String domicile;
    @ExcelProperty("现住地址所属地区")
    private String addressRegion;
    @ExcelProperty("现住详细地址")
    private String address;
    @ExcelProperty("政治身份")
    private String political;
    @ExcelProperty("学历")
    private String education;
    @ExcelProperty("职业")
    private String profession;
    @ExcelProperty("工作单位")
    private String company;
    @ExcelProperty("手机")
    private String mobilePhone;
    @ExcelProperty("电话")
    private String telephone;
    @ExcelProperty("微信号")
    private String weChat;
    @ExcelProperty("QQ")
    private String qq;
    @ExcelProperty("邮政编码")
    private String postCode;
    @ExcelProperty("邮箱地址")
    private String 邮箱地址;
    @ExcelProperty("通讯地址所属地区")
    private String postalRegion;
    @ExcelProperty("通讯地址详细地址")
    private String postal;

    /** 信访事项 */
    @ExcelProperty("是否受理范围")
    private String isAccept;
    @ExcelProperty("来访原因")
    private String lfReason;
    @ExcelProperty("所属内容分类1")
    private String contentClassify1;
    @ExcelProperty("所属内容分类2")
    private String contentClassify2;
    @ExcelProperty("所属内容分类3")
    private String contentClassify3;
    @ExcelProperty("所属内容分类4")
    private String contentClassify4;
    @ExcelProperty("所属内容分类5")
    private String contentClassify5;

    private String contentClassify;
    private String contentClassifyID;
    @ExcelProperty("去向单位")
    private String finalDisposal;
    @ExcelProperty("信访问题所属系统")
    private String belongs;
    @ExcelProperty("问题属地")
    private String happenRegion;
    @ExcelProperty("问题发生详细地址")
    private String happenAddress;
    @ExcelProperty("信访摘要")
    private String matterAbstract;
    @ExcelProperty("热点问题标签")
    private String hotspot;
    @ExcelProperty("个人标签")
    private String personspot;
    @ExcelProperty("是否三跨三分离")
    private String isSKSFL;
    @ExcelProperty("三跨三分离情况")
    private String SKSFL;
    @ExcelProperty("登记时间")
    private String matterCreateTime;
    @ExcelProperty("登记人")
    private String mattterCreatePerson;
    @ExcelProperty("登记单位")
    private String matterCreateOrg;
    @ExcelProperty("办理方式")
    private String handleModel;
    @ExcelProperty("去向单位地区")
    private String finalZone;
    @ExcelProperty("去向单位地区编号")
    private String finalZoneID;
    @ExcelProperty("是否信访主体")
    private String isSubject;
    @ExcelProperty("主体类型")
    private String subjectType;
    @ExcelProperty("与主体关系")
    private String relationWithSubject;
    @ExcelProperty("信访主体姓名(名称)")
    private String objectName;
    @ExcelProperty("被反映身份类型")
    private String identityType;
    @ExcelProperty("被反映人所属系统")
    private String identityBelongs;
    @ExcelProperty("被反映人姓名(名称)")
    private String identityName;
    @ExcelProperty("被反映人单位")
    private String identityDept;
    @ExcelProperty("被反映人级别")
    private String identityLevel;
    @ExcelProperty("被反映人职务")
    private String identityPost;
    @ExcelProperty("是否受理范围人工判断")
    private String isAcceptPerson;
    @ExcelProperty("查询统计用问题分类Id")
    private String ccmID;
    @ExcelProperty("初重情况")
    private String visit;
    @ExcelProperty("是否大会版")
    private String matterIsMeeting;
    @ExcelProperty("大会届次")
    private String matterMeetingSession;
    @ExcelProperty("事项名称")
    private String xfName;

    @ExcelProperty("是否需要反馈")
    private String isAnswer;

    public ActivityDTO() {
    }

    public ActivityDTO(String number, String xfSource, String xfNature, String xfType, String isAccept, String lIfReason, String contentClassifyMain) {
        this.number = number;
        this.xfSource = xfSource;
        this.xfNature = xfNature;
        this.xfType = xfType;
        this.isAccept = isAccept;
        this.lfReason = lIfReason;
    }
}
