package com.dlsm.model.vo;

import com.dlsm.utils.StringUtils;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;
import org.apache.ibatis.type.Alias;

import java.util.Collections;
import java.util.List;
import java.util.Objects;

/** 自定义查询 子类bean 属性
 * Created with IntelliJ IDEA.
 *
 * @Author: dzy
 * @Date: 2022/04/24/10:57
 * @Description:
 */
@Data
public class CustomQuery {
    /**
     *  开始时间
     */
    private String startTime;
    /**
     *  结束时间
     */
    private String endTime;

    // Activity 表
    /**  活动编号 */
    private String activityNum;
    /** 信访人数 */
    private Integer xfNumber;
    /** 信访来源编号 */
    private List<String> xfSourceID;
    /** 信访类型编号 */
    private List<String> xfTypeID;
    /** 信访登记类型编号 */
    private List<String> registerTypeID;


    //Matter
    /** 是否受理 */
    private Integer isAccept;
    /**是否受理范围人工判断0受理*/
    private String isAcceptPerson;
    /** 信访原因编号 */
    private List<String> lfReasonID;
    /** 所属内容分类编号 */
    private String contentClassifyID;
    /** 信访问题发生所属系统id */
    private List<String> belongsID;
    /** 问题属地编号 */
    private List<String> happenRegionID;
    /** 信访摘要*/
    @JsonProperty("abstract")
    private String mAbstract;
    /** 热点问题标签 */
    private String hotspot;
    /** 个人标签*/
    private String personspot;
    /** 是否三跨三分离1是0否 */
    private String isSKSFL;
    /** 事项编号 */
    private String matterNum;
    private String xfName;
    private List<String> handleModelID;
    private String finalZoneID;
    private String finalDisposalID;
    private String visitID;
    private String isAnswer;

    //信访人条件
    /**是否匿名 0非匿名，1匿名 */
    private String isAnonymous;
    private String name;
    private String IDTypeID;
    private String IDNumber;
    private String identityID;
    private String nationalityID;
    private String nationID;
    private String address;
    private String politicalID;
    private String educationID;
    private String company;
    private String mobilePhone;
    private String telephone;
    private String weChat;
    private String qq;
    private String postCode;
    private String email;
    private String postal;
    private List<String> idCardRegionID;
    private List<String> domicileID;
    private List<String> addressRegionID;

    //All
    /** 创建者 登记人姓名*/
    private String createPerson;
    /**创建单位Id*/
    private List<String> createOrgID;

    public static boolean checkIsNull(CustomQuery customQuery) {
        Boolean boole = true;

        if (!StringUtils.isBlank(customQuery.startTime)
            || !StringUtils.isBlank(customQuery.endTime)
            || !StringUtils.isBlank(customQuery.activityNum)
            || !StringUtils.isBlank(customQuery.isAcceptPerson)
            || !StringUtils.isBlank(customQuery.contentClassifyID)
            || !StringUtils.isBlank(customQuery.mAbstract)
            || !StringUtils.isBlank(customQuery.hotspot)
            || !StringUtils.isBlank(customQuery.personspot)
            || !StringUtils.isBlank(customQuery.isSKSFL)
            || !StringUtils.isBlank(customQuery.matterNum)
            || !StringUtils.isBlank(customQuery.xfName)
            || !StringUtils.isBlank(customQuery.finalZoneID)
            || !StringUtils.isBlank(customQuery.finalDisposalID)
            || !StringUtils.isBlank(customQuery.visitID)
            || !StringUtils.isBlank(customQuery.isAnswer)
            || !StringUtils.isBlank(customQuery.isAnonymous)
            || !StringUtils.isBlank(customQuery.name)
            || !StringUtils.isBlank(customQuery.IDTypeID)
            || !StringUtils.isBlank(customQuery.IDNumber)
            || !StringUtils.isBlank(customQuery.identityID)
            || !StringUtils.isBlank(customQuery.nationalityID)
            || !StringUtils.isBlank(customQuery.nationID)
            || !StringUtils.isBlank(customQuery.address)
            || !StringUtils.isBlank(customQuery.politicalID)
            || !StringUtils.isBlank(customQuery.educationID)
            || !StringUtils.isBlank(customQuery.company)
            || !StringUtils.isBlank(customQuery.mobilePhone)
            || !StringUtils.isBlank(customQuery.telephone)
            || !StringUtils.isBlank(customQuery.weChat)
            || !StringUtils.isBlank(customQuery.qq)
            || !StringUtils.isBlank(customQuery.postCode)
            || !StringUtils.isBlank(customQuery.email)
            || !StringUtils.isBlank(customQuery.postal)
            || !StringUtils.isBlank(customQuery.createPerson)
            || !StringUtils.isNull(customQuery.xfNumber)
            || !StringUtils.isNull(customQuery.isAccept)
            || (!Objects.isNull(customQuery.xfSourceID) && customQuery.xfSourceID.size() > 0)
            || (!Objects.isNull(customQuery.xfTypeID) && customQuery.xfTypeID.size() > 0)
            || (!Objects.isNull(customQuery.registerTypeID) && customQuery.registerTypeID.size() > 0)
            || (!Objects.isNull(customQuery.lfReasonID) && customQuery.lfReasonID.size() > 0)
            || (!Objects.isNull(customQuery.belongsID) && customQuery.belongsID.size() > 0)
            || (!Objects.isNull(customQuery.happenRegionID) && customQuery.happenRegionID.size() > 0)
            || (!Objects.isNull(customQuery.handleModelID) && customQuery.handleModelID.size() > 0)
            || (!Objects.isNull(customQuery.idCardRegionID) && customQuery.idCardRegionID.size() > 0)
            || (!Objects.isNull(customQuery.domicileID) && customQuery.domicileID.size() > 0)
            || (!Objects.isNull(customQuery.addressRegionID) && customQuery.addressRegionID.size() > 0)
            || (!Objects.isNull(customQuery.createOrgID) && customQuery.createOrgID.size() > 0)) {
            boole = false;
        }
        return boole;
    }
}














