package com.dlsm.model.vo;

import com.dlsm.utils.DateTimeUtils;
import lombok.Data;

import java.text.ParseException;
import java.util.Date;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 *
 * @Author: dzy
 * @Date: 2022/04/07/14:56
 * @Description:
 */
@Data
public class   MatterQuery {

    /**
     *  0:以activity 为主表
     *  1:以matter 为主表
     */
    private String major = "0";
    /**
     *  动态合并列
     */
    private List<String> merge;

    /**
     *  动态单独列
     */
    private List<String> alone;

    /**
     *  开始时间
     */
    private String startTime;
    /**
     *  结束时间
     */
    private String endTime;
    private String orgName;

    /**
     *  历年开始时间
     */
    private String orgStartTime;
    /**
     *  历年结束时间
     */
    private String orgEndTime;
    /**
     *  信访形式
     */
    private List<String> xfSourceID;
    /**
     * 创建单位Id
     */
    private List<String> createOrgID;
    /**
     * 最少重复数
     */
    private String minNum;

    /**
     * 信访人姓名
     */
    private String name;

    /**
     * 登记单位Ids
     */
    private List<String> orgID;

    /**
     * 代表层级
     */
    private String grade;

    /**
     * 代表 届次
     */
    private String due;

    /**
     * 代表地区ID
     */
    private String zoneID;

    /**
     * 来访最小人数
     */
    private Integer xfNumber;

    /**
     * 诉求主体名称
     */
    private String objectName;

    /**
     * 问题属地
     */
    private List<String> happenRegionID;

    /**
     * 所属系统
     */
    private List<String> belongsID;

    /**
     * 被控检人姓名
     */
    private String identityName;

    /**
     * 是否三跨三分离情况
     */
    private String isSKSFL;
    /**
     * 三跨三分离情况
     */
    private List<String> SKSFL;

    /**
     * 是否提交
     */

    private String submit;
    /**
     * 是否异常
     */
    private String isAbnormal;
    /**
     *异常信访查询
     */
    private List<String> abnormalID;

    /**
     * 来信、来访、网上反映、来电信访事项 类型
     */
    private List<String> registerTypeIDs;

    private List<String> registerTypeID;

    /**
     * 排序类型
     */
    private String 	orderByType;

    /**
     * 信访类型编号
     */
    private List<String> xfTypeID;

    /**
     * 是否需要反馈
     */
    private String isAnswer;

    /**
     * 设置同比时间
     */
    public void setTime(){
        setStartTime(getOrgStartTime());
        setEndTime(getOrgEndTime());
    }
    /**
     * 设置当年时间
     */
    public void setCurrent(){
        setStartTime(DateTimeUtils.formatDate(DateTimeUtils.getCurrYearFirst()));
        setEndTime(DateTimeUtils.formatDate(new Date()));
    }
    /**
     * 设置历年时间
     */
    public void setOrgCurrent() throws ParseException {
        setStartTime(DateTimeUtils.getOrgStartTime());
        setEndTime(DateTimeUtils.getOrgEndTime());
    }
}
