package com.dlsm.service;


import com.dlsm.model.AffiliationMatter;
import com.dlsm.model.dto.ActivityDto;
import com.dlsm.model.export.ActivityDTO;
import com.dlsm.model.export.XfzbDTO;
import com.dlsm.model.vo.ActivityVO;
import com.dlsm.model.vo.MatterQuery;
import com.dlsm.model.vo.ZdyQuery;

import java.text.ParseException;
import java.util.*;

/**
 * 人活动管理Service接口
 *
 * @author xunfeng
 * @date 2022-03-02
 */

public interface ActivityService {

    // 查询信访总量分析表
    Map<String, Object> petitionLetterGrossAnalyse(String deptIdList,String userId, String startTime, String endTime) throws ParseException;


    LinkedList<ActivityDTO> selectByActivityDtoToExport(ActivityVO activityVO);

    /**
     * 查询-信访指标列表
     * @param activityVO
     * @return
     */
    List<ActivityVO> selectByXFZBToExport(ActivityVO activityVO);

    /**
     * 导出-信访指标
     * @param activityVO
     * @return
     * @throws ParseException
     */
    List<XfzbDTO> excludeExcelXfzb(ActivityVO activityVO) throws ParseException;

    /**
     * 本级代表反应信访事项统计表
     * @param affiliationMatter
     * @return
     */
    Map<String, List<ActivityDto>>  behalfList(AffiliationMatter affiliationMatter) throws ParseException;

    /**
     *  信访登记统计表
     * @param activityVO
     * @param type 2：省级  3：市级
     * @return
     */
    LinkedList<Map> excludeExcelXfdj(ActivityVO activityVO, int type);
    /**
     * 人大常委会及机关、工委领导接访阅信情况统计表（三级通用）
     * @param affiliationMatter
     * @return
     * @throws ParseException
     */
    Map<String, List<ActivityDto>>  leadList(AffiliationMatter affiliationMatter) throws ParseException;



    /**
     *本级及下一级人大领导接访阅信统计表（省、市级用）
     * @param affiliationMatter
     * @return
     * @throws ParseException
     */
    Map<String, Object>  NpcCongressList(AffiliationMatter affiliationMatter) throws ParseException;

    /**
     * 自定义查询导出
     * @param zdyQuery
     * @return
     */
    List<ActivityDTO> excludeZDY(ZdyQuery zdyQuery);

    /**
     * 所属内容分类拆分
     * @param list
     * @return
     */
    List<ActivityDTO> checkContentClassify(List<ActivityDTO> list);

    /**
     * 信访人所有信访事项查询
     * @param matterQuery
     * @return
     */
    List<ActivityDTO> excludeXFRSX(MatterQuery matterQuery);
}
