package com.dlsm.service;


import com.dlsm.model.AffiliationMatter;
import com.dlsm.model.Dictionary;
import com.dlsm.model.LeadBehalf;
import com.dlsm.model.Person;
import com.dlsm.model.dto.ActivityDto;
import com.dlsm.model.dto.ActivityDto1;
import com.dlsm.model.export.GradeExport;
import com.dlsm.model.export.MatterDTO2;
import com.dlsm.model.export.PersonExport;
import com.dlsm.model.vo.AffiliationMatterVO;

import java.text.ParseException;
import java.util.List;
import java.util.Map;

/**
 * 固定报表导出
 *
 * @author xunfeng
 * @date 2022-03-03
 */
public interface ExportService {

    /**
     * 查询个人信息
     * @param id
     * @return
     */
    Person selectPerson(Long id);

    /**
     * 查询本系统记录信息
     * @param id
     * @return
     */
    Map<String, Object> personInitial(Long id);


    /**
     * 同件网上联名反映署名人员名单
     * @param id
     * @return
     */
    Map<String, Object> networkList(String id);

    /**
     *人民群众信访（活动）登记摘录单
     * @param id
     * @return
     */
    Map<String, Object> peopleActivity(String id);

    /**
     * 各层级代表反映信访事项情况表(三级通用)
     * @param gradeExport
     * @return
     */
    Map<String, Object> GradeExportList(GradeExport gradeExport) throws ParseException;


    /**
     * 重复反映信访事项排查表
     * @param matterDTO2
     * @return
     */
    List<Map<String,Object>> matterExclude(MatterDTO2 matterDTO2);

    List<Map<String,Object>> matterOldUser(PersonExport personExport);


    /**
     * 依法分类处理情况统计表（三级通用）
     * @param affiliationMatter
     * @return
     * @throws ParseException
     */
    List<ActivityDto> exclFLtjList(AffiliationMatter affiliationMatter) throws ParseException;


    /**
     * 初重反映信访事项统计表(三级通用)
     * @param leadBehalf
     * @return
     * @throws ParseException
     */
    List<ActivityDto> exclCcXfTjList(LeadBehalf leadBehalf) throws ParseException;
    /**
     * 信访事项所属系统统计表（三级通用）
     * @param affiliationMatter
     * @return
     * @throws ParseException
     */
    List<ActivityDto1> exclXfSsxtList(AffiliationMatter affiliationMatter) throws ParseException;

    /**
     * 信访事项所属属地统计表（三级通用）
     * @param matterVO
     * @return
     * @throws ParseException
     */
    List<ActivityDto1> exclSdXfTj(AffiliationMatterVO matterVO) throws ParseException;

    Dictionary selectDictonaryByDictValue(String dictId,String postalRegionlD);
}
