package com.dlsm.service;


import com.dlsm.model.Activity;
import com.dlsm.model.Matter;
import com.dlsm.model.export.ActivityDTO;
import com.dlsm.model.export.XfzbDTO;
import com.dlsm.model.vo.MatterQuery;
import com.dlsm.model.dto.MatterDto;
import org.apache.commons.collections.map.LinkedMap;

import java.text.ParseException;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

/**
 * 信访事项管理Service接口
 *
 * @author xunfeng
 * @date 2022-03-03
 */

public interface MatterService {

    // 根据来访原因ID查询子id
    List<String> selectLFReasonID(String identifying);

    // 查询信访事项
    public List<Matter> selectMatterList(List<Activity> activityList);

    // 查询信访内容分类分析
    Map<String, Object> reactionContentClassify(String deptIdList, String userId, String startTime, String endTime,String identifying) throws ParseException;

    // 热点问题分析
    Map<String, Object> hotSpot(String deptIdList, String userId, String startTime, String endTime, String registerTypeIdList,String identifying) throws ParseException;

    //人民群众信访事项摘录单
    MatterDto MessageAbstract(String id);

    //导出-重复信访查询
    List<ActivityDTO> selectRepeatXf(MatterQuery matterQuery);

    //领导代表查询
    List<ActivityDTO> excludeExcelLeader(MatterQuery matterQuery);

    List<ActivityDTO> excludeExcelCollectiveResponse(MatterQuery matterQuery);

    //同一信访事项涉及的参与集体（群体）走访和联名信署名的人员名单
    Map<String, Object> morePersonList(String id);

    //事项转角去向统计表
    LinkedList<Map> excludeSXZJQX(MatterQuery matterQuery);

    //信访事项交办转送情况统计表
    LinkedList<XfzbDTO> excludeXSJBZSQK(MatterQuery matterQuery) throws ParseException;

    //15.上级交办转送件处理情况统计表
    LinkedList<XfzbDTO> excludeSJJBZSQK(MatterQuery matterQuery) throws ParseException;

    //集体访问题属地统计表
    LinkedList<Map> excludeWTSD(MatterQuery matterQuery);
}
