package com.dlsm.service.impl;

import com.dlsm.model.Lettermanage;
import com.dlsm.utils.CalculateUtils;
import com.dlsm.utils.DateTimeUtils;

import com.dlsm.utils.StringUtils;
import com.dlsm.mapper.AffiliationMapper;
import com.dlsm.model.AffiliationMatter;
import com.dlsm.model.Dept;
import com.dlsm.model.PetitionRation;
import com.dlsm.service.AffiliationService;
import com.dlsm.service.DeptService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;


/**
 * 活动管理Service业务层处理
 *
 * @author xunfeng
 * @date 2022-03-02
 */
@Service
public class AffiliationServiceImpl implements AffiliationService {

    @Autowired
    private AffiliationMapper affiliationMapper;



    @Autowired
    private DeptService deptService;

    @Override
    public Map<Object, Object> AffiliationList(AffiliationMatter affiliationMatter) throws ParseException {

        if (StringUtils.isEmpty(affiliationMatter.getCreateOrgIDS())) {
            List<Dept> depts = deptService.selectDeptByUserIdList(affiliationMatter.getUserId());
            if (StringUtils.isNull(affiliationMatter.getStartTime()) || StringUtils.isNull(affiliationMatter.getEndTime())) {
                for (Dept dept : depts) {
                    String OrgIDS = dept.getOrganizationId().toString();
                    if (StringUtils.isEmpty(affiliationMatter.getCreateOrgIDS())) {
                        affiliationMatter.setCreateOrgIDS(OrgIDS);
                    } else {
                        affiliationMatter.setCreateOrgIDS(affiliationMatter.getCreateOrgIDS() + "," + OrgIDS);
                    }
                }
            }
        }
        SimpleDateFormat f = new SimpleDateFormat("yyyy", Locale.CHINA);
            //  // 初始时间
            Date firstYearTime;
            Date endYearTime;

// 同比开始时间与结束时间
            Date currYearTBTime;
            Date lastYearTBTime;

// 环比开始时间与结束时间Year
            Date currYearHBTime;
            Date lastYearHBTime;

            if (affiliationMatter.getStartTime() == null) {
                // 本年的第一天
                firstYearTime = DateTimeUtils.getCurrYearFirst();
                // 本年最后一天
                endYearTime = new Date();

                // 同比时间
                currYearHBTime = DateTimeUtils.getStartHBTime(firstYearTime);
                lastYearHBTime = DateTimeUtils.getEndHBTime(endYearTime);

                // 环比时间
                currYearTBTime = DateTimeUtils.getTBTime(firstYearTime,endYearTime).get("startTBTime");
                lastYearTBTime = DateTimeUtils.getTBTime(firstYearTime,endYearTime).get("endTBTime");
            } else {

                firstYearTime = affiliationMatter.getStartTime();
                endYearTime = DateTimeUtils.getTodayTime(affiliationMatter.getEndTime());


                currYearHBTime = DateTimeUtils.getStartHBTime(affiliationMatter.getStartTime());
                lastYearHBTime = DateTimeUtils.getEndHBTime(affiliationMatter.getEndTime());


                currYearTBTime = DateTimeUtils.getTBTime(affiliationMatter.getStartTime(), affiliationMatter.getEndTime()).get("startTBTime");
                lastYearTBTime = DateTimeUtils.getTBTime(affiliationMatter.getStartTime(), affiliationMatter.getEndTime()).get("endTBTime");

            }
            //今年数据
            affiliationMatter.setStartTime(firstYearTime);
            affiliationMatter.setEndTime(endYearTime);

            List<AffiliationMatter> Matters = affiliationMapper.happenRegionList(affiliationMatter);
            List<AffiliationMatter> Newmatters = StraightPlus(Matters);
            List<AffiliationMatter> BelongsMatters = affiliationMapper.BelongsList(affiliationMatter);
            //去年数据  同比
            affiliationMatter.setStartTime(currYearTBTime);
            affiliationMatter.setEndTime(lastYearTBTime);
            List<AffiliationMatter> MattersFront = affiliationMapper.happenRegionList(affiliationMatter);
            List<AffiliationMatter> NewMattersFront = StraightPlus(MattersFront);
            List<AffiliationMatter> BelongsMattersFront = affiliationMapper.BelongsList(affiliationMatter);
            //上一阶段数据  环比
            affiliationMatter.setStartTime(currYearHBTime);
            affiliationMatter.setEndTime(lastYearHBTime);
            List<AffiliationMatter> MattersLoopRatio = affiliationMapper.happenRegionList(affiliationMatter);
            List<AffiliationMatter> NewMattersLoopRatio = StraightPlus(MattersLoopRatio);
            List<AffiliationMatter> BelongsMattersLoopRatio = affiliationMapper.BelongsList(affiliationMatter);

 // 获取的前十的数据  问题归属地
            List<PetitionRation> happenRegionlist = new ArrayList<>();
            for (AffiliationMatter matter : Newmatters) {
                //总量
                if (StringUtils.isNull(affiliationMatter.getSum())) {
                    affiliationMatter.setSum(matter.getNum());
                } else {
                    affiliationMatter.setSum(affiliationMatter.getSum() + matter.getNum());
                }
            }
            for (AffiliationMatter matter : Newmatters) {
                PetitionRation petitionRation = new PetitionRation();
                petitionRation.setName(matter.getHappenRegion());
                petitionRation.setNumber(matter.getNum());
                String happenRegionID = matter.getHappenRegionID();
                petitionRation.setGrossRatio(CalculateUtils.makeUp(matter.getNum(), affiliationMatter.getSum()));

                //去年同一属地的行政
                if (NewMattersFront.size()!=0){
                    List<AffiliationMatter> self = NewMattersFront.stream().filter((n) -> n.getHappenRegionID().equals(happenRegionID)).collect(Collectors.toList());
                    if (StringUtils.isNotEmpty(self)){
                        Integer Frontnum = self.get(0).getNum();
                               petitionRation.setCompare(CalculateUtils.IncreaseDecreaseMakeUp(matter.getNum(), Frontnum)+"%");
                    }else{
                        petitionRation.setCompare("100%");
                    }
                }else {
                    petitionRation.setCompare("100%");
                }

                //阶段环比
                if (NewMattersLoopRatio.size()!=0) {
                    List<AffiliationMatter> selfLoopRatio = NewMattersLoopRatio.stream().filter((n) -> n.getHappenRegionID().equals(happenRegionID)).collect(Collectors.toList());
                         if (StringUtils.isNotEmpty(selfLoopRatio)){
                           Integer Rationum = selfLoopRatio.get(0).getNum();
                            petitionRation.setLoopRatio(CalculateUtils.IncreaseDecreaseMakeUp(matter.getNum(), Rationum) + "%");
                         }else{
                           petitionRation.setLoopRatio("100%");
                            }
                }else {
                        petitionRation.setLoopRatio("100%");
                    }
                happenRegionlist.add(petitionRation);
            }
            for (int i = 0; i < 10; i++) {
                if ( i<=happenRegionlist.size()-1 ){
                        String name = happenRegionlist.get(i).getName();
                        if (StringUtils.isNull(affiliationMatter.getXzName())) {
                            affiliationMatter.setXzName(name);
                        } else {
                            affiliationMatter.setXzName(affiliationMatter.getXzName() + "," + name);
                        }
                }

            }
 // 获取的前十的数据  系统归属地
        List<PetitionRation> Belongslist = new ArrayList<>();
        AffiliationMatter belongs = new AffiliationMatter();
        for (AffiliationMatter belongsMatter : BelongsMatters) {
            if (StringUtils.isNull(belongs.getSum())) {
                belongs.setSum(belongsMatter.getNum());
            } else {
                belongs.setSum(belongs.getSum() + belongsMatter.getNum());
            }
        }
        for (AffiliationMatter matterBelongs : BelongsMatters) {
            if (StringUtils.isNotEmpty(matterBelongs.getBelongs())) {
                PetitionRation petitionRation = new PetitionRation();
                petitionRation.setName(matterBelongs.getBelongs());
                petitionRation.setNumber(matterBelongs.getNum());
                String belongsID = matterBelongs.getBelongsID();
                petitionRation.setGrossRatio(CalculateUtils.makeUp(matterBelongs.getNum(), belongs.getSum()));

                //去年同一属地的行政
                if (BelongsMattersFront.size()!=0) {
                    List<AffiliationMatter> self = BelongsMattersFront.stream().filter((n) -> n.getBelongsID().equals(belongsID)).collect(Collectors.toList());
                    if (StringUtils.isNotEmpty(self)){
                        Integer BelongsFrontnum = self.get(0).getNum();
                        petitionRation.setCompare(CalculateUtils.IncreaseDecreaseMakeUp(matterBelongs.getNum(), BelongsFrontnum) + "%");
                    }else {
                        petitionRation.setCompare("100%");
                           }
                }else {
                   petitionRation.setCompare("100%");
                    }
                //阶段环比
                if (BelongsMattersLoopRatio.size()!=0) {
                    List<AffiliationMatter> self = BelongsMattersLoopRatio.stream().filter((n) -> n.getBelongsID().equals(belongsID)).collect(Collectors.toList());
                       if (StringUtils.isNotEmpty(self)){
                           Integer matterLoopRatioatioNum = self.get(0).getNum();
                           petitionRation.setLoopRatio(CalculateUtils.IncreaseDecreaseMakeUp(matterBelongs.getNum(), matterLoopRatioatioNum) + "%");
                       }else {
                           petitionRation.setLoopRatio("100%");
                            }
                }else {
                       petitionRation.setLoopRatio("100%");
                        }
            Belongslist.add(petitionRation);
            }
        }
        for (int i = 0; i < 10; i++) {
            if ( i<=Belongslist.size()-1 ){
                String name = Belongslist.get(i).getName();
               if (StringUtils.isNotEmpty(name)){
                if (StringUtils.isNull(belongs.getXzName())) {
                    belongs.setXzName(name);
                } else {
                    belongs.setXzName(belongs.getXzName() + "," + name);
                }
               }
            }
        }
            Map<Object, Object> map = new HashMap<>();
            String content;
            String belongscontent;
            content = "&nbsp;"+ "&nbsp;" + DateTimeUtils.getYear(firstYearTime) + "年" + DateTimeUtils.getMonth(firstYearTime) + "月" + DateTimeUtils.getDay(firstYearTime) + "日至" + DateTimeUtils.getYear(endYearTime) + "年" + DateTimeUtils.getMonth(endYearTime) + "月" + DateTimeUtils.getDay(endYearTime) + "日,当前登记单位及所辖单位人大信访处理情" +
                    "处理的" + affiliationMatter.getSum() + "件信访事项，按照问题属地分:" + affiliationMatter.getXzName();
            belongscontent = "&nbsp;"+ "&nbsp;" + DateTimeUtils.getYear(firstYearTime) + "年" + DateTimeUtils.getMonth(firstYearTime) + "月" + DateTimeUtils.getDay(firstYearTime) + "日至" + DateTimeUtils.getYear(endYearTime) + "年" + DateTimeUtils.getMonth(endYearTime) + "月" + DateTimeUtils.getDay(endYearTime) + "日,当前登记单位及所辖单位人大信访处理情" +
                  "处理的" + affiliationMatter.getSum() + "件信访事项，按照问题所属系统分:" + belongs.getXzName();
            map.put("list", happenRegionlist);
            map.put("content", content);
            map.put("belongslist", Belongslist);
            map.put("belongscontent", belongscontent);
            return map;
        }

                /**
                 *  市 （县） 直        加到    市 （县）
                  * @param mattersPlus
                 */
            private List<AffiliationMatter>  StraightPlus(List<AffiliationMatter> mattersPlus) {
                for (AffiliationMatter matter : mattersPlus) {
                    String happenRegionID = matter.getHappenRegionID();
                    String last = happenRegionID.substring(happenRegionID.length() - 3);  //后三位
                    String begin = happenRegionID.substring(0,happenRegionID.length() - 3);  // 从前面截取 后面只剩三位未取
                    if (happenRegionID.length()>6 &&  (last).equals("000")) {
                        int numstraight = matter.getNum(); //行政 市（县） 直
                        List<AffiliationMatter> filtration = mattersPlus.stream().filter((n) -> n.getHappenRegionID().equals(begin)).collect(Collectors.toList());
                        if (StringUtils.isNotEmpty(filtration)) {
                            matter.setNum(filtration.get(0).getNum() + numstraight);
                        } else {
                            matter.setNum(matter.getNum());
                        }
                        matter.setHappenRegionID(begin);
                        matter.setHappenRegion(matter.getHappenRegion().substring(0, matter.getHappenRegion().length() - 1));
                    }
                    }

                List<AffiliationMatter> mattersSort = Sort(mattersPlus);
                return     mattersPlusmain(mattersSort);
            }

        /**
         *  按最大的排序
         * @param mattersPlus
         */
        private List<AffiliationMatter> Sort(List<AffiliationMatter> mattersPlus) {
            Collections.sort(mattersPlus, new Comparator<AffiliationMatter>() {
                @Override
                public int compare(AffiliationMatter o1, AffiliationMatter o2) {

                    int i = o2.getNum() - o1.getNum();
                    if (i == 0) {
                        return o2.getNum() - o1.getNum();
                    }
                    return i;
                }
            });
            return  mattersPlus;
        }

        /**
         *  去重 取最大的
         * @param mattersPlus
         * @return
         */
        public List<AffiliationMatter> mattersPlusmain(List<AffiliationMatter> mattersPlus) {
                ArrayList<AffiliationMatter> collect = mattersPlus.stream().collect(Collectors.collectingAndThen(Collectors.toCollection(() ->
                        new TreeSet<>(Comparator.comparing(AffiliationMatter::getHappenRegion))), ArrayList::new));
            List<AffiliationMatter> sort = Sort(collect);
            return sort;
            }

}
