package com.dlsm.service.impl;

import com.dlsm.mapper.DeptMapper;
import com.dlsm.model.Dept;
import com.dlsm.model.vo.DeptVO;
import com.dlsm.service.DeptService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * 单位管理Service业务层处理
 *
 * @author xunfeng
 * @date 2022-03-03
 */
@Service
public class DeptServiceImpl implements DeptService {

    @Autowired
    private DeptMapper deptMapper;

    // 根据用户id查询单位
    @Override
    public Dept selectDeptByUserId(String uerId) {
        return deptMapper.selectDeptByUserId(uerId);
    }

    // 根据用户id查询单位及本单位下一级
    @Override
    public List<Dept> selectDeptByUserIdList(String uerId) {
        return deptMapper.selectDeptByUserIdList(uerId);
    }

    @Override
    public LinkedList<DeptVO> selectDeptByOrgId(String orgID) {
        return deptMapper.selectDeptByOrgId(orgID);
    }
}
