package com.dlsm.service.impl;

import com.dlsm.mapper.ActivityMapper;
import com.dlsm.utils.CalculateUtils;
import com.dlsm.utils.DateTimeUtils;

import com.dlsm.utils.StringUtils;
import com.dlsm.mapper.LeadBehalfMapper;

import com.dlsm.model.Dept;
import com.dlsm.model.LeadBehalf;
import com.dlsm.service.DeptService;
import com.dlsm.service.LeadBehalfService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;

/**
 * 领导代表件情况Service业务层处理
 *
 * @author xunfeng
 * @date 2022-03-02
 */

@Service
public class LeadBehalfServiceImpl implements LeadBehalfService {

        @Autowired
        private LeadBehalfMapper behalfMapper;

        @Autowired
        private DeptService deptService;

        @Autowired
        private ActivityMapper activityMapper;

        @Override
        public Map<Object, Object> LeadBehalfList(LeadBehalf behalf) throws ParseException {

            //登录的id

            if (StringUtils.isEmpty(behalf.getCreateOrgIDS())) {
                List<Dept> depts = deptService.selectDeptByUserIdList(behalf.getUserId());
                for (Dept dept : depts) {
                    String OrgIDS = dept.getOrganizationId().toString();
                    if (StringUtils.isEmpty(behalf.getCreateOrgIDS())) {
                        behalf.setCreateOrgIDS(OrgIDS);
                    } else {
                        behalf.setCreateOrgIDS(behalf.getCreateOrgIDS() + "," + OrgIDS);
                    }
                }
            }
            SimpleDateFormat f = new SimpleDateFormat("yyyy", Locale.CHINA);

            //  // 初始时间
            Date firstYearTime;
            Date endYearTime;

            // 环比开始时间与结束时间Year
            Date currYearHBTime;
            Date lastYearHBTime;

            // 同比开始时间与结束时间
            Date currYearTBTime;
            Date lastYearTBTime;

            if (behalf.getStartTime() == null) {
                // 本年的第一天
                firstYearTime = DateTimeUtils.getCurrYearFirst();
                // 本年最后一天
                endYearTime = new Date();

                // 环比时间
                currYearTBTime = DateTimeUtils.getTBTime(firstYearTime,endYearTime).get("startTBTime");
                lastYearTBTime = DateTimeUtils.getTBTime(firstYearTime,endYearTime).get("endTBTime");

                // 同比时间
                currYearHBTime = DateTimeUtils.getStartHBTime(firstYearTime);
                lastYearHBTime = DateTimeUtils.getEndHBTime(endYearTime);
            } else {

                firstYearTime = behalf.getStartTime();
                endYearTime = DateTimeUtils.getTodayTime(behalf.getEndTime());

                currYearHBTime = DateTimeUtils.getStartHBTime(behalf.getStartTime());
                lastYearHBTime = DateTimeUtils.getEndHBTime(behalf.getEndTime());

                currYearTBTime = DateTimeUtils.getTBTime(behalf.getStartTime(), behalf.getEndTime()).get("startTBTime");
                lastYearTBTime = DateTimeUtils.getTBTime(behalf.getStartTime(), behalf.getEndTime()).get("endTBTime");

            }
  //今年数据
            behalf.setStartTime(firstYearTime);
            behalf.setEndTime(endYearTime);
            //总数
            List<LeadBehalf> leadBehalves = behalfMapper.LeadBehalfList(behalf);

            //领导件及代表件  （独立的）
            int LdDbSum = behalfMapper.LeadBehalfSum(behalf);
            int TotalNum  = leadBehalves.size();
            //领导件
            List<LeadBehalf> lead = leadBehalves.stream().filter((n) -> n.getXfSourceID().equals("001002001") ||  n.getXfSourceID().equals("001002002") ||  n.getXfSourceID().equals("002002001") || n.getXfSourceID().equals("002002002")  ).collect(Collectors.toList());
            int leadNum  = lead.size();

            //统计活动activity
            List<LeadBehalf> hdList = activityMapper.cxLD(behalf);
            int hdSum  = hdList.size();
            //领导件
            List<LeadBehalf> hdld = hdList.stream().filter((n) -> n.getXfSourceID().equals("001002001") || n.getXfSourceID().equals("001002002") || n.getXfSourceID().equals("002002001") || n.getXfSourceID().equals("002002002")).collect(Collectors.toList());
            int hdldNum  = hdld.size();

            //代表表
            List<LeadBehalf>  hddb = hdList.stream().filter((n) -> n.getXfSourceID().equals("001003") || n.getXfSourceID().equals("002003") || n.getXfSourceID().equals("001004") || n.getXfSourceID().equals("002006")).collect(Collectors.toList());
            int hddbNum  = hddb.size();

            //初次
            int firstleadNum = lead.stream().filter((n) -> n.getVisitID().equals("100")).collect(Collectors.toList()).size();
            //重复
            int moreleadNum = lead.stream().filter((n) -> n.getVisitID().equals("200")).collect(Collectors.toList()).size();

            //领导接访约访件
            List<LeadBehalf> leadJF = lead.stream().filter((n) -> n.getXfSourceID().equals("001002001") ||  n.getXfSourceID().equals("001002002")  ).collect(Collectors.toList());
            int leadJFNum  = leadJF.size();

            //领导阅批来信件
            List<LeadBehalf> read = lead.stream().filter((n) ->   n.getXfSourceID().equals("002002001") || n.getXfSourceID().equals("002002002")  ).collect(Collectors.toList());
            int readNum  = read.size();
            // 省人大常委会领导
            List<LeadBehalf> provincial = lead.stream().filter((n) -> String.valueOf(n.getType()).equals("2")   ).collect(Collectors.toList());
            int provincialNum  = provincial.size();
            // 市人大常委会领导
            List<LeadBehalf> city = lead.stream().filter((n) -> String.valueOf(n.getType()).equals("3")   ).collect(Collectors.toList());
            int cityNum  = city.size();
            // 县人大常委会领导
            List<LeadBehalf> county = lead.stream().filter((n) -> String.valueOf(n.getType()).equals("4")   ).collect(Collectors.toList());
            int countyNum  = county.size();
            // 属于人大机关处理的
            List<LeadBehalf> npcoffice = lead.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("1") ).collect(Collectors.toList());
            int npcofficeNum  = npcoffice.size();
            //涉及行政机关的XXXX件 administration
            List<LeadBehalf> administration = lead.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("0") ).collect(Collectors.toList());
            int administrationNum  = administration.size();
            //涉及审判机关的XXXX件 administration
            List<LeadBehalf> judge = lead.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("2") ).collect(Collectors.toList());
            int judgeNum  = judge.size();
            // 涉及检察机关monitor
            List<LeadBehalf> monitor = lead.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("3") ).collect(Collectors.toList());
            int monitorNum  = monitor.size();
            //涉及纪检监察机关 discipline
            List<LeadBehalf> discipline = lead.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("4") ).collect(Collectors.toList());
            int disciplineNum  = discipline.size();
            //交办处理
            List<LeadBehalf> assign = lead.stream().filter((n) -> n.getHandleModelID().equals("001003001") || n.getHandleModelID().equals("002003001") || n.getHandleModelID().equals("003003001") ||  n.getHandleModelID().equals("004003001") || n.getHandleModelID().equals("005003001") ).collect(Collectors.toList());
            int assignNum = assign.size();

            //做转送处理
            List<LeadBehalf> pass = lead.stream().filter((n) -> n.getHandleModelID().equals("001003002") || n.getHandleModelID().equals("002003002") || n.getHandleModelID().equals("003003002") || n.getHandleModelID().equals("004003002") || n.getHandleModelID().equals("005003002") ).collect(Collectors.toList());
            int passNum  = pass.size();
            // 作引导劝息、存信存件
            List<LeadBehalf> letter = lead.stream().filter((n) -> n.getHandleModelID().equals("001004") || n.getHandleModelID().equals("002004") ).collect(Collectors.toList());
            int letterNum  = letter.size();



            //转常委会办事机构办理
            List<LeadBehalf> local = npcoffice.stream().filter((n) -> String.valueOf(n.getAgent()).equals("0") ).collect(Collectors.toList());
            int localNum  = local.size();
            //转下级人大常委会
            List<LeadBehalf> downNpc = npcoffice.stream().filter((n) -> String.valueOf(n.getAgent()).equals("1") &&  !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) ).collect(Collectors.toList());
            int downNpcNum  = downNpc.size();
            //信访部门作引导劝息、存信存件
            List<LeadBehalf> Section = npcoffice.stream().filter((n) -> String.valueOf(n.getAgent()).equals("1") &&  String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID()))  ).collect(Collectors.toList());
            List<LeadBehalf> letterSection = Section.stream().filter((n) -> n.getHandleModelID().equals("001004") ||  n.getHandleModelID().equals("002004")).collect(Collectors.toList());
            int letterSectionNum = letterSection.size();
            //转行政机关
            List<LeadBehalf> turnXZ = lead.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("0") &&  !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID()))  ).collect(Collectors.toList());
            int turnXZNum  = turnXZ.size();
            //转审判机关
            List<LeadBehalf> turnSP = lead.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("2") &&  !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID()))  ).collect(Collectors.toList());
            int turnSPNum  = turnSP.size();
            //转检察机关
            List<LeadBehalf> turnJC = lead.stream().filter((n) ->   !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) && String.valueOf(n.getIsRenDa()).equals("3")  ).collect(Collectors.toList());
            int turnJCNum  = turnJC.size();
            //转纪检监察
            List<LeadBehalf> turnJJ = lead.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("4") &&  !String.valueOf(n.getCreateOrgID()).equals (String.valueOf(n.getFinalDisposalID()))  ).collect(Collectors.toList());
            int turnJJNum  = turnJJ.size();

            //代表件
            List<LeadBehalf> behalfletter = leadBehalves.stream().filter((n) -> n.getXfSourceID().equals("001003") ||  n.getXfSourceID().equals("002003") ||  n.getXfSourceID().equals("001004") || n.getXfSourceID().equals("002006")  ).collect(Collectors.toList());
            int behalfletterNum  = behalfletter.size();
            int firstbehalfNum = behalfletter.stream().filter((n) -> n.getVisitID().equals("100")).collect(Collectors.toList()).size();
            //重复
            int morebehalfNum = behalfletter.stream().filter((n) -> n.getVisitID().equals("200")).collect(Collectors.toList()).size();
            //代表来访
            List<LeadBehalf> visitor = behalfletter.stream().filter((n) -> n.getXfSourceID().equals("001004")).collect(Collectors.toList());
            int visitorNum  = visitor.size();
            //代表引导来访
            List<LeadBehalf> guidevisitor = behalfletter.stream().filter((n) -> n.getXfSourceID().equals("001003")).collect(Collectors.toList());
            int guidevisitorNum  = guidevisitor.size();
            //代表来信
            List<LeadBehalf> lettervisitor = behalfletter.stream().filter((n) -> n.getXfSourceID().equals("002006")).collect(Collectors.toList());
            int lettervisitorNum  = lettervisitor.size();
            //代表转信
            List<LeadBehalf> transferletter = behalfletter.stream().filter((n) -> n.getXfSourceID().equals("002003")).collect(Collectors.toList());
            int transferletterNum  = transferletter.size();

            //全国人大代表件
            List<LeadBehalf> nationmember = behalfletter.stream().filter((n) -> String.valueOf(n.getType()).equals("1")   ).collect(Collectors.toList());
            int nationmemberNum  = nationmember.size();
            //省人大代表件
            List<LeadBehalf> provincemember = behalfletter.stream().filter((n) -> String.valueOf(n.getType()).equals("2")   ).collect(Collectors.toList());
            int provincememberNum  = provincemember.size();
            //市级人大代表件
            List<LeadBehalf> citymember = behalfletter.stream().filter((n) -> String.valueOf(n.getType()).equals("3")   ).collect(Collectors.toList());
            int citymemberNum  = citymember.size();
            //县级人大代表件
            List<LeadBehalf> townsmember = behalfletter.stream().filter((n) -> String.valueOf(n.getType()).equals("4")   ).collect(Collectors.toList());
            int townsmemberNum  = townsmember.size();

            //属于人大机关处理
            List<LeadBehalf> behalfleadnpc = behalfletter.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("1") ).collect(Collectors.toList());
            int behalfleadnpcNum  = behalfleadnpc.size();
            //涉及行政机关
            List<LeadBehalf> behalfleadXZ = behalfletter.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("0") ).collect(Collectors.toList());
            int behalfleadXZNum  = behalfleadXZ.size();
            //涉及审判机关
            List<LeadBehalf> behalfleadSP = behalfletter.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("2") ).collect(Collectors.toList());
            int behalfleadSPNum  = behalfleadSP.size();
            //涉及检察机关
            List<LeadBehalf> behalfleadJC = behalfletter.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("3") ).collect(Collectors.toList());
            int behalfleadJCNum  = behalfleadJC.size();
            //涉及纪检监察机关
            List<LeadBehalf> behalfleadJJ = behalfletter.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("4") ).collect(Collectors.toList());
            int behalfleadJJNum  = behalfleadJJ.size();

            //分类处理情况：
            //作交办处理的
            List<LeadBehalf> behalfassign = behalfletter.stream().filter((n) -> n.getHandleModelID().equals("001003001") || n.getHandleModelID().equals("002003001") || n.getHandleModelID().equals("003003001") ||  n.getHandleModelID().equals("004003001") || n.getHandleModelID().equals("005003001") ).collect(Collectors.toList());
            int behalfassignNum = behalfassign.size();

            //做转送处理
            List<LeadBehalf> behalfpass = behalfletter.stream().filter((n) -> n.getHandleModelID().equals("001003002") || n.getHandleModelID().equals("002003002") || n.getHandleModelID().equals("003003002") || n.getHandleModelID().equals("004003002") || n.getHandleModelID().equals("005003002") ).collect(Collectors.toList());
            int behalfpassNum  = behalfpass.size();
            // 作引导劝息、存信存件
            List<LeadBehalf> saveletter = behalfletter.stream().filter((n) -> n.getHandleModelID().equals("001004") || n.getHandleModelID().equals("002004") ).collect(Collectors.toList());
            int saveletterNum  = saveletter.size();


            //转常委会办事机构办理 (人大机关自行办理)
            List<LeadBehalf> committee = behalfleadnpc.stream().filter((n) -> String.valueOf(n.getAgent()).equals("0") ).collect(Collectors.toList());
            int committeeNum  = committee.size();
            //转下一级人大常委会办理 (人大机关自行办理)
            List<LeadBehalf> downdealNpc = behalfleadnpc.stream().filter((n) -> String.valueOf(n.getAgent()).equals("1") &&  !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) ).collect(Collectors.toList());
            int downdealNpcNum  = downdealNpc.size();
            //信访部门作引导劝息、存信存件 (人大机关自行办理)
            List<LeadBehalf> letterSelf = behalfleadnpc.stream().filter((n) -> String.valueOf(n.getAgent()).equals("1") &&  String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID()))  ).collect(Collectors.toList());
            List<LeadBehalf> letterSelfNPC = letterSelf.stream().filter((n) -> n.getHandleModelID().equals("001004") ||  n.getHandleModelID().equals("002004")).collect(Collectors.toList());
            int letterSelfNPCNum = letterSelfNPC.size();
            //转行政机关
            List<LeadBehalf> turnbehalfXZ = behalfletter.stream().filter((n) ->   !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) && String.valueOf(n.getIsRenDa()).equals("0")  ).collect(Collectors.toList());
            int turnbehalfXZNum  = turnbehalfXZ.size();
            //转审判机关
            List<LeadBehalf> turnbehalfSP = behalfletter.stream().filter((n) ->   !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) &&String.valueOf(n.getIsRenDa()).equals("2")  ).collect(Collectors.toList());
            int turnbehalfSPNum  = turnbehalfSP.size();
            //转检察机关
            List<LeadBehalf> turnletterJC = behalfletter.stream().filter((n) ->   !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) && String.valueOf(n.getIsRenDa()).equals("3")  ).collect(Collectors.toList());
            int turnletterJCNum  = turnletterJC.size();
            //转纪检监察
            List<LeadBehalf> turnletterJJ = behalfletter.stream().filter((n) ->   !String.valueOf(n.getCreateOrgID()).equals (String.valueOf(n.getFinalDisposalID())) && String.valueOf(n.getIsRenDa()).equals("4")  ).collect(Collectors.toList());
            int turnletterJJNum  = turnletterJJ.size();



     // 环比开始年份与结束年份
            behalf.setStartTime(currYearHBTime);
            behalf.setEndTime(lastYearHBTime);
            //总数
            List<LeadBehalf> leadBehalvesHB = behalfMapper.LeadBehalfList(behalf);
            int TotalHBNum = leadBehalvesHB.size();
            //领导件
            List<LeadBehalf> leadHB = leadBehalvesHB.stream().filter((n) -> n.getXfSourceID().equals("001002001") ||  n.getXfSourceID().equals("001002002") ||  n.getXfSourceID().equals("002002001") || n.getXfSourceID().equals("002002002")  ).collect(Collectors.toList());
            int leadHBNum  = leadHB.size();

            //统计活动activity
            List<LeadBehalf> hdListHB = activityMapper.cxLD(behalf);
            //领导件

            List<LeadBehalf> hdldHB = hdListHB.stream().filter((n) -> n.getXfSourceID().equals("001002001") || n.getXfSourceID().equals("001002002") || n.getXfSourceID().equals("002002001") || n.getXfSourceID().equals("002002002")).collect(Collectors.toList());
            int hdldHBNum  = hdldHB.size();
            //代表表
            List<LeadBehalf>  hddbHB = hdListHB.stream().filter((n) -> n.getXfSourceID().equals("001003") || n.getXfSourceID().equals("002003") || n.getXfSourceID().equals("001004") || n.getXfSourceID().equals("002006")).collect(Collectors.toList());
            int hddbHBNum  = hddbHB.size();

            //领导接访约访件
            List<LeadBehalf> leadJFHB = leadHB.stream().filter((n) -> n.getXfSourceID().equals("001002001") ||  n.getXfSourceID().equals("001002002")  ).collect(Collectors.toList());
            int leadJFHBNum  = leadJFHB.size();
            //领导阅批来信件
            List<LeadBehalf> readHB = leadHB.stream().filter((n) ->   n.getXfSourceID().equals("002002001") || n.getXfSourceID().equals("002002002")  ).collect(Collectors.toList());
            int readHBNum  = readHB.size();

            // 省人大常委会领导
            List<LeadBehalf> provincialHB = leadHB.stream().filter((n) -> String.valueOf(n.getType()).equals("2")   ).collect(Collectors.toList());
            int provincialHBNum  = provincialHB.size();
            // 市人大常委会领导
            List<LeadBehalf> cityHB = leadHB.stream().filter((n) -> String.valueOf(n.getType()).equals("3")   ).collect(Collectors.toList());
            int cityHBNum  = cityHB.size();
            // 县人大常委会领导
            List<LeadBehalf> countyHB = leadHB.stream().filter((n) -> String.valueOf(n.getType()).equals("4")   ).collect(Collectors.toList());
            int countyHBNum  = countyHB.size();

            // 属于人大机关处理的
            List<LeadBehalf> npcofficeHB = leadHB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("1") ).collect(Collectors.toList());
            int npcofficeHBNum  = npcofficeHB.size();
            //涉及行政机关的XXXX件 administration
            List<LeadBehalf> administrationHB = leadHB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("0") ).collect(Collectors.toList());
            int administrationHBNum  = administrationHB.size();
            //涉及审判机关的XXXX件 administration
            List<LeadBehalf> judgeHB = leadHB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("2") ).collect(Collectors.toList());
            int judgeHBNum  = judgeHB.size();
            //涉及 检察机关monitor
            List<LeadBehalf> monitorHB = leadHB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("3") ).collect(Collectors.toList());
            int monitorHBNum  = monitorHB.size();
            //涉及纪检监察机关 discipline
            List<LeadBehalf> disciplineHB = leadHB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("4") ).collect(Collectors.toList());
            int disciplineHBNum  = disciplineHB.size();

            //交办处理
            List<LeadBehalf> assignHB = leadHB.stream().filter((n) -> n.getHandleModelID().equals("001003001") || n.getHandleModelID().equals("002003001") || n.getHandleModelID().equals("003003001") ||  n.getHandleModelID().equals("004003001") || n.getHandleModelID().equals("005003001") ).collect(Collectors.toList());
            int assignHBNum  = assignHB.size();
            //做转送处理
            List<LeadBehalf> passHB = leadHB.stream().filter((n) -> n.getHandleModelID().equals("001003002") || n.getHandleModelID().equals("002003002") || n.getHandleModelID().equals("003003002") || n.getHandleModelID().equals("004003002") || n.getHandleModelID().equals("005003002") ).collect(Collectors.toList());
            int passHBNum  = passHB.size();
            // 作引导劝息、存信存件
            List<LeadBehalf> letterHB = leadHB.stream().filter((n) -> n.getHandleModelID().equals("001004") || n.getHandleModelID().equals("002004") ).collect(Collectors.toList());
            int letterHBNum  = letterHB.size();

            //转常委会办事机构办理
            List<LeadBehalf> localHB = npcofficeHB.stream().filter((n) -> String.valueOf(n.getAgent()).equals("0") ).collect(Collectors.toList());
            int localHBNum  = localHB.size();
            //转下级人大常委会
            List<LeadBehalf> downNpcHB = npcofficeHB.stream().filter((n) -> String.valueOf(n.getAgent()).equals("1") &&  !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) ).collect(Collectors.toList());
            int downNpcHBNum  = downNpcHB.size();
            //信访部门作引导劝息、存信存件
            List<LeadBehalf> SectionHB = npcofficeHB.stream().filter((n) -> String.valueOf(n.getAgent()).equals("1") &&  String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID()))).collect(Collectors.toList());
            List<LeadBehalf> letterSectionHB = SectionHB.stream().filter((n) -> n.getHandleModelID().equals("001004") ||  n.getHandleModelID().equals("002004")).collect(Collectors.toList());
            int letterSectionHBNum = letterSectionHB.size();

            //转行政机关
            List<LeadBehalf> turnXZHB = leadHB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("0") &&  !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID()))  ).collect(Collectors.toList());
            int turnXZHBNum  = turnXZHB.size();
            //转审判机关
            List<LeadBehalf> turnSPHB = leadHB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("2") &&  !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID()))  ).collect(Collectors.toList());
            int turnSPHBNum  = turnSPHB.size();
            //转检察机关
            List<LeadBehalf> turnJCHB = leadHB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("3") &&  !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID()))  ).collect(Collectors.toList());
            int turnJCHBNum  = turnJCHB.size();
            //转纪检监察
            List<LeadBehalf> turnJJHB = leadHB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("4") &&  !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID()))  ).collect(Collectors.toList());
            int turnJJHBNum  = turnJJHB.size();


            //代表件
            List<LeadBehalf> behalfletterHB = leadBehalvesHB.stream().filter((n) -> n.getXfSourceID().equals("001003") ||  n.getXfSourceID().equals("002003") ||  n.getXfSourceID().equals("001004") || n.getXfSourceID().equals("002006")  ).collect(Collectors.toList());
            int behalfletterHBNum  = behalfletterHB.size();

            //代表来访
            List<LeadBehalf> visitorHB = behalfletterHB.stream().filter((n) -> n.getXfSourceID().equals("001004")).collect(Collectors.toList());
            int visitorHBNum  = visitorHB.size();
            //代表引导来访
            List<LeadBehalf> guidevisitorHB = behalfletterHB.stream().filter((n) -> n.getXfSourceID().equals("001003")).collect(Collectors.toList());
            int guidevisitorHBNum  = guidevisitorHB.size();
            //代表来信
            List<LeadBehalf> lettervisitorHB = behalfletterHB.stream().filter((n) -> n.getXfSourceID().equals("002006")).collect(Collectors.toList());
            int lettervisitorHBNum  = lettervisitorHB.size();
            //代表转信
            List<LeadBehalf> transferletterHB = behalfletterHB.stream().filter((n) -> n.getXfSourceID().equals("002003")).collect(Collectors.toList());
            int transferletterHBNum  = transferletterHB.size();

            //全国人大代表件
            List<LeadBehalf> nationmemberHB = behalfletterHB.stream().filter((n) -> String.valueOf(n.getType()).equals("1")   ).collect(Collectors.toList());
            int nationmemberHBNum  = nationmemberHB.size();
            //省人大代表件
            List<LeadBehalf> provincememberHB = behalfletterHB.stream().filter((n) -> String.valueOf(n.getType()).equals("2")   ).collect(Collectors.toList());
            int provincememberHBNum  = provincememberHB.size();
            //市级人大代表件
            List<LeadBehalf> citymemberHB = behalfletterHB.stream().filter((n) -> String.valueOf(n.getType()).equals("3")   ).collect(Collectors.toList());
            int citymemberHBNum  = citymemberHB.size();
            //县级人大代表件
            List<LeadBehalf> townsmemberHB = behalfletterHB.stream().filter((n) -> String.valueOf(n.getType()).equals("4")   ).collect(Collectors.toList());
            int townsmemberHBNum  = townsmemberHB.size();

            //属于人大机关处理
            List<LeadBehalf> behalfleadnpcHB = behalfletterHB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("1") ).collect(Collectors.toList());
            int behalfleadnpcHBNum  = behalfleadnpcHB.size();
            //涉及行政机关
            List<LeadBehalf> behalfleadXZHB = behalfletterHB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("0") ).collect(Collectors.toList());
            int behalfleadXZHBNum  = behalfleadXZHB.size();
            //涉及审判机关
            List<LeadBehalf> behalfleadSPHB = behalfletterHB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("2") ).collect(Collectors.toList());
            int behalfleadSPHBNum  = behalfleadSPHB.size();
            //涉及检察机关
            List<LeadBehalf> behalfleadJCHB = behalfletterHB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("3") ).collect(Collectors.toList());
            int behalfleadJCHBNum  = behalfleadJCHB.size();
            //涉及纪检监察机关
            List<LeadBehalf> behalfleadJJHB = behalfletterHB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("4") ).collect(Collectors.toList());
            int behalfleadJJHBNum  = behalfleadJJHB.size();

            //分类处理情况：
            //作交办处理的
            List<LeadBehalf> behalfassignHB = behalfletterHB.stream().filter((n) -> n.getHandleModelID().equals("001003001") || n.getHandleModelID().equals("002003001") || n.getHandleModelID().equals("003003001") ||  n.getHandleModelID().equals("004003001") || n.getHandleModelID().equals("005003001") ).collect(Collectors.toList());
            int behalfassignHBNum = behalfassignHB.size();

            //做转送处理
            List<LeadBehalf> behalfpassHB = behalfletterHB.stream().filter((n) -> n.getHandleModelID().equals("001003002") || n.getHandleModelID().equals("002003002") || n.getHandleModelID().equals("003003002") || n.getHandleModelID().equals("004003002") || n.getHandleModelID().equals("005003002") ).collect(Collectors.toList());
            int behalfpassHBNum  = behalfpassHB.size();
            // 作引导劝息、存信存件
            List<LeadBehalf> saveletterHB = behalfletterHB.stream().filter((n) -> n.getHandleModelID().equals("001004") || n.getHandleModelID().equals("002004") ).collect(Collectors.toList());
            int saveletterHBNum  = saveletterHB.size();


            //转常委会办事机构办理 (人大机关自行办理)
            List<LeadBehalf> committeeHB = behalfleadnpcHB.stream().filter((n) -> String.valueOf(n.getAgent()).equals("0") ).collect(Collectors.toList());
            int committeeHBNum  = committeeHB.size();
            //转下一级人大常委会办理 (人大机关自行办理)
            List<LeadBehalf> downdealNpcHB = behalfleadnpcHB.stream().filter((n) -> String.valueOf(n.getAgent()).equals("1") &&  !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) ).collect(Collectors.toList());
            int downdealNpcHBNum  = downdealNpcHB.size();
            //信访部门作引导劝息、存信存件 (人大机关自行办理)
            List<LeadBehalf> letterSelfHB = behalfleadnpcHB.stream().filter((n) -> String.valueOf(n.getAgent()).equals("1") &&  String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID()))  ).collect(Collectors.toList());
            List<LeadBehalf> letterSelfNPCHB = letterSelfHB.stream().filter((n) -> n.getHandleModelID().equals("001004") ||  n.getHandleModelID().equals("002004")).collect(Collectors.toList());
            int letterSelfNPCHBNum = letterSelfNPCHB.size();

            //转行政机关
            List<LeadBehalf> turnbehalfXZHB = behalfletterHB.stream().filter((n) ->   !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) && String.valueOf(n.getIsRenDa()).equals("0")  ).collect(Collectors.toList());
            int turnbehalfXZHBNum  = turnbehalfXZHB.size();
            //转审判机关
            List<LeadBehalf> turnbehalfSPHB = behalfletterHB.stream().filter((n) ->   !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) &&String.valueOf(n.getIsRenDa()).equals("2")  ).collect(Collectors.toList());
            int turnbehalfSPHBNum  = turnbehalfSPHB.size();
            //转检察机关
            List<LeadBehalf> turnletterJCHB = behalfletterHB.stream().filter((n) ->   !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) && String.valueOf(n.getIsRenDa()).equals("3")  ).collect(Collectors.toList());
            int turnletterJCHBNum  = turnletterJCHB.size();
            //转纪检监察
            List<LeadBehalf> turnletterJJHB = behalfletterHB.stream().filter((n) ->   !String.valueOf(n.getCreateOrgID()).equals (String.valueOf(n.getFinalDisposalID())) && String.valueOf(n.getIsRenDa()).equals("4")  ).collect(Collectors.toList());
            int turnletterJJHBNum  = turnletterJJHB.size();

   // 同比开始年份与结束年份
            behalf.setStartTime(currYearTBTime);
            behalf.setEndTime(lastYearTBTime);
            //总数
            List<LeadBehalf> leadBehalvesTB = behalfMapper.LeadBehalfList(behalf);
            int TotalTBNum  = leadBehalvesTB.size();
            //统计活动activity
            List<LeadBehalf> hdListTB = activityMapper.cxLD(behalf);
            //领导件
            List<LeadBehalf> hdldTB = hdListTB.stream().filter((n) -> n.getXfSourceID().equals("001002001") || n.getXfSourceID().equals("001002002") || n.getXfSourceID().equals("002002001") || n.getXfSourceID().equals("002002002")).collect(Collectors.toList());
            int hdldTBNum  = hdldTB.size();
            //代表表
            List<LeadBehalf>  hddbTB = hdListTB.stream().filter((n) -> n.getXfSourceID().equals("001003") || n.getXfSourceID().equals("002003") || n.getXfSourceID().equals("001004") || n.getXfSourceID().equals("002006")).collect(Collectors.toList());
            int hddbTBNum  = hddbTB.size();


            //领导件
            List<LeadBehalf> leadTB = leadBehalvesTB.stream().filter((n) -> n.getXfSourceID().equals("001002001") ||  n.getXfSourceID().equals("001002002") ||  n.getXfSourceID().equals("002002001") || n.getXfSourceID().equals("002002002")  ).collect(Collectors.toList());
            int leadTBNum  = leadTB.size();
            //初次
            int firstleadTBNum = leadTB.stream().filter((n) -> n.getVisitID().equals("100")).collect(Collectors.toList()).size();
            //重复
            int moreleadTBNum = leadTB.stream().filter((n) -> n.getVisitID().equals("200")).collect(Collectors.toList()).size();
            //领导接访约访件
            List<LeadBehalf> leadJFTB = leadTB.stream().filter((n) -> n.getXfSourceID().equals("001002001") ||  n.getXfSourceID().equals("001002002") ).collect(Collectors.toList());
            int leadJFTBNum  = leadJFTB.size();
            //领导阅批来信件
            List<LeadBehalf> readTB = leadTB.stream().filter((n) ->   n.getXfSourceID().equals("002002001") || n.getXfSourceID().equals("002002002")  ).collect(Collectors.toList());
            int readTBNum  = readTB.size();

            // 省人大常委会领导
            List<LeadBehalf> provincialTB = leadTB.stream().filter((n) -> String.valueOf(n.getType()).equals("2")   ).collect(Collectors.toList());
            int provincialTBNum  = provincialTB.size();
            // 市人大常委会领导
            List<LeadBehalf> cityTB = leadTB.stream().filter((n) -> String.valueOf(n.getType()).equals("3")   ).collect(Collectors.toList());
            int cityTBNum  = cityTB.size();
            // 县人大常委会领导
            List<LeadBehalf> countyTB = leadTB.stream().filter((n) -> String.valueOf(n.getType()).equals("4")   ).collect(Collectors.toList());
            int countyTBNum  = countyTB.size();


            // 属于人大机关处理的
            List<LeadBehalf> npcofficeTB = leadTB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("1") ).collect(Collectors.toList());
            int npcofficeTBNum  = npcofficeTB.size();
            //涉及行政机关的XXXX件 administration
            List<LeadBehalf> administrationTB = leadTB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("0") ).collect(Collectors.toList());
            int administrationTBNum  = administrationTB.size();
            //涉及审判机关的XXXX件 administration
            List<LeadBehalf> judgeTB = leadTB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("2") ).collect(Collectors.toList());
            int judgeTBNum  = judgeTB.size();
            // 涉及检察机关monitor
            List<LeadBehalf> monitorTB = leadTB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("3") ).collect(Collectors.toList());
            int monitorTBNum  = monitorTB.size();
            //涉及纪检监察机关 discipline
            List<LeadBehalf> disciplineTB = leadTB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("4") ).collect(Collectors.toList());
            int disciplineTBNum  = disciplineTB.size();

            //交办处理
            List<LeadBehalf> assignTB = leadTB.stream().filter((n) -> n.getHandleModelID().equals("001003001") || n.getHandleModelID().equals("002003001") || n.getHandleModelID().equals("003003001") ||  n.getHandleModelID().equals("004003001") || n.getHandleModelID().equals("005003001") ).collect(Collectors.toList());
            int assignTBNum  = assignTB.size();
            //做转送处理
            List<LeadBehalf> passTB = leadTB.stream().filter((n) -> n.getHandleModelID().equals("001003002") || n.getHandleModelID().equals("002003002") || n.getHandleModelID().equals("003003002") || n.getHandleModelID().equals("004003002") || n.getHandleModelID().equals("005003002") ).collect(Collectors.toList());
            int passTBNum  = passTB.size();
            // 作引导劝息、存信存件
            List<LeadBehalf> letterTB = leadTB.stream().filter((n) -> n.getHandleModelID().equals("001004") || n.getHandleModelID().equals("002004") ).collect(Collectors.toList());
            int letterTBNum  = letterTB.size();

            //转常委会办事机构办理
            List<LeadBehalf> localTB = npcofficeTB.stream().filter((n) -> String.valueOf(n.getAgent()).equals("0") ).collect(Collectors.toList());
            int localTBNum  = localTB.size();
            //转下级人大常委会
            List<LeadBehalf> downNpcTB = npcofficeTB.stream().filter((n) -> String.valueOf(n.getAgent()).equals("1") &&  !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) ).collect(Collectors.toList());
            int downNpcTBNum  = downNpcTB.size();
            //信访部门作引导劝息、存信存件
            List<LeadBehalf> SectionTB = npcofficeTB.stream().filter((n) -> String.valueOf(n.getAgent()).equals("1") &&  String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID()))  ).collect(Collectors.toList());
            List<LeadBehalf> letterSectionTB = SectionTB.stream().filter((n) -> n.getHandleModelID().equals("001004") ||  n.getHandleModelID().equals("002004")).collect(Collectors.toList());
            int letterSectionTBNum = letterSectionTB.size();

            //转行政机关
            List<LeadBehalf> turnXZTB = leadTB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("0") &&  !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID()))  ).collect(Collectors.toList());
            int turnXZTBNum  = turnXZTB.size();
            //转审判机关
            List<LeadBehalf> turnSPTB = leadTB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("2") &&  !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) ).collect(Collectors.toList());
            int turnSPTBNum  = turnSPTB.size();
            //转检察机关
            List<LeadBehalf> turnJCTB = leadTB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("3") &&  !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID()))).collect(Collectors.toList());
            int turnJCTBNum  = turnJCTB.size();
            //转纪检监察
            List<LeadBehalf> turnJJTB = leadTB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("4") &&  !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) ).collect(Collectors.toList());
            int turnJJTBNum  = turnJJTB.size();

            //代表件
            List<LeadBehalf> behalfletterTB = leadBehalvesTB.stream().filter((n) -> n.getXfSourceID().equals("001003") ||  n.getXfSourceID().equals("002003") ||  n.getXfSourceID().equals("001004") || n.getXfSourceID().equals("002006")  ).collect(Collectors.toList());
            int behalfletterTBNum  = behalfletterTB.size();
            //初次
            int firstbehalfTBNum = behalfletterTB.stream().filter((n) -> n.getVisitID().equals("100")).collect(Collectors.toList()).size();
            //重复
            int morebehalfTBNum = behalfletterTB.stream().filter((n) -> n.getVisitID().equals("200")).collect(Collectors.toList()).size();

            //代表来访
            List<LeadBehalf> visitorTB = behalfletterTB.stream().filter((n) -> n.getXfSourceID().equals("001004")).collect(Collectors.toList());
            int visitorTBNum  = visitorTB.size();
            //代表引导来访
            List<LeadBehalf> guidevisitorTB = behalfletterHB.stream().filter((n) -> n.getXfSourceID().equals("001003")).collect(Collectors.toList());
            int guidevisitorTBNum  = guidevisitorTB.size();
            //代表来信T
            List<LeadBehalf> lettervisitorTB = behalfletterTB.stream().filter((n) -> n.getXfSourceID().equals("002006")).collect(Collectors.toList());
            int lettervisitorTBNum  = lettervisitorTB.size();
            //代表转信
            List<LeadBehalf> transferletterTB = behalfletterTB.stream().filter((n) -> n.getXfSourceID().equals("002003")).collect(Collectors.toList());
            int transferletterTBNum  = transferletterTB.size();

            //全国人大代表件
            List<LeadBehalf> nationmemberTB = behalfletterTB.stream().filter((n) -> String.valueOf(n.getType()).equals("1")   ).collect(Collectors.toList());
            int nationmemberTBNum  = nationmemberTB.size();
            //省人大代表件
            List<LeadBehalf> provincememberTB = behalfletterTB.stream().filter((n) -> String.valueOf(n.getType()).equals("2")   ).collect(Collectors.toList());
            int provincememberTBNum  = provincememberTB.size();
            //市级人大代表件
            List<LeadBehalf> citymemberTB = behalfletterTB.stream().filter((n) -> String.valueOf(n.getType()).equals("3")   ).collect(Collectors.toList());
            int citymemberTBNum  = citymemberTB.size();
            //县级人大代表件
            List<LeadBehalf> townsmemberTB = behalfletterTB.stream().filter((n) -> String.valueOf(n.getType()).equals("4")   ).collect(Collectors.toList());
            int townsmemberTBNum  = townsmemberTB.size();

            //属于人大机关处理
            List<LeadBehalf> behalfleadnpcTB = behalfletterTB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("1") ).collect(Collectors.toList());
            int behalfleadnpcTBNum  = behalfleadnpcTB.size();
            //涉及行政机关
            List<LeadBehalf> behalfleadXZTB = behalfletterTB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("0") ).collect(Collectors.toList());
            int behalfleadXZTBNum  = behalfleadXZTB.size();
            //涉及审判机关
            List<LeadBehalf> behalfleadSPTB = behalfletterTB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("2") ).collect(Collectors.toList());
            int behalfleadSPTBNum  = behalfleadSPTB.size();
            //涉及检察机关
            List<LeadBehalf> behalfleadJCTB = behalfletterTB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("3") ).collect(Collectors.toList());
            int behalfleadJCTBNum  = behalfleadJCTB.size();
            //涉及纪检监察机关
            List<LeadBehalf> behalfleadJJTB = behalfletterTB.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("4") ).collect(Collectors.toList());
            int behalfleadJJTBNum  = behalfleadJJTB.size();

            //分类处理情况：
            //作交办处理的
            List<LeadBehalf> behalfassignTB = behalfletterTB.stream().filter((n) -> n.getHandleModelID().equals("001003001") || n.getHandleModelID().equals("002003001") || n.getHandleModelID().equals("003003001") ||  n.getHandleModelID().equals("004003001") || n.getHandleModelID().equals("005003001") ).collect(Collectors.toList());
            int behalfassignTBNum = behalfassignTB.size();

            //做转送处理
            List<LeadBehalf> behalfpassTB = behalfletterTB.stream().filter((n) -> n.getHandleModelID().equals("001003002") || n.getHandleModelID().equals("002003002") || n.getHandleModelID().equals("003003002") || n.getHandleModelID().equals("004003002") || n.getHandleModelID().equals("005003002") ).collect(Collectors.toList());
            int behalfpassTBNum  = behalfpassTB.size();
            // 作引导劝息、存信存件
            List<LeadBehalf> saveletterTB = behalfletterTB.stream().filter((n) -> n.getHandleModelID().equals("001004") || n.getHandleModelID().equals("002004") ).collect(Collectors.toList());
            int saveletterTBNum  = saveletterTB.size();

            //转常委会办事机构办理 (人大机关自行办理)
            List<LeadBehalf> committeeTB = behalfleadnpcTB.stream().filter((n) -> String.valueOf(n.getAgent()).equals("0") ).collect(Collectors.toList());
            int committeeTBNum  = committeeTB.size();
            //转下一级人大常委会办理 (人大机关自行办理)
            List<LeadBehalf> downdealNpcTB = behalfleadnpcTB.stream().filter((n) -> String.valueOf(n.getAgent()).equals("1") &&  !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) ).collect(Collectors.toList());
            int downdealNpcTBNum  = downdealNpcTB.size();
            //信访部门作引导劝息、存信存件 (人大机关自行办理)
            List<LeadBehalf> letterSelfTB = behalfleadnpcTB.stream().filter((n) -> String.valueOf(n.getAgent()).equals("1") &&  String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID()))  ).collect(Collectors.toList());
            List<LeadBehalf> letterSelfNPCTB = letterSelfTB.stream().filter((n) -> n.getHandleModelID().equals("001004") ||  n.getHandleModelID().equals("002004")).collect(Collectors.toList());
            int letterSelfNPCTBNum = letterSelfNPCTB.size();

            //转行政机关
            List<LeadBehalf> turnbehalfXZTB = behalfletterTB.stream().filter((n) ->   !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) && String.valueOf(n.getIsRenDa()).equals("0")  ).collect(Collectors.toList());
            int turnbehalfXZTBNum  = turnbehalfXZTB.size();
            //转审判机关
            List<LeadBehalf> turnbehalfSPTB = behalfletterTB.stream().filter((n) ->   !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) &&String.valueOf(n.getIsRenDa()).equals("2")  ).collect(Collectors.toList());
            int turnbehalfSPTBNum  = turnbehalfSPTB.size();
            //转检察机关
            List<LeadBehalf> turnletterJCTB = behalfletterTB.stream().filter((n) ->   !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) && String.valueOf(n.getIsRenDa()).equals("3")  ).collect(Collectors.toList());
            int turnletterJCTBNum  = turnletterJCTB.size();
            //转纪检监察
            List<LeadBehalf> turnletterJJTB = behalfletterTB.stream().filter((n) ->   !String.valueOf(n.getCreateOrgID()).equals (String.valueOf(n.getFinalDisposalID())) && String.valueOf(n.getIsRenDa()).equals("4")  ).collect(Collectors.toList());
            int turnletterJJTBNum  = turnletterJJTB.size();
            Map<Object, Object> map = new HashMap<>();
            String content;
            content="&nbsp;"+ "&nbsp;"+"&nbsp;"+ "&nbsp;"+"1.领导代表件总量分析"+  System.getProperty("line.separator")+  //换行
                    "&nbsp;"+ "&nbsp;"+"&nbsp;"+ "&nbsp;"+DateTimeUtils.getYear(firstYearTime)+"年"+DateTimeUtils.getMonth(firstYearTime)+"月"+DateTimeUtils.getDay(firstYearTime)+"日至"+DateTimeUtils.getYear(endYearTime)+"年"+DateTimeUtils.getMonth(endYearTime)+"月"+DateTimeUtils.getDay(endYearTime)+"日,"+"当前登记单位及所辖单位处理的"+
                   +TotalNum+"件信访事项中：领导件"+leadNum+"件,占总量"+CalculateUtils.makeUp(leadNum,TotalNum)+"%" +
                    "，环比"+CalculateUtils.IncreaseDecreaseMakeUp(leadNum,leadHBNum)+
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(leadNum,leadTBNum)+"" +
                    "%;代表件"+behalfletterNum+"件，占总量"+CalculateUtils.makeUp(behalfletterNum,TotalNum)+
                   "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(behalfletterNum,behalfletterHBNum)+
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(behalfletterNum,behalfletterTBNum)+"%。"+System.getProperty("line.separator")+
                    "&nbsp;"+ "&nbsp;"+"&nbsp;"+ "&nbsp;"+DateTimeUtils.getYear(firstYearTime)+"年"+DateTimeUtils.getMonth(firstYearTime)+"月"+DateTimeUtils.getDay(firstYearTime)+"日至"+DateTimeUtils.getYear(endYearTime)+"年"+DateTimeUtils.getMonth(endYearTime)+"月"+DateTimeUtils.getDay(endYearTime)+"日,"+"当前登记单位及所辖单位处理的"+
                    +hdSum+"批次群众信访中：领导件"+hdldNum+"件,占总量"+CalculateUtils.makeUp(hdldNum,hdSum)+"%" +
                    "，环比"+CalculateUtils.IncreaseDecreaseMakeUp(hdldNum,hdldHBNum)+
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(hdldNum,hdldTBNum)+"" +
                    "%;代表件"+hddbNum+"件，占总量"+CalculateUtils.makeUp(hddbNum,hdSum)+
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(hddbNum,hddbHBNum)+
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(hddbNum,hddbTBNum)+"%。"+System.getProperty("line.separator")+

                    "&nbsp;"+ "&nbsp;"+"&nbsp;"+ "&nbsp;"+"2.领导件分析："+System.getProperty("line.separator")+
                    "&nbsp;"+ "&nbsp;"+"&nbsp;"+ "&nbsp;"+leadNum+"件领导件中:领导接访约访件"+leadJFNum+"件,占领导件"+CalculateUtils.makeUp(leadJFNum,leadNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(leadJFNum,leadJFHBNum) +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(leadJFNum,leadJFTBNum) +
                    "%;领导阅批来信件" +readNum+"件，占领导件"+CalculateUtils.makeUp(readNum,leadNum)+
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(readNum,readHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(readNum,readTBNum)+"%。"+System.getProperty("line.separator")+
                    "&nbsp;"+ "&nbsp;"+"&nbsp;"+ "&nbsp;"+leadNum+"件领导件中：省人大常委会领导件"+provincialNum+"件占领导件"+CalculateUtils.makeUp(provincialNum,leadNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(provincialNum,provincialHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(provincialNum,provincialTBNum)+"" +
                    "%；市级人大常委会领导件"+cityNum+"件,占领导件"+CalculateUtils.makeUp(cityNum,leadNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(cityNum,cityHBNum)+"" +
                    "%，同比"+CalculateUtils.IncreaseDecreaseMakeUp(cityNum,cityTBNum)+"%；县级人大常委会领导件" +
                      countyNum+"件占领导件"+CalculateUtils.makeUp(countyNum,leadNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(countyNum,countyHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(countyNum,countyTBNum)+"%。" +System.getProperty("line.separator")+
                    "&nbsp;"+ "&nbsp;"+ "&nbsp;"+ "&nbsp;"+leadNum+"件领导件中：属于人大机关处理的"+npcofficeNum+"件，占领导件"+ CalculateUtils.makeUp(npcofficeNum,leadNum)+
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(npcofficeNum,npcofficeHBNum)+
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(npcofficeNum,npcofficeTBNum)+"" +
                    "%；涉及行政机关的"+administrationNum+"件，占领导件"+CalculateUtils.makeUp(administrationNum,leadNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(administrationNum,administrationHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(administrationNum,administrationTBNum)+"" +
                    "%；涉及审判机关的"+judgeNum+"件，占领导件"+CalculateUtils.makeUp(judgeNum,leadNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(judgeNum,judgeHBNum)+"" +
                    "%，同比"+CalculateUtils.IncreaseDecreaseMakeUp(judgeNum,judgeTBNum)+"" +
                    "%；涉及检察机关的"+monitorNum+"件，占领导件"+CalculateUtils.makeUp(monitorNum,leadNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(monitorNum,monitorHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(monitorNum,monitorTBNum)+"" +
                    "%；涉及纪检监察机关的"+disciplineNum+"件，占领导件"+CalculateUtils.makeUp(disciplineNum,leadNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(disciplineNum,disciplineHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(disciplineNum,disciplineTBNum)+"%。"+System.getProperty("line.separator")+
                    "&nbsp;"+ "&nbsp;"+ "&nbsp;"+ "&nbsp;"+"分类处理情况：" +System.getProperty("line.separator")+
                    "&nbsp;"+ "&nbsp;"+ "&nbsp;"+ "&nbsp;"+leadNum+"件领导件中：作交办处理的"+assignNum+"件，占领导件"+CalculateUtils.makeUp(assignNum,leadNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(assignNum,assignHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(assignNum,assignTBNum)+"" +
                    "%；作转送处理的" +passNum+"件，占领导件"+CalculateUtils.makeUp(passNum,leadNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(passNum,passHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(passNum,passTBNum)+"" +
                    "%；作引导劝息、存信存件" +letterNum+"件，占领导件"+CalculateUtils.makeUp(letterNum,leadNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(letterNum,letterHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(letterNum,letterTBNum)+"%。其中："+System.getProperty("line.separator")+
                    "&nbsp;"+ "&nbsp;"+ "&nbsp;"+ "&nbsp;"+"⑴人大机关自行办理"+npcofficeNum+"件，占领导件"+CalculateUtils.makeUp(npcofficeNum,leadNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(npcofficeNum,npcofficeHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(npcofficeNum,npcofficeTBNum)+"" +
                    "%。其中：转常委会办事机构办理"+localNum+"件，占领导件"+CalculateUtils.makeUp(localNum,leadNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(localNum,localHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(localNum,localTBNum)+"" +"" +
                    "%；转下一级人大常委会办理"+downNpcNum+"件，占领导件"+CalculateUtils.makeUp(downNpcNum,leadNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(downNpcNum,downNpcHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(downNpcNum,downNpcTBNum)+"" +
                    "%；信访部门作引导劝息、存信存件"+letterSectionNum+"件，占领导件"+CalculateUtils.makeUp(letterSectionNum,leadNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(letterSectionNum,letterSectionHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(letterSectionNum,letterSectionTBNum)+"" +
                    "%。⑵转行政机关" +turnXZNum+"件，占领导件"+CalculateUtils.makeUp(turnXZNum,leadNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(turnXZNum,turnXZHBNum)+"" +
                    "%，同比"+CalculateUtils.IncreaseDecreaseMakeUp(turnXZNum,turnXZTBNum)+"" +
                    "%。⑶转审判机关" +turnSPNum+"件，占领导件"+CalculateUtils.makeUp(turnSPNum,leadNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(turnSPNum,turnSPHBNum)+"" +
                    "%，同比"+CalculateUtils.IncreaseDecreaseMakeUp(turnSPNum,turnSPTBNum)+"" +
                    "%。⑷转检察机关" +turnJCNum+"件，占领导件"+CalculateUtils.makeUp(turnJCNum,leadNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(turnJCNum,turnJCHBNum)+"" +
                    "%，同比"+CalculateUtils.IncreaseDecreaseMakeUp(turnJCNum,turnJCTBNum)+"" +
                    "%。⑸转纪检监察机关" +turnJJNum+"件，占领导件"+CalculateUtils.makeUp(turnJJNum,leadNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(turnJJNum,turnJJHBNum)+"" +
                    "%，同比"+CalculateUtils.IncreaseDecreaseMakeUp(turnJJNum,turnJJTBNum)+"%。"+System.getProperty("line.separator")+
                    "&nbsp;"+ "&nbsp;"+"&nbsp;"+ "&nbsp;"+"3.代表件分析："+System.getProperty("line.separator")+
                    "&nbsp;"+ "&nbsp;"+ "&nbsp;"+ "&nbsp;"+behalfletterNum+"件代表件中：代表来访"+visitorNum+"件，占代表件"+CalculateUtils.makeUp(visitorNum,behalfletterNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(visitorNum,visitorHBNum)+
                    "%，同比"+CalculateUtils.IncreaseDecreaseMakeUp(visitorNum,visitorTBNum)+"" +
                    "%；代表引导来访"+guidevisitorNum+"件，占代表件"+CalculateUtils.makeUp(guidevisitorNum,behalfletterNum) +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(guidevisitorNum,guidevisitorHBNum)+"" +
                    "%，同比"+CalculateUtils.IncreaseDecreaseMakeUp(guidevisitorNum,guidevisitorTBNum)+"" +
                    "%；代表来信"+lettervisitorNum+"件，占代表件"+CalculateUtils.makeUp(lettervisitorNum,behalfletterNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(lettervisitorNum,lettervisitorHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(lettervisitorNum,lettervisitorTBNum)+"" +
                    "%；代表转信"+transferletterNum+"件，占代表件"+CalculateUtils.makeUp(transferletterNum,behalfletterNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(transferletterNum,transferletterHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(transferletterNum,transferletterTBNum)+"%。"+System.getProperty("line.separator")+
                    "&nbsp;"+ "&nbsp;"+"&nbsp;"+ "&nbsp;"+behalfletterNum+"件代表件中：全国人大代表件"+nationmemberNum+"件占代表件"+CalculateUtils.makeUp(nationmemberNum,behalfletterNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(nationmemberNum,+nationmemberHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(nationmemberNum,nationmemberTBNum)+"" +
                    "%；省人大代表件"+provincememberNum+"件占代表件"+CalculateUtils.makeUp(provincememberNum,behalfletterNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(provincememberNum,provincememberHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(provincememberNum,provincememberTBNum)+"" +
                    "%；市级人大代表件"+citymemberNum+"件占代表件"+CalculateUtils.makeUp(citymemberNum,behalfletterNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(citymemberNum,citymemberHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(citymemberNum,citymemberTBNum)+"" +
                    "%；县级人大代表件"+townsmemberNum+"件占代表件" +CalculateUtils.makeUp(townsmemberNum,behalfletterNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(townsmemberNum,townsmemberHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(townsmemberNum,townsmemberTBNum)+"%。" +System.getProperty("line.separator")+
                    "&nbsp;"+ "&nbsp;"+ "&nbsp;"+ "&nbsp;"+behalfletterNum+"件代表件中：属于人大机关处理的"+behalfleadnpcNum+"件，占领导件"+CalculateUtils.makeUp(behalfleadnpcNum,behalfletterNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(behalfleadnpcNum,behalfleadnpcHBNum)+
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(behalfleadnpcNum,behalfleadnpcTBNum)+"" +
                    "%；涉及行政机关的"+behalfleadXZNum+"件，占代表件"+CalculateUtils.makeUp(behalfleadXZNum,behalfletterNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(behalfleadXZNum,behalfleadXZHBNum)+
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(behalfleadXZNum,behalfleadXZTBNum)+"" +
                    "%；涉及审判机关的"+behalfleadSPNum+"件，占代表件"+CalculateUtils.makeUp(behalfleadSPNum,behalfletterNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(behalfleadSPNum,behalfleadSPHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(behalfleadSPNum,behalfleadSPTBNum)+"" +
                    "%；涉及检察机关的" +behalfleadJCNum+"件，占代表件"+CalculateUtils.makeUp(behalfleadJCNum,behalfletterNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(behalfleadJCNum,behalfleadJCHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(behalfleadJCNum,behalfleadJCTBNum)+"" +
                    "%；涉及纪检监察机关的" +behalfleadJJNum+"件，占代表件"+CalculateUtils.makeUp(behalfleadJJNum,behalfletterNum)+
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(behalfleadJJNum,behalfleadJJHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(behalfleadJJNum,behalfleadJJTBNum)+"%。"+System.getProperty("line.separator")+
                    "&nbsp;"+ "&nbsp;"+ "&nbsp;"+ "&nbsp;"+"分类处理情况："+System.getProperty("line.separator")+
                    "&nbsp;"+ "&nbsp;"+ "&nbsp;"+ "&nbsp;"+behalfletterNum+"件代表件中：作交办处理的"+behalfassignNum+"件，占代表件"+CalculateUtils.makeUp(behalfassignNum,behalfletterNum) +"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(behalfassignNum,behalfassignHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(behalfassignNum,behalfassignTBNum)+"" +
                    "%；作转送处理的"+behalfpassNum+"件，占代表件"+CalculateUtils.makeUp(behalfpassNum,behalfletterNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(behalfpassNum,behalfpassHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(behalfpassNum,behalfpassTBNum)+"" +
                    "%；作引导劝息、存信存件"+saveletterNum+"件，占代表件"+CalculateUtils.makeUp(saveletterNum,behalfletterNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(saveletterNum,saveletterHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(saveletterNum,saveletterTBNum)+"%。其中："+System.getProperty("line.separator")+
                    "&nbsp;"+ "&nbsp;"+ "&nbsp;"+"&nbsp;"+"⑴人大机关自行办理"+behalfleadnpcNum+"件，占代表件"+CalculateUtils.makeUp(behalfleadnpcNum,behalfletterNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(behalfleadnpcNum,behalfleadnpcHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(behalfleadnpcNum,+behalfleadnpcTBNum)+"" +
                    "%。其中：转常委会办事机构办理"+committeeNum+"件，占代表件"+CalculateUtils.makeUp(committeeNum,behalfletterNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(committeeNum,+committeeHBNum)+"" +
                    "%，同比"+CalculateUtils.IncreaseDecreaseMakeUp(committeeNum,+committeeTBNum)+"" +
                    "%；转下一级人大常委会办理"+downdealNpcNum+"件，占代表件"+CalculateUtils.makeUp(downdealNpcNum,behalfletterNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(downdealNpcNum,downdealNpcHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(downdealNpcNum,downdealNpcTBNum)+"" +
                    "%；信访部门作引导劝息、存信存件"+letterSelfNPCNum+"件，占代表件"+CalculateUtils.makeUp(letterSelfNPCNum,behalfletterNum)+
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(letterSelfNPCNum,letterSelfNPCHBNum)+"" +
                    "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(letterSelfNPCNum,letterSelfNPCTBNum)+"" +
                    "%。⑵转行政机关"+turnbehalfXZNum+"件，占代表件"+CalculateUtils.makeUp(turnbehalfXZNum,behalfletterNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(turnbehalfXZNum,turnbehalfXZHBNum)+"" +
                    "%，同比"+CalculateUtils.IncreaseDecreaseMakeUp(turnbehalfXZNum,turnbehalfXZTBNum)+"" +
                    "%。⑶转审判机关"+turnbehalfSPNum+"件，占代表件"+CalculateUtils.makeUp(turnbehalfSPNum,behalfletterNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(turnbehalfSPNum,turnbehalfSPHBNum)+"" +
                    "%，同比"+CalculateUtils.IncreaseDecreaseMakeUp(turnbehalfSPNum,turnbehalfSPTBNum)+
                    "%。⑷转检察机关"+turnletterJCNum+"件，占代表件"+CalculateUtils.makeUp(turnletterJCNum,behalfletterNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(turnletterJCNum,turnletterJCHBNum)+"" +
                    "%，同比"+CalculateUtils.IncreaseDecreaseMakeUp(turnletterJCNum,turnletterJCTBNum)+
                    "%。⑸转纪检监察机关"+turnletterJJNum+"件，占代表件"+CalculateUtils.makeUp(turnletterJJNum,behalfletterNum)+"" +
                    "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(turnletterJJNum,turnletterJJHBNum)+"" +
                    "%，同比"+CalculateUtils.IncreaseDecreaseMakeUp(turnletterJJNum,turnletterJJTBNum)+"%。";

            map.put("content",content);
            List<Map<String,Object>> department = new ArrayList<>();
            HashMap<String, Object> map1 = new HashMap<>();
            HashMap<String, Object> map2 = new HashMap<>();
            map1.put("name","今年");
            map1.put("totalNum",leadNum+behalfletterNum);
            map1.put("firstNum",firstleadNum+firstbehalfNum);
            map1.put("moreNum",moreleadNum+morebehalfNum);
            map2.put("name","去年");
            map2.put("totalNum",leadTBNum+behalfletterTBNum);
            map2.put("firstNum",firstleadTBNum+firstbehalfTBNum);
            map2.put("moreNum",moreleadTBNum+morebehalfTBNum);
            department.add(map1);
            department.add(map2);
            List<Map<String,Object>> department1 = new ArrayList<>();
            HashMap<String, Object> map3 = new HashMap<>();
            HashMap<String, Object> map4 = new HashMap<>();
            HashMap<String, Object> map5 = new HashMap<>();
            map3.put("name","领导件");
            map3.put("id","1");
            map3.put("number",leadNum);
            map4.put("name","代表件");
            map4.put("id","2");
            map4.put("number",behalfletterNum);
            map5.put("name","领导兼任代表件");
            map5.put("number",LdDbSum);
            department1.add(map3);
            department1.add(map4);
            department1.add(map5);
            map.put("firstMore",department);
            map.put("leaderList",department1);
            return map;

        }

    // 领导代表件情况
    @Override
    public Map<Object,Object> FirstMore(LeadBehalf leadBehalf) throws ParseException{
        Map<Object, Object> map = new HashMap<>();
        List<Map<String,Object>> department = new ArrayList<>();
        if (leadBehalf.getEndTime()!=null){
           leadBehalf.setEndTime(DateTimeUtils.getTodayTime(leadBehalf.getEndTime()));
        }
        if (leadBehalf.getId().equals("1")){
                List<LeadBehalf> leadBehalves = behalfMapper.FirstMore(leadBehalf);
                //领导件
                List<LeadBehalf> lead = leadBehalves.stream().filter((n) -> n.getXfSourceID().equals("001002001") ||  n.getXfSourceID().equals("001002002") ||  n.getXfSourceID().equals("002002001") || n.getXfSourceID().equals("002002002")  ).collect(Collectors.toList());
                //初次
                int firstleadNum = lead.stream().filter((n) -> n.getVisitID().equals("100")).collect(Collectors.toList()).size();
                //重复
                int moreleadNum = lead.stream().filter((n) -> n.getVisitID().equals("200")).collect(Collectors.toList()).size();
                    HashMap<String, Object> map1 = new HashMap<>();
                    HashMap<String, Object> map2 = new HashMap<>();
                     map1.put("name","初次");
                     map1.put("number",firstleadNum);
                     map2.put("name","重复");
                     map2.put("number",moreleadNum);
                     department.add(map1);
                     department.add(map2);
            }else{
            //代表件
                List<LeadBehalf> leadBehalves = behalfMapper.FirstMore(leadBehalf);
                List<LeadBehalf> behalfletter = leadBehalves.stream().filter((n) -> n.getXfSourceID().equals("001003") ||  n.getXfSourceID().equals("002003") ||  n.getXfSourceID().equals("001004") || n.getXfSourceID().equals("002006")  ).collect(Collectors.toList());
                //初次
                int firstleadNum = behalfletter.stream().filter((n) -> n.getVisitID().equals("100")).collect(Collectors.toList()).size();
                //重复
                int moreleadNum = behalfletter.stream().filter((n) -> n.getVisitID().equals("200")).collect(Collectors.toList()).size();
                HashMap<String, Object> map1 = new HashMap<>();
                HashMap<String, Object> map2 = new HashMap<>();
                map1.put("name","初次");
                map1.put("number",firstleadNum);
                map2.put("name","重复");
                map2.put("number",moreleadNum);
                department.add(map1);
                department.add(map2);
            }

            map.put("initialList",department);
            return map;
    }

}
