package com.dlsm.service.impl;



import com.dlsm.utils.DateTimeUtils;
import com.dlsm.utils.CalculateUtils;
import com.dlsm.utils.Result;
import com.dlsm.utils.StringUtils;
import com.dlsm.mapper.LettermanageMapper;
import com.dlsm.model.Dept;
import com.dlsm.model.Lettermanage;
import com.dlsm.service.DeptService;
import com.dlsm.service.LettermanageService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;


/**
 * 信息办理管理Service业务层处理
 *
 * @author jinlei
 * @date 2022-03-03
 */
@Service
public class LettermanageServiceImpl implements LettermanageService {

    @Autowired
    private LettermanageMapper lettermanageMapper;

    @Autowired
    private DeptService deptService;

    @Override
    public Result LetterList(Lettermanage lettermanage) throws ParseException {
        //登录的id
        Map<String, Object> map = new HashMap<>();
        if (StringUtils.isEmpty(lettermanage.getCreateOrgIDS())) {
            List<Dept> depts = deptService.selectDeptByUserIdList(lettermanage.getUserId());
                for (Dept dept : depts) {
                    String OrgIDS = dept.getOrganizationId().toString();
                    if (StringUtils.isEmpty(lettermanage.getCreateOrgIDS())) {
                        lettermanage.setCreateOrgIDS(OrgIDS);
                    } else {
                        lettermanage.setCreateOrgIDS(lettermanage.getCreateOrgIDS() + "," + OrgIDS);
                    }
                }
        }
            SimpleDateFormat  f = new SimpleDateFormat("yyyy", Locale.CHINA);

//  // 初始时间
            Date firstYearTime;
            Date endYearTime;

// 环比开始时间与结束时间Year
            Date currYearHBTime;
            Date lastYearHBTime;

// 同比开始时间与结束时间
            Date currYearTBTime;
            Date lastYearTBTime;

            if (lettermanage.getStartTime() == null) {
                // 本年的第一天
                firstYearTime = DateTimeUtils.getCurrYearFirst();
                // 本年最后一天
                endYearTime = new Date();

                // 环比时间
                currYearTBTime = DateTimeUtils.getTBTime(firstYearTime,endYearTime).get("startTBTime");
                lastYearTBTime = DateTimeUtils.getTBTime(firstYearTime,endYearTime).get("endTBTime");

                // 同比时间
                currYearHBTime = DateTimeUtils.getStartHBTime(firstYearTime);
                lastYearHBTime = DateTimeUtils.getEndHBTime(endYearTime);
            } else {

                firstYearTime = lettermanage.getStartTime();
                endYearTime = DateTimeUtils.getTodayTime(lettermanage.getEndTime());


                currYearHBTime = DateTimeUtils.getStartHBTime(lettermanage.getStartTime());
                lastYearHBTime = DateTimeUtils.getEndHBTime(lettermanage.getEndTime());

                currYearTBTime = DateTimeUtils.getTBTime(lettermanage.getStartTime(),lettermanage.getEndTime()).get("startTBTime");
                lastYearTBTime = DateTimeUtils.getTBTime(lettermanage.getStartTime(),lettermanage.getEndTime()).get("endTBTime");
            }

   // 今年时间数据
                //当前是时间截至时间   某年1月一日
                lettermanage.setStartTime(firstYearTime);
                lettermanage.setEndTime(endYearTime);
                // 受理范围  总量
                List<Lettermanage> letterManageThisYear = lettermanageMapper.LetterList(lettermanage);
                int total = letterManageThisYear.size();
                List<Lettermanage> self = letterManageThisYear.stream().filter((n) -> String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID()))).collect(Collectors.toList());
                int selfNum  = self.size();
         //属于人大信访受理范围
                List<Lettermanage> collect = letterManageThisYear.stream().filter((n) -> String.valueOf(n.getIsAccept()).equals("0")).collect(Collectors.toList());
                int Npcaccept  = collect.size();
                // 受理XXXX件
                List<Lettermanage> collect2 = collect.stream().filter((n) -> String.valueOf(n.getIsAcceptPerson()).equals("0")).collect(Collectors.toList());
                int accept  = collect2.size();
                // 不属于受理XXXX件
                List<Lettermanage> collect3 = collect.stream().filter((n) -> String.valueOf(n.getIsAcceptPerson()).equals("1")).collect(Collectors.toList());
                int acceptNot  = collect3.size();
                //做交办
                 List<Lettermanage> assign = collect.stream().filter((n) -> n.getHandleModelID().equals("001003001") || n.getHandleModelID().equals("002003001") || n.getHandleModelID().equals("003003001")|| n.getHandleModelID().equals("004003001")|| n.getHandleModelID().equals("005003001") ).collect(Collectors.toList());
                 int assignNum  = assign.size();
                 //转常委会办事机构XXXX件
                  List<Lettermanage> committee = collect.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("1") && String.valueOf(n.getAgent()).equals("0")  ).collect(Collectors.toList());
                  int committeeNum  = committee.size();
                //属于转交人大的
                List<Lettermanage> subordinateAll = collect.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("1") && String.valueOf(n.getAgent()).equals("1")  ).collect(Collectors.toList());
                // 属于转交给下级
                List<Lettermanage> subordinate = subordinateAll.stream().filter((n) -> !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID()))  ).collect(Collectors.toList());
                int subordinateNum  = subordinate.size();
                 //做转送
                List<Lettermanage> pass = collect.stream().filter((n) -> n.getHandleModelID().equals("001003002") || n.getHandleModelID().equals("002003002") || n.getHandleModelID().equals("003003002")|| n.getHandleModelID().equals("004003002")|| n.getHandleModelID().equals("005003002") ).collect(Collectors.toList());
                int passNum  = pass.size();
               //作引导劝息、存信存件
                List<Lettermanage> letter = collect.stream().filter((n) -> n.getHandleModelID().equals("002004") || n.getHandleModelID().equals("001004") || n.getHandleModelID().equals("001005") || n.getHandleModelID().equals("003005")).collect(Collectors.toList());
                int letterNum  = letter.size();
          //不属于人大信访受理范围
                List<Lettermanage> collectNot = letterManageThisYear.stream().filter((n) -> String.valueOf(n.getIsAccept()).equals("1")).collect(Collectors.toList());
                int NpcacceptNot = collectNot.size();

                //作交办处理的领导代表件   过滤领导 代表 事件
                List<Lettermanage> selectleadNot = collectNot.stream().filter((n) -> n.getXfSourceID().equals("001002001") || n.getXfSourceID().equals("001002002") || n.getXfSourceID().equals("001003")|| n.getXfSourceID().equals("002002001")|| n.getXfSourceID().equals("002002002") || n.getXfSourceID().equals("002003")|| n.getXfSourceID().equals("001004") || n.getXfSourceID().equals("002006")).collect(Collectors.toList());
                List<Lettermanage> leadchoiceNot = selectleadNot.stream().filter((n) -> n.getHandleModelID().equals("001003001") || n.getHandleModelID().equals("002003001") || n.getHandleModelID().equals("003003001")|| n.getHandleModelID().equals("004003001")|| n.getHandleModelID().equals("005003001") ).collect(Collectors.toList());
                int leadchoiceNotNum  = leadchoiceNot.size();

                //不属于人大范围  做转送
                List<Lettermanage> passNot = collectNot.stream().filter((n) -> n.getHandleModelID().equals("001003002") || n.getHandleModelID().equals("002003002") || n.getHandleModelID().equals("003003002")|| n.getHandleModelID().equals("004003002")|| n.getHandleModelID().equals("005003002") ).collect(Collectors.toList());
                int passNotNum  = passNot.size();

                //作引导劝息、存信存件
                List<Lettermanage> letterNot = collectNot.stream().filter((n) -> n.getHandleModelID().equals("002004") || n.getHandleModelID().equals("001004") || n.getHandleModelID().equals("001005") || n.getHandleModelID().equals("003005")).collect(Collectors.toList());
                int letterNotNum  = letterNot.size();

           //  转行政机 administrative
                List<Lettermanage> administrativeNot = collectNot.stream().filter((n) -> !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) && String.valueOf(n.getIsRenDa()).equals("0")).collect(Collectors.toList());
                int administrativeNotNum  = administrativeNot.size();

             //  转审判机关
                List<Lettermanage> judgeNot = collectNot.stream().filter((n) -> !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) && String.valueOf(n.getIsRenDa()).equals("2")).collect(Collectors.toList());
                int judgeNotNum  = judgeNot.size();

                //转检察机关
                List<Lettermanage> examineNot = collectNot.stream().filter((n) -> !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) && String.valueOf(n.getIsRenDa()).equals("3")).collect(Collectors.toList());
                int examineNotNum  = examineNot.size();

        //        转纪检监察
                List<Lettermanage> disciplineNot = collectNot.stream().filter((n) -> !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) && String.valueOf(n.getIsRenDa()).equals("4")).collect(Collectors.toList());
                int disciplineNotNum  = disciplineNot.size();

                //转常委会办事机构
                List<Lettermanage> committeeNot = collectNot.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("1") && String.valueOf(n.getAgent()).equals("0")  ).collect(Collectors.toList());
                int committeeNotNum  = committeeNot.size();

                //转下一级人大常委会
                List<Lettermanage> subordinateAllNot = collectNot.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("1") && String.valueOf(n.getAgent()).equals("1")  ).collect(Collectors.toList());
                // 属于转交给下级
                List<Lettermanage> subordinateNot = subordinateAllNot.stream().filter((n) -> !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) ).collect(Collectors.toList());
                int subordinateNotNum  = subordinateNot.size();

            // 环比开始年份与结束年份  LoopRatio
            //获取上一年  年的时间

            lettermanage.setStartTime(currYearHBTime);
            lettermanage.setEndTime(lastYearHBTime);
            // 同比 上一年 受理范围 总量
            List<Lettermanage> letterManageLoopRatio = lettermanageMapper.LetterList(lettermanage);
            //属于人大信访受理范围
            List<Lettermanage> totalLoopRatio= letterManageLoopRatio.stream().filter((n) -> String.valueOf(n.getIsAccept()).equals("0")).collect(Collectors.toList());
            int NpcacceptLoopRatio = totalLoopRatio.size();
            //受理XXXXX件
            List<Lettermanage> acceptLoopRatio= totalLoopRatio.stream().filter((n) -> String.valueOf(n.getIsAcceptPerson()).equals("0")).collect(Collectors.toList());
            int acceptLoopRatioNum = acceptLoopRatio.size();
            //不给予受理XXXXX件
            List<Lettermanage> collectLoopRatio= totalLoopRatio.stream().filter((n) -> String.valueOf(n.getIsAcceptPerson()).equals("1")).collect(Collectors.toList());
            int acceptLoopRatioNotNum = collectLoopRatio.size();
            //做交办
            List<Lettermanage> assignLoopRatio = totalLoopRatio.stream().filter((n) -> n.getHandleModelID().equals("001003001") || n.getHandleModelID().equals("002003001") || n.getHandleModelID().equals("003003001")|| n.getHandleModelID().equals("004003001")|| n.getHandleModelID().equals("005003001") ).collect(Collectors.toList());
            int assignLoopRatioNum  = assignLoopRatio.size();
            //转常委会办事机构XXXX件
            List<Lettermanage> committeeLoopRatio = totalLoopRatio.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("1") && String.valueOf(n.getAgent()).equals("0")  ).collect(Collectors.toList());
            int committeeLoopRatioNum  = committeeLoopRatio.size();
            //属于转交人大的
            List<Lettermanage> LoopRatioAllFront = totalLoopRatio.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("1") && String.valueOf(n.getAgent()).equals("1")  ).collect(Collectors.toList());
            // 属于转交给下级
            List<Lettermanage> subordinateLoopRatio = LoopRatioAllFront.stream().filter((n) -> !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID()))  ).collect(Collectors.toList());
            int subordinateLoopRatioNum  = subordinateLoopRatio.size();
            //做转送
            List<Lettermanage> passLoopRatio = totalLoopRatio.stream().filter((n) -> n.getHandleModelID().equals("001003002") || n.getHandleModelID().equals("002003002") || n.getHandleModelID().equals("003003002")|| n.getHandleModelID().equals("004003002")|| n.getHandleModelID().equals("005003002") ).collect(Collectors.toList());
            int passLoopRatioNum  = passLoopRatio.size();

            //作引导劝息、存信存件
            List<Lettermanage> letterLoopRatio = totalLoopRatio.stream().filter((n) -> n.getHandleModelID().equals("002004") || n.getHandleModelID().equals("001004")).collect(Collectors.toList());
            int letterLoopRatioNum  = letterLoopRatio.size();

            //不属于人大信访受理范围
            List<Lettermanage> collectLoopRatioNot= letterManageLoopRatio.stream().filter((n) -> String.valueOf(n.getIsAccept()).equals("1")).collect(Collectors.toList());
            int NpcacceptLoopRatioNot = collectLoopRatioNot.size();

            //作交办处理的领导代表件   过滤领导 代表 事件
            List<Lettermanage> selectleadLoopRatioNot = collectLoopRatioNot.stream().filter((n) -> n.getXfSourceID().equals("001002001") || n.getXfSourceID().equals("001002002") || n.getXfSourceID().equals("001003")|| n.getXfSourceID().equals("002002001")|| n.getXfSourceID().equals("002002002") || n.getXfSourceID().equals("002003")|| n.getXfSourceID().equals("001004") || n.getXfSourceID().equals("002006")).collect(Collectors.toList());
            List<Lettermanage> leadchoiceleadLoopNot = selectleadLoopRatioNot.stream().filter((n) -> n.getHandleModelID().equals("001003001") || n.getHandleModelID().equals("002003001") || n.getHandleModelID().equals("003003001")|| n.getHandleModelID().equals("004003001")|| n.getHandleModelID().equals("005003001") ).collect(Collectors.toList());
            int leadchoiceLoopRatioNotNum  = leadchoiceleadLoopNot.size();

            //做转送
            List<Lettermanage> passNotLoopRatio = collectLoopRatioNot.stream().filter((n) -> n.getHandleModelID().equals("001003002") || n.getHandleModelID().equals("002003002") || n.getHandleModelID().equals("003003002")|| n.getHandleModelID().equals("004003002")|| n.getHandleModelID().equals("005003002") ).collect(Collectors.toList());
            int passNotLoopRatioNum  = passNotLoopRatio.size();

            //作引导劝息、存信存件
            List<Lettermanage> letterLoopRatioNot = collectLoopRatioNot.stream().filter((n) -> n.getHandleModelID().equals("002004") || n.getHandleModelID().equals("001004")).collect(Collectors.toList());
            int letterLoopRatioNotNum  = letterLoopRatioNot.size();

            //  转行政机 administrative
            List<Lettermanage> administrativeLoopRatioNot = collectLoopRatioNot.stream().filter((n) -> !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) && String.valueOf(n.getIsRenDa()).equals("0")).collect(Collectors.toList());
            int administrativeLoopRatioNotNum  = administrativeLoopRatioNot.size();

            //  转审判机关
            List<Lettermanage> judgeLoopRatioNot = collectLoopRatioNot.stream().filter((n) -> !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) && String.valueOf(n.getIsRenDa()).equals("2")).collect(Collectors.toList());
            int judgeLoopRatioNotNum  = judgeLoopRatioNot.size();

            //转检察机关
            List<Lettermanage> examineLoopRatioNot = collectLoopRatioNot.stream().filter((n) -> !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) && String.valueOf(n.getIsRenDa()).equals("3")).collect(Collectors.toList());
            int examineLoopRatioNotNum  = examineLoopRatioNot.size();

            //        转纪检监察
            List<Lettermanage> disciplineLoopRatioNot = collectLoopRatioNot.stream().filter((n) -> !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) && String.valueOf(n.getIsRenDa()).equals("4")).collect(Collectors.toList());
            int disciplineLoopRatioNotNum  = disciplineLoopRatioNot.size();

            //转常委会办事机构
            List<Lettermanage> committeeLoopRatioNot = collectLoopRatioNot.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("1") && String.valueOf(n.getAgent()).equals("0")  ).collect(Collectors.toList());
            int committeeLoopRatioNotNum  = committeeLoopRatioNot.size();

            //转下一级人大常委会 (属于人大常委)
            List<Lettermanage> subordinateAllLoopRatioNot = collectLoopRatioNot.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("1") && String.valueOf(n.getAgent()).equals("1")  ).collect(Collectors.toList());
            // 属于转交给下级
            List<Lettermanage> subordinateLoopRatioNot = subordinateAllLoopRatioNot.stream().filter((n) -> !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID()))  ).collect(Collectors.toList());
            int subordinateLoopRatioNotNum  = subordinateLoopRatioNot.size();
        // 同比开始年份与结束年份

                lettermanage.setStartTime(currYearTBTime);
                lettermanage.setEndTime(lastYearTBTime);
                // 同比 上一年 受理范围 总量
                List<Lettermanage> letterManageFrontYear = lettermanageMapper.LetterList(lettermanage);
                //属于人大信访受理范围
                List<Lettermanage> totalFront1= letterManageFrontYear.stream().filter((n) -> String.valueOf(n.getIsAccept()).equals("0")).collect(Collectors.toList());
                int NpcacceptFront = totalFront1.size();
                //受理XXXXX件
                List<Lettermanage> totalFront2= totalFront1.stream().filter((n) -> String.valueOf(n.getIsAcceptPerson()).equals("0")).collect(Collectors.toList());
                int acceptFront = totalFront2.size();
                //不给予受理XXXXX件
                List<Lettermanage> collectFront3= totalFront1.stream().filter((n) -> String.valueOf(n.getIsAcceptPerson()).equals("1")).collect(Collectors.toList());
                int acceptFrontNot = collectFront3.size();
                //做交办
                List<Lettermanage> assignFront = totalFront1.stream().filter((n) -> n.getHandleModelID().equals("001003001") || n.getHandleModelID().equals("002003001") || n.getHandleModelID().equals("003003001")|| n.getHandleModelID().equals("004003001")|| n.getHandleModelID().equals("005003001") ).collect(Collectors.toList());
                int assignNumFront  = assignFront.size();
                //转常委会办事机构XXXX件
                List<Lettermanage> committeeFront = totalFront1.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("1") && String.valueOf(n.getAgent()).equals("0")  ).collect(Collectors.toList());
                int committeeFrontNum  = committeeFront.size();
                //属于转交人大的
                List<Lettermanage> subordinateAllFront = totalFront1.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("1") && String.valueOf(n.getAgent()).equals("1")  ).collect(Collectors.toList());
               // 属于转交给下级
                List<Lettermanage> subordinateFront = subordinateAllFront.stream().filter((n) -> !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID()))  ).collect(Collectors.toList());
                int subordinateFrontNum  = subordinateFront.size();
                //做转送
                List<Lettermanage> passFront = totalFront1.stream().filter((n) -> n.getHandleModelID().equals("001003002") || n.getHandleModelID().equals("002003002") || n.getHandleModelID().equals("003003002")|| n.getHandleModelID().equals("004003002")|| n.getHandleModelID().equals("005003002") ).collect(Collectors.toList());
                int passNumFront  = passFront.size();

            //作引导劝息、存信存件
                List<Lettermanage> letterFront = totalFront1.stream().filter((n) -> n.getHandleModelID().equals("002004") || n.getHandleModelID().equals("001004")).collect(Collectors.toList());
                int letterFrontNum  = letterFront.size();

                //不属于人大信访受理范围
                List<Lettermanage> collectFrontNot= letterManageFrontYear.stream().filter((n) -> String.valueOf(n.getIsAccept()).equals("1")).collect(Collectors.toList());
               int NpcacceptFrontNot = collectFrontNot.size();

            //作交办处理的领导代表件   过滤领导 代表 事件
            List<Lettermanage> selectleadFrontNot = collectFrontNot.stream().filter((n) -> n.getXfSourceID().equals("001002001") || n.getXfSourceID().equals("001002002") || n.getXfSourceID().equals("001003")|| n.getXfSourceID().equals("002002001")|| n.getXfSourceID().equals("002002002") || n.getXfSourceID().equals("002003")|| n.getXfSourceID().equals("001004") || n.getXfSourceID().equals("002006")).collect(Collectors.toList());
            List<Lettermanage> leadchoiceFrontNot = selectleadFrontNot.stream().filter((n) -> n.getHandleModelID().equals("001003001") || n.getHandleModelID().equals("002003001") || n.getHandleModelID().equals("003003001")|| n.getHandleModelID().equals("004003001")|| n.getHandleModelID().equals("005003001") ).collect(Collectors.toList());
            int leadchoiceFrontNotNum  = leadchoiceFrontNot.size();

            //做转送
                List<Lettermanage> passNotFront = collectFrontNot.stream().filter((n) -> n.getHandleModelID().equals("001003002") || n.getHandleModelID().equals("002003002") || n.getHandleModelID().equals("003003002")|| n.getHandleModelID().equals("004003002")|| n.getHandleModelID().equals("005003002") ).collect(Collectors.toList());
                int passNotFrontNum  = passNotFront.size();

                //作引导劝息、存信存件
                List<Lettermanage> letterFrontNot = collectFrontNot.stream().filter((n) -> n.getHandleModelID().equals("002004") || n.getHandleModelID().equals("001004")).collect(Collectors.toList());
                int letterFrontNotNum  = letterFrontNot.size();


                //  转行政机 administrative
                List<Lettermanage> administrativeFrontNot = collectFrontNot.stream().filter((n) -> !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) && String.valueOf(n.getIsRenDa()).equals("0")).collect(Collectors.toList());
                int administrativeFrontNotNotNum  = administrativeFrontNot.size();

                //  转审判机关
                List<Lettermanage> judgeFrontNot = collectFrontNot.stream().filter((n) -> !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) && String.valueOf(n.getIsRenDa()).equals("2")).collect(Collectors.toList());
                int judgeFrontNotNum  = judgeFrontNot.size();

                //转检察机关
                List<Lettermanage> examineFrontNot = collectFrontNot.stream().filter((n) ->!String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) && String.valueOf(n.getIsRenDa()).equals("3")).collect(Collectors.toList());
                int examineFrontNotNum  = examineFrontNot.size();

                //        转纪检监察
                List<Lettermanage> disciplineFrontNot = collectFrontNot.stream().filter((n) -> !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID())) && String.valueOf(n.getIsRenDa()).equals("4")).collect(Collectors.toList());
                int disciplineFrontNotNum  = disciplineFrontNot.size();

                //转下一级人大常委会 (属于人大常委)
                List<Lettermanage> subordinateAllFrontNot = collectFrontNot.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("1") && String.valueOf(n.getAgent()).equals("1")  ).collect(Collectors.toList());
                // 属于转交给下级
                List<Lettermanage> subordinateFrontNot = subordinateAllFrontNot.stream().filter((n) -> !String.valueOf(n.getCreateOrgID()).equals(String.valueOf(n.getFinalDisposalID()))  ).collect(Collectors.toList());
                int subordinateFrontNotNum  = subordinateFrontNot.size();

                //转常委会办事机构
                List<Lettermanage> committeeFrontNot = collectFrontNot.stream().filter((n) -> String.valueOf(n.getIsRenDa()).equals("1") && String.valueOf(n.getAgent()).equals("0")  ).collect(Collectors.toList());
                int committeeFrontNotNum  = committeeFrontNot.size();


            String content;
                content ="&nbsp;"+ "&nbsp;"+"&nbsp;"+ "&nbsp;"+DateTimeUtils.getYear(firstYearTime)+"年"+DateTimeUtils.getMonth(firstYearTime)+"月"+DateTimeUtils.getDay(firstYearTime)+"日至"+DateTimeUtils.getYear(endYearTime)+"年"+DateTimeUtils.getMonth(endYearTime)+"月"+DateTimeUtils.getDay(endYearTime)+"日,"+"当前登记单位及所辖单位人大信访处理情况分析"+
                        "处理的"+total+"件信访事项，属于人大信访受理范围内的"+Npcaccept+"件,占总量"+ CalculateUtils.makeUp(Npcaccept,total)+
                        "%,环比"+ CalculateUtils.IncreaseDecreaseMakeUp(Npcaccept,NpcacceptLoopRatio)+
                        "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(Npcaccept,NpcacceptFront)+
                        "%；不属于人大信访受理范围的"+NpcacceptNot+"件，占总量"+CalculateUtils.makeUp(NpcacceptNot,total)+
                        "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(NpcacceptNot,NpcacceptLoopRatioNot)+
                        "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(NpcacceptNot,NpcacceptFrontNot)+"%。"+ System.getProperty("line.separator")+  //换行
                        "&nbsp;"+ "&nbsp;"+"&nbsp;"+ "&nbsp;"+"⑴属于人大信访受理范围内的"+Npcaccept+ "件信访事项中:"+System.getProperty("line.separator")+  // 第二段
                        "&nbsp;"+ "&nbsp;"+"&nbsp;"+ "&nbsp;"+"①受理"+accept+"件，占受理范围内件"+CalculateUtils.makeUp(accept,Npcaccept)+
                        "%,环比"+CalculateUtils.IncreaseDecreaseMakeUp(accept,acceptLoopRatioNum)+
                        "%,同比"+ CalculateUtils.IncreaseDecreaseMakeUp(accept,acceptFront)+
                        "%,不予受理"+acceptNot+"件,占受理范围内件"+CalculateUtils.makeUp(acceptNot,Npcaccept)+
                        "%,环比"+CalculateUtils.IncreaseDecreaseMakeUp(acceptNot,acceptLoopRatioNotNum)+
                        "%,同比"+CalculateUtils.IncreaseDecreaseMakeUp(acceptNot,acceptFrontNot)+"%。"+System.getProperty("line.separator")+
                        "&nbsp;"+ "&nbsp;"+"&nbsp;"+ "&nbsp;"+"②作交办处理的"+assignNum+"件,占受理范围内件"+CalculateUtils.makeUp(assignNum,Npcaccept)+
                        "%,环比"+CalculateUtils.IncreaseDecreaseMakeUp(assignNum,assignLoopRatioNum)+
                        "%,同比"+CalculateUtils.IncreaseDecreaseMakeUp(assignNum,assignNumFront)+
                        "%;作转送处理的"+passNum+"件，占受理范围内件"+CalculateUtils.makeUp(passNum,Npcaccept)+
                        "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(passNum,passLoopRatioNum)+
                        "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(passNum,passNumFront)+
                        "%;作引导劝息、存信存件"+letterNum+"件，占受理范围内件"+CalculateUtils.makeUp(letterNum,Npcaccept)+
                        "%,环比"+CalculateUtils.IncreaseDecreaseMakeUp(letterNum,letterLoopRatioNum)+
                        "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(letterNum,letterFrontNum)+"%。" +
                        "其中:转常委会办事机构"+committeeNum+"件，占受理范围内件"+CalculateUtils.makeUp(committeeNum,Npcaccept)+
                        "%,环比"+CalculateUtils.IncreaseDecreaseMakeUp(committeeNum,committeeLoopRatioNum)+
                        "%,同比"+CalculateUtils.IncreaseDecreaseMakeUp(committeeNum,committeeFrontNum)+
                        "%;转下一级常委会"+subordinateNum+"件，占受理范围内件"+CalculateUtils.makeUp(subordinateNum,Npcaccept) +
                        "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(subordinateNum,subordinateLoopRatioNum)+
                        "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(subordinateNum,subordinateFrontNum)+"%。"+ System.getProperty("line.separator")+
                        "&nbsp;"+ "&nbsp;"+  "&nbsp;"+ "&nbsp;"+"⑵不属于人大信访受理范围的"+NpcacceptNot+"件信访事项中："+System.getProperty("line.separator")+
                        "&nbsp;"+ "&nbsp;"+  "&nbsp;"+ "&nbsp;"+"作交办处理的领导代表件及其它重点信访问题"+leadchoiceNotNum+"件，占受理范围外件"+CalculateUtils.makeUp(leadchoiceNotNum,NpcacceptNot)+
                        "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(leadchoiceNotNum,leadchoiceLoopRatioNotNum)+
                        "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(leadchoiceNotNum,leadchoiceFrontNotNum)+"%；" +
                        "%；作转送处理的"+passNotNum+"件，占受理范围外件"+CalculateUtils.makeUp(passNotNum,NpcacceptNot)+
                        "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(passNotNum,passNotLoopRatioNum)+
                        "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(passNotNum,passNotFrontNum)+
                        "%；作引导劝息、存信存件"+letterNotNum+"件，占受理范围外件"+CalculateUtils.makeUp(letterNotNum,NpcacceptNot)+
                        "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(letterNotNum,letterLoopRatioNotNum)+
                        "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(letterNotNum,letterFrontNotNum)+"%。其中："+System.getProperty("line.separator")+
                        "&nbsp;"+ "&nbsp;"+ "&nbsp;"+ "&nbsp;"+"①转行政机关"+administrativeNotNum+"件，占受理范围外件"+CalculateUtils.makeUp(administrativeNotNum,NpcacceptNot)+
                        "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(administrativeNotNum,administrativeLoopRatioNotNum)+
                         "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(administrativeNotNum,administrativeFrontNotNotNum)+"%"+ System.getProperty("line.separator")+
                        "&nbsp;"+ "&nbsp;"+   "&nbsp;"+ "&nbsp;"+"②转审判机关"+judgeNotNum+"件，占受理范围外件"+CalculateUtils.makeUp(judgeNotNum,NpcacceptNot)+
                        "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(judgeNotNum,judgeLoopRatioNotNum)+
                         "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(judgeNotNum,judgeFrontNotNum)+"%"+ System.getProperty("line.separator")+
                        "&nbsp;"+ "&nbsp;"+"&nbsp;"+ "&nbsp;"+"③转检察机关"+examineNotNum+"件，占受理范围外件"+CalculateUtils.makeUp(examineNotNum,NpcacceptNot)+
                        "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(examineNotNum,examineLoopRatioNotNum)+
                         "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(examineNotNum,examineFrontNotNum)+"%"+ System.getProperty("line.separator")+
                        "&nbsp;"+ "&nbsp;"+"&nbsp;"+ "&nbsp;"+"④转纪检监察机关"+disciplineNotNum+"件，占受理范围外件"+CalculateUtils.makeUp(disciplineNotNum,NpcacceptNot)+
                        "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(disciplineNotNum,disciplineLoopRatioNotNum)+
                        "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(disciplineNotNum,disciplineFrontNotNum)+"%"+ System.getProperty("line.separator")+
                        "&nbsp;"+ "&nbsp;"+"&nbsp;"+ "&nbsp;"+"⑤转下一级人大常委会向相关部门转交办"+subordinateNotNum+"件，占受理范围外件"+CalculateUtils.makeUp(subordinateNotNum,NpcacceptNot)+
                        "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(subordinateNotNum,subordinateLoopRatioNotNum)+
                        "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(subordinateNotNum,subordinateFrontNotNum)+"%"+ System.getProperty("line.separator")+
                        "&nbsp;"+ "&nbsp;"+"&nbsp;"+ "&nbsp;"+"⑥转常委会办事机构协调相关部门处理"+committeeNotNum+"件，占受理范围外件"+CalculateUtils.makeUp(committeeNotNum,NpcacceptNot)+
                                "%，环比"+CalculateUtils.IncreaseDecreaseMakeUp(committeeNotNum,committeeLoopRatioNotNum)+
                                "%、同比"+CalculateUtils.IncreaseDecreaseMakeUp(committeeNotNum,committeeFrontNotNum)+"%";


        map.put("content",content);
        List<Map<String,Object>> department = new ArrayList<>();
        HashMap<String, Object> map1 = new HashMap<>();
        HashMap<String, Object> map2 = new HashMap<>();
        HashMap<String, Object> map3 = new HashMap<>();
        HashMap<String, Object> map4 = new HashMap<>();
        HashMap<String, Object> map5 = new HashMap<>();
        HashMap<String, Object> map6 = new HashMap<>();
        HashMap<String, Object> map7 = new HashMap<>();
        map1.put("name","转行政机关");
        map1.put("count",administrativeNotNum);
        map2.put("name","转常委会办事机构");
        map2.put("count",committeeNotNum);
        map3.put("name","转审判机关");
        map3.put("count",judgeNotNum);
        map4.put("name","转检监机关");
        map4.put("count",examineNotNum);
        map5.put("name","转纪检监察机关");
        map5.put("count",disciplineNotNum);
        map6.put("name","下级人大");
        map6.put("count",subordinateNotNum);
        map7.put("name","自办、接谈、存信");
        map7.put("count",selfNum);
        department.add(map1);
        department.add(map2);
        department.add(map3);
        department.add(map4);
        department.add(map5);
        department.add(map6);
        department.add(map7);
        map.put("department",department);
        List<Map<String,Object>> acceptRatio = new ArrayList<>();
        HashMap<String, Object> map8 = new HashMap<>();
        HashMap<String, Object> map9 = new HashMap<>();
        map8.put("name","受理范围内");
        map8.put("number",Npcaccept);
        map8.put("Ratio",CalculateUtils.makeUp(Npcaccept,total)+"%");
        map9.put("name","受理范围外");
        map9.put("number",NpcacceptNot);
        map9.put("Ratio",CalculateUtils.makeUp(NpcacceptNot,total)+"%");
        acceptRatio.add(map8);
        acceptRatio.add(map9);
        map.put("Ratio",acceptRatio);

        Result objectResult = new Result<>();
        objectResult.setData(map);
        return objectResult;
    }
}
