package com.dlsm.utils;

import com.dlsm.model.Matter;
import com.dlsm.model.export.ActivityDTO;
import com.dlsm.model.vo.MatterVO;
import com.sun.codemodel.internal.JDocComment;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * Created with IntelliJ IDEA.
 *
 * @Author: dzy
 * @Date: 2022/04/18/15:19
 * @Description:
 */
public class AhrdUitls {

    /**
     * 获取占比
     * @param x
     * @param total
     * @return
     */
    public static String getZb(int x, int total) {
        if (total == 0 && x == 0) {
            return "0.00%";
        } else if (total == 0) {
            return "100.00%";
        }
        double f = (Double.valueOf(x) / Double.valueOf(total)) * 100;
        BigDecimal bg = new BigDecimal(f);
        double f1 = bg.setScale(2, BigDecimal.ROUND_HALF_UP).doubleValue();
        return (f1 + "%");
    }

    /**
     * 根据百分比获取同比
     * @param x
     * @param total
     * @return
     */
    public static String getPercentTb(String x, String total) {
        double a = Double.valueOf(x.substring(0,x.indexOf("%")-1));
        double b = Double.valueOf(total.substring(0,total.indexOf("%")-1));

        if (a == 0 && b == 0) {
            return "0.00%";
        } else if (b == 0) {
            return "100.00%";
        }
        double f = (a - b) / b * 100;
        BigDecimal bg = new BigDecimal(f);

        double f1 = bg.setScale(2, BigDecimal.ROUND_HALF_UP).doubleValue();
        return (f1 + "%");
    }

        /**
         * 获取同比数值
         * @param x
         * @param total
         * @return
         */
    public static String getPercent(int x, int total) {
        if (total == 0 && x == 0) {
            return "0.00%";
        } else if (total == 0) {
            return "100.00%";
        }
        double f = (Double.valueOf(x) - Double.valueOf(total)) / Double.valueOf(total) * 100;
        //double f = x*100/ total;
        BigDecimal bg = new BigDecimal(f);
        double f1 = bg.setScale(2, BigDecimal.ROUND_HALF_UP).doubleValue();
        return (f1 + "%");
    }


    /**
     * @param type  是否受理范围0受理，1不受理
     * @return
     */
    public static int getMatterIsAccept(List<MatterVO> list , Integer type){
       return  (int) list.stream().filter(p -> type.equals(p.getIsAccept())).count();
    }

    /**
     *
     * @param type     办理方式
     * @param overdue  是否逾期
     * @param partType 上级单位类别
     * @return
     */
    public static int getMatterHandleModel(List<MatterVO> list , String type ,Boolean overdue, String partType){
        if(overdue != null){
            if(overdue){
                return  (int) list.stream().filter(p -> type.equals(p.getHandleModel()) && p.getXcDay() > 60).count();
            }else {
                return  (int) list.stream().filter(p -> type.equals(p.getHandleModel()) && p.getXcDay() <= 60).count();
            }
        }
        if (StringUtils.isNotEmpty(type)){
            if(StringUtils.isEmpty(partType)){
                return  (int) list.stream().filter(p -> type.equals(p.getHandleModel())).count();
            }else {
                return  (int) list.stream().filter(p -> type.equals(p.getHandleModel()) && partType.equals(p.getType())).count();
            }
        }else {
            if(StringUtils.isEmpty(partType)){
                return  (int) list.stream().filter(p -> "交办".equals(p.getHandleModel()) || "转送".equals(p.getHandleModel())).count();
            }else {
                return  (int) list.stream().filter(p -> "交办".equals(p.getHandleModel()) || "转送".equals(p.getHandleModel())).filter(p-> partType.equals(p.getType())).count();
            }
        }
    }

    public static List<MatterVO> getIsAnswer(List<MatterVO> list){
        return list.stream().filter( p -> p.getIsAnswer() == 1 ).collect(Collectors.toList());
    }


    /**
     * 获取序号
     * @param list
     * @param merge
     */
    public static void setNumber(List<ActivityDTO> list,List<String> merge){
        Integer a = 1;
        for (int i = 0; i < list.size(); i++) {
            if(i > 0 ){
                if(!(list.get(i).getId()).equals(list.get(i-1).getId()) || merge==null || merge.isEmpty()){
                    a++;
                }
                list.get(i).setNumber(a.toString());
            }else {
                list.get(i).setNumber(a.toString());
            }
        }
    }

    public static int getChunAnSum(List<MatterVO> aList) {
        List<MatterVO> list = new ArrayList<>();
        List<MatterVO> collect = aList.stream().filter(p -> StringUtils.isNotEmpty(p.getMatterB()) && StringUtils.isNotEmpty(p.getMatterA())).collect(Collectors.toList());

        for (MatterVO matterVO : collect) {
            int a = 0;
            for (MatterVO vo : aList) {
               if( matterVO.getMatterB().equals(vo.getId()) || matterVO.getMatterA().equals(vo.getId())){
                   a++;
               }
            }
            if(a == 2){
                list.add(matterVO);
            }
        }
        int  b = list.size();
        int  a = 0;
        for (MatterVO matterVO : list) {
            for (MatterVO vo : list) {
                if(matterVO.getMatterB().equals(vo.getMatterA()) && matterVO.getMatterA().equals(vo.getMatterB())){
                    a++;
                }
            }
        }
        return b-(a/2);
    }
}
