package com.dlsm;

import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.ExcelWriter;
import com.alibaba.excel.write.handler.WriteHandler;
import com.alibaba.excel.write.metadata.WriteSheet;
import com.alibaba.excel.write.metadata.WriteWorkbook;
import com.alibaba.excel.write.style.HorizontalCellStyleStrategy;
import com.dlsm.model.export.ActivityDTO;
import com.dlsm.model.export.XfzbDTO;
import com.dlsm.model.vo.ActivityVO;
import com.dlsm.service.ActivityService;
import com.dlsm.utils.*;
import com.dlsm.utils.excel.ExcelFillCellMergeStrategy;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.core.io.ClassPathResource;
import org.springframework.test.context.junit4.SpringRunner;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.Field;
import java.text.ParseException;
import java.util.*;
import java.util.stream.Collectors;

@RunWith(SpringRunner.class)
@SpringBootTest
public class SpringbootsApplicationTests {

	@Autowired
	private ActivityService activityService;
	@Test
	public void contextLoads() {
		LinkedList<ActivityDTO> activityDTOS = activityService.selectByActivityDtoToExport(new ActivityVO());
		 Integer a = 1;
		for (int i = 0; i < activityDTOS.size(); i++) {
			if(i > 0 ){
				if(!(activityDTOS.get(i).getId()).equals(activityDTOS.get(i-1).getId())){
					a++;
				}
				activityDTOS.get(i).setNumber(a.toString());
			}else {
				activityDTOS.get(i).setNumber(a.toString());
			}
		}
		Map<String, List<ActivityDTO>> collect = activityDTOS.stream().sorted(Comparator.comparing(ActivityDTO::getCreateTime)).collect(Collectors.groupingBy(ActivityDTO::getId));

		System.out.println(activityDTOS);
		//ExcelUtil.excludeOrIncludeWrite(null,null,ActivityDTO.class,null,null);
	}
	@Test
	public void selectByActivityDtoToExportTest(){
		LinkedList<ActivityDTO> activityDTOS = activityService.selectByActivityDtoToExport(new ActivityVO());
		System.out.println(activityDTOS);
	}

	@Test
	public void excelUtilTest() throws ParseException {
		{
			ActivityVO activityVO = new ActivityVO();
			activityVO.setStartTime("2022-01-01");
			activityVO.setEndTime("2022-12-30");
			activityVO.setOrgStartTime("2021-01-01");
			activityVO.setOrgStartTime("2021-12-30");
			activityVO.setCreateOrgID("40");
			List<XfzbDTO> list = activityService.excludeExcelXfzb(activityVO);
			String fileName = TestFileUtil.getPath() + "excludeOrIncludeWrite" + System.currentTimeMillis() + ".xlsx";
			//样式设置
			HorizontalCellStyleStrategy horizontalCellStyleStrategy = ExcelUtil.getExcelStyle();
			//需要被合并的列
			List<Integer> mergeColumnIndex = new ArrayList<>();
			InputStream inputStream = null;
			try {
				inputStream = new ClassPathResource("/static/temp/excel/test.xlsx").getInputStream();
			} catch (IOException e) {
				e.printStackTrace();
			}
			for (int i = 0; i < 4; i++) {
				mergeColumnIndex.add(i);
			}
			// 导出项：includeColumnFiledNames
			//Set<String> includeColumnFiledNames = new HashSet<String>();
			//includeColumnFiledNames.add("number");
			// 排除项excludeColumnFiledNames
			Set<String> excludeColumnFiledNames = new HashSet<String>();
			excludeColumnFiledNames.add("id");
			ExcelWriter excelWriter = null;
			try {
				WriteWorkbook writeWorkbook = new WriteWorkbook();
				writeWorkbook.setFile(new File(fileName));
				/**  */
				writeWorkbook.setClazz(XfzbDTO.class);
				writeWorkbook.setTemplateInputStream(inputStream);
				// writeWorkbook.setHead(head(ratingYear+"年"+material.getDeptName()+"评价总体情况分析表"));
				//导出项字段
				//writeWorkbook.setIncludeColumnFieldNames(includeColumnFiledNames);
				//排除项
				 //writeWorkbook.setExcludeColumnFieldNames(excludeColumnFiledNames);
				//是否自动关闭输入流
				writeWorkbook.setAutoCloseStream(Boolean.TRUE);
				//自定义拦截器，设置头部样式
				List<WriteHandler> customWriteHandlerList = new ArrayList<>();
				customWriteHandlerList.add(horizontalCellStyleStrategy);
				customWriteHandlerList.add(new ExcelFillCellMergeStrategy(1, mergeColumnIndex));
				writeWorkbook.setCustomWriteHandlerList(customWriteHandlerList);
				excelWriter = new ExcelWriter(writeWorkbook);
				WriteSheet writeSheet = new WriteSheet();
				writeSheet.setSheetName("sheet1");
				excelWriter.write(list, writeSheet);
			} finally {
				// 千万别忘记finish 会帮忙关闭流
				if (excelWriter != null) {
					excelWriter.finish();
				}
			}
		}
	}
	@Test
	public void DateTimeTest(){
		Date startHBTime = DateTimeUtils.getCurrYearFirst();
		System.out.println(DateTimeUtils.getYYYYMMDD(startHBTime));
		System.out.println(DateTimeUtils.getOrgStartTime());
		try {
			System.out.println(DateTimeUtils.getOrgEndTime());
		} catch (ParseException e) {
			e.printStackTrace();
		}
	}
	//信访指标导出
	@Test
	public void excludeExcelTest(){
		Field[] declaredField = XfzbDTO.class.getDeclaredFields();
		Double d = new Double("1.23");
		try {
			ActivityVO activityVO = new ActivityVO();
			activityVO.setStartTime("2022-01-01");
			activityVO.setEndTime("2022-12-30");
			activityVO.setOrgStartTime("2021-01-01");
			activityVO.setOrgStartTime("2021-12-30");
			activityVO.setCreateOrgID("40");
			List<XfzbDTO> xfzbDTOS = activityService.excludeExcelXfzb(activityVO);
			System.out.println(xfzbDTOS);
		} catch (ParseException e) {
			e.printStackTrace();
		}
	}

	//class获取 所有需要导出属性
	@Test
	public void TestClassFieLdUtils(){
		List field = ClassFieLdUtils.getField(XfzbDTO.class);
		System.out.println(field);
	}

	@Test
	public void TestexcludeTepm(){
		ActivityVO activityVO = new ActivityVO();
		activityVO.setCreateOrgID("40");
		List<Map> list = activityService.excludeExcelXfdj(activityVO,2);
		System.out.println(list);
	}

	@Test
	public void TestString(){
		double a1 = 2;
		double a2 = 2;
		double b1 = 2;
		double b2 = 2;


		double a = a1/a2;
		double b = b1/b2;
		double c = (a-b)/b;
		System.out.println(c);

		double d =(a1*b2 - b1*a2)/a2*b1;
		System.out.println(d);
	}
	@Test
	public void TestgetPercent2(){
		int a = 0;
		int b = 13;
		System.err.println(b - (a / 2));
	}

	@Test
	public void TestE(){
		ExcelWriter excelWriter = null;
		try {
			List<XfzbDTO> list =new ArrayList<>();
			list.add(new XfzbDTO("1","2","3","3"));
			list.add(new XfzbDTO("1","3","4","4"));
			String templateName = "test";
			InputStream inputStream = new ClassPathResource("/static/temp/excel/test.xlsx").getInputStream();
			String fileName = templateName + System.currentTimeMillis() + ".xlsx";
			String filePath = TestFileUtil.getPath() ;
			//excelWriter = EasyExcel.write(filePath + fileName,XfzbDTO.class).withTemplate(inputStream).build();

			EasyExcel.write(filePath + fileName, ActivityDTO.class).withTemplate(inputStream)
					.sheet("sheet1")
					.doWrite(list);
		} catch (Exception e) {
			e.printStackTrace();
		}finally {
			// 关闭流
			if (excelWriter != null) {
				excelWriter.finish();
			}
		}
	}


}
